/*******************************************************************************
 * The information contained in this file is confidential and proprietary to
 * Broadcom Corporation.  No part of this file may be reproduced or
 * distributed, in any form or by any means for any purpose, without the
 * express written permission of Broadcom Corporation.
 *
 * (c) COPYRIGHT 2001-2007 Broadcom Corporation, ALL RIGHTS RESERVED.
 *
 *
 * Module Description:
 *
 *
 * History:
 *    28/06/11 ShayH    Inception.
 ******************************************************************************/
#ifndef _LM_DCBX_MP_H
#define _LM_DCBX_MP_H

/*******************************************************************************
 * Constants.
 ******************************************************************************/
#define MAX_NUM_OF_ETH_CONS_PER_COS                 (MAX_RSS_CHAINS)
#define ETH_MP_MAX_COS_SUPPORTED                    (3)

/*******************************************************************************
 * Defines.
 ******************************************************************************/

#define MAX_ETH_TX_ONLY_CONS                        ((ETH_MP_MAX_COS_SUPPORTED - 1)*(MAX_NUM_OF_ETH_CONS_PER_COS))
#define MAX_ETH_TX_ONLY_CHAINS                      ((ETH_MP_MAX_COS_SUPPORTED - 1)*(MAX_HW_CHAINS))


typedef enum
{
    lm_chain_type_cos_reg       = 0,
    lm_chain_type_cos_tx_only   = 1,
    lm_chain_type_not_cos       = 2
}lm_chain_type_t;

/**
 * @description
 * Get COS number based on chain. 
 * If the chain doesn't belong to a specific COS (e.g. ISCSI L2 
 * chain) 
 * @param pdev 
 * @param chain 
 * 
 * @return u8_t 
 */
u8_t 
lm_mp_cos_from_chain(IN struct _lm_device_t *pdev, 
                     IN const u32_t         chain);

/**
 * @description
 * Get max cos chain used.
 * @param pdev 
 * @param chain 
 * @param cos 
 * 
 * @return u32_t 
 */
u8_t
lm_mp_max_cos_chain_used(
    IN struct _lm_device_t  *pdev);

#endif// _LM_DCBX_MP_H
