/*
 * The information contained in this file is confidential and proprietary to
 * Broadcom Corporation.  No part of this file may be reproduced or
 * distributed, in any form or by any means for any purpose, without the
 * express written permission of Broadcom Corporation.
 *
 * (c) COPYRIGHT 2010-2012 Broadcom Corporation, ALL RIGHTS RESERVED.
 */

#pragma ident "(C) 2010-2012 Broadcom Corporation"
#pragma ident " $File$$Revision$$Change$$DateTime$"

#include <sys/conf.h>
#include <sys/ddi.h>
#include <sys/stat.h>
#include <sys/pci.h>
#include <sys/sunddi.h>
#include <sys/modctl.h>
#include <sys/cmn_err.h>
#include <sys/file.h>
#include <sys/cred.h>
#include <sys/byteorder.h>
#include <sys/atomic.h>
#include <sys/scsi/scsi.h>
#include <sys/modhash.h>
#include <sys/sunldi.h>
#include <sys/kstat.h>
#include <sys/kmem.h>
#include <sys/ethernet.h>
#include <sys/stream.h>
#include <sys/sunldi.h>

/*
 * leadville header files
 */
#include <sys/fibre-channel/fc_types.h>
#include <sys/fibre-channel/impl/fc_fcaif.h>
#if !(defined(__S11) || defined(__S12))
#include <sys/fibre-channel/ulp/fcp.h>
#endif
#include <bnxe_binding.h>
#include <bnxef_tq_param.h>
#include <bnxef_fcf_info.h>
#include <bnxef_hsi.h>
#include <bnxef_fcoe_task.h>
#include <bnxef_fcoe_session.h>
#include <bnxef_state.h>
#include <bnxef_fip.h>
#include <bnxef_fcoe.h>
#include <bnxef_debug.h>
#include <57xx_fcoe_constants.h>
#include <bnxef_hsi.h>
#include <bnxef_trace_events.h>

/* Prototypes */
void bnxef_fp_cq_notification(bnxef_driver_state_t *dsp,
	struct fcoe_kcqe *kcqep);
void bnxef_session_cq_handler(void *sessionp);
void bnxef_ofld_completion(bnxef_driver_state_t *dsp, struct fcoe_kcqe *kcqep);
void bnxef_enable_connection_completion(bnxef_driver_state_t *dsp,
		struct fcoe_kcqe *kcqep);
void bnxef_fw_init_completion(bnxef_driver_state_t *dsp,
		struct fcoe_kcqe *kcqep);
void bnxef_fw_stat_completion(bnxef_driver_state_t *dsp,
		struct fcoe_kcqe *kcqep);
void bnxef_fw_destroy_completion(bnxef_driver_state_t *dsp,
	struct fcoe_kcqe *kcqep);
void bnxef_destroy_connection_completion(bnxef_driver_state_t *dsp,
	struct fcoe_kcqe *kcqep);
void bnxef_disable_connection_completion(bnxef_driver_state_t *dsp,
	struct fcoe_kcqe *kcqep);
void bnxef_process_fcoe_error(bnxef_driver_state_t *dsp,
	struct fcoe_kcqe *kcqep);
void bnxef_unsol_event_handler(bnxef_session_t *sessionp, uint16_t wqe);
void bnxef_cq_completion(void *taskp);
void bnxef_handle_scsi_cmd_completion(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp, uint8_t num_rq, uint8_t rx_state);
void bnxef_handle_els_mp_completion(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp, uint8_t num_rq, uint8_t rx_state);
void bnxef_handle_task_cleanup_completion(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp);
void bnxef_handle_tm_completion(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp);
void bnxef_handle_abts_completion(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp);
void bnxef_scsi_normal_completion(bnxef_session_t *sessionp,
		bnxef_fcoe_task_t *taskp, uint8_t num_rq);
void bnxef_scsi_recovery_completion(bnxef_session_t *sesssionp,
	bnxef_fcoe_task_t *taskp, int num_rq);
void bnxef_scsi_exch_cleanup_completion(bnxef_session_t *sessionp,
		bnxef_fcoe_task_t *taskp);
void
bnxef_handle_task_sequence_cleanup_completion(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp, uint8_t rx_state);
static void
bnxef_mp_adisc_ls_acc_rx_handler(bnxef_driver_state_t *dsp, fc_packet_t *pktp);
static void
bnxef_mp_adisc_ls_rjt_rx_handler(bnxef_driver_state_t *dsp, fc_packet_t *pktp);

static void
bnxef_mp_rls_ls_acc_rx_handler(bnxef_driver_state_t *dsp, fc_packet_t *pktp);
static void
bnxef_mp_rls_ls_rjt_rx_handler(bnxef_driver_state_t *dsp, fc_packet_t *pktp);

static void
bnxef_mp_prli_ls_acc_rx_handler(bnxef_driver_state_t *dsp, fc_packet_t *pktp);
static void
bnxef_mp_prli_ls_rjt_rx_handler(bnxef_driver_state_t *dsp, fc_packet_t *pktp);
void
bnxef_handle_els_exch_cleanup_completion(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp);
void
bnxef_handle_els_mp_abts_completion(bnxef_session_t *sessionp,
		bnxef_fcoe_task_t *taskp);
void
bnxef_handle_els_mp_completion_handler(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp, uint8_t num_rq, uint8_t rx_state);
int
bnxef_mp_logo_handler(bnxef_port_t *portp,
	bnxef_session_t *sessionp,
	bnxef_unsol_buf_t *unsolbufp,
	fc_unsol_buf_t *ubp,
	uint8_t type);
void bnxef_mp_logo_handler_tq(void *arg);
int
bnxef_mp_prlo_handler(bnxef_port_t *portp,
	bnxef_session_t *sessionp,
	bnxef_unsol_buf_t *unsolbufp,
	fc_unsol_buf_t *ubp,
	uint8_t type);
void bnxef_mp_prlo_handler_tq(void *arg);
int
bnxef_mp_rscn_handler(bnxef_port_t *portp,
	bnxef_session_t *sessionp,
	bnxef_unsol_buf_t *unsolbufp,
	fc_unsol_buf_t *ubp,
	uint8_t type);
void bnxef_mp_rscn_handler_tq(void *arg);




extern void  *bnxef_state;
extern uint8_t *bnxef_get_next_rqe(bnxef_session_t *sessionp,
	uint8_t num_items);
extern bnxef_unsol_buf_t *bnxef_find_unsol_buf(bnxef_port_t *portp,
	uchar_t type);
extern void bnxef_complete_pkt(fc_packet_t *pktp, uint8_t state,
		uint8_t action, uint32_t reason, uint32_t expln);
extern void bnxef_pkt_cmd_res_free(fc_packet_t *pktp, int stage);
extern void bnxef_pkt_resp_res_free(fc_packet_t *pktp,  int stage);
extern void bnxef_task_free(void *arg, bnxef_fcoe_task_t *taskp);
extern int bnxef_task_bd_table_free(fc_packet_t *pktp, uint32_t stage);
extern void bnxef_send_rrq(void *arg);
extern int bnxef_door_bell_bar_unmap(bnxef_driver_state_t *dsp,
		bnxef_session_t *sessionp);
extern int bnxef_door_bell_bar_map(bnxef_driver_state_t *dsp,
		bnxef_session_t *sessionp);
extern void bnxef_big_endian(void *bufp, int size);
extern int
bnxef_initiate_abts(bnxef_session_t *sessionp, bnxef_fcoe_task_t *taskp);
extern int bnxef_cleanup_task(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp);
extern bnxef_session_t *
bnxef_session_find_remote_port(bnxef_port_t *portp, int16_t vlan_id,
		uint32_t d_id, uint8_t *macaddr);
extern void
bnxef_send_ls_rjt(bnxef_port_t *portp, bnxef_session_t *sessionp,
	bnxef_unsol_buf_t *unsolbufp, uint8_t reason, uint8_t expln);
extern void bnxef_arm_cq(bnxef_session_t *sessionp, uint16_t cq_idx);
extern void bnxef_return_rqe(bnxef_session_t *sessionp, uint8_t num_items);
extern void bnxef_send_rec(void *arg);

extern void bnxef_mp_rec_ls_rjt_rx_handler(bnxef_driver_state_t *dsp,
		fc_packet_t *pktp);
extern void bnxef_mp_srr_ls_rjt_rx_handler(bnxef_driver_state_t *dsp,
		fc_packet_t *pktp);
extern void bnxef_mp_rec_ls_acc_rx_handler(bnxef_driver_state_t *dsp,
		fc_packet_t *pktp);
extern void bnxef_mp_srr_ls_acc_rx_handler(bnxef_driver_state_t *dsp,
		fc_packet_t *pktp);
extern void bnxef_send_srr(void *arg);
extern fc_packet_t *
bnxef_prep_ls_rjt_with_fhdr(bnxef_driver_state_t *dsp, fc_frame_hdr_t *fcp);
extern int
bnxef_pkt_cmd_res_alloc(bnxef_tq_params_t *tqp, fc_packet_t *pktp);
extern void
bnxef_build_ls_rjt_cmd(la_els_rjt_t *rjt, fc_packet_t *pktp, uint8_t reason,
		uint8_t expln);

extern void
bnxef_els_tx_ofld_session_noresp(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp, uint32_t flags);
extern int
bnxef_implicit_logout_handler(bnxef_port_t *portp, bnxef_session_t *sessionp);
extern int bnxef_session_cleanup(bnxef_session_t *sessionp);

extern int
bnxef_ub_release(opaque_t fca_handle, uint32_t count, uint64_t tokens[]);

extern int
bnxef_els_tx_nonofld_session_noresp(bnxef_port_t *portp,
	bnxef_session_t *sessionp, fc_packet_t *pktp, int flags);













/*
 * This routine handles all the completion events that come from L2.
 */
boolean_t
bnxef_l2_cqe_rx(dev_info_t  *dip, void *cqes[], int cqe_cnt)
{

	bnxef_driver_state_t *dsp;
	int instance;
	struct fcoe_kcqe *kcqe = NULL;
	int i;

	ASSERT(dip != NULL);
	ASSERT(cqe_cnt > 0);
	ASSERT(cqes != NULL);



	instance = ddi_get_instance(dip);
	dsp = ddi_get_soft_state(bnxef_state, instance);
	if (dsp == NULL) {
		cmn_err(CE_PANIC, "%s%d:Unable to get driver state\n"
			BNXEF_DRIVER_NAME, instance);
		return (BNXEF_FAILURE);
	}
	BNXEF_DEBUG(dsp, SCSI, -1, " %s%d: Received Completion",
		BNXEF_DRIVER_NAME, dsp->instance);
#if 0
	{

		dev_info_t *pdip;

		pdip = ddi_get_parent(dsp->dip);
		if (!dsp->callbacks.prvCtl(pdip, PRV_CTL_ENABLE_INTR,
			(void *)&dsp->bnxe_params, sizeof (BnxeFcoeInfo))) {
		//	cmn_err(CE_WARN,
		//  "%s%d: Unable to get the Params from Bnxe",
		//		BNXEF_DRIVER_NAME, dsp->instance);
		}
	}
#endif


	for (i = 0; i < cqe_cnt; i++) {
		kcqe = (struct fcoe_kcqe *)cqes[i];
		BNXEF_DEBUG(dsp, SCSI, -1,
			"%s%d: Kcqe opcode received 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, kcqe->op_code);
		switch (kcqe->op_code) {
		case FCOE_KCQE_OPCODE_CQ_EVENT_NOTIFICATION:
			BNXEF_STATS(dsp, fp_completion_rx);
			bnxef_fp_cq_notification(dsp, kcqe);
			break;
		case FCOE_KCQE_OPCODE_OFFLOAD_CONN:
			BNXEF_STATS(dsp, ofld_comp_cqe_rx);
			bnxef_ofld_completion(dsp, kcqe);
			break;
		case FCOE_KCQE_OPCODE_ENABLE_CONN:
			BNXEF_STATS(dsp, enable_comp_cqe_rx);
			bnxef_enable_connection_completion(dsp, kcqe);
			break;
		case FCOE_KCQE_OPCODE_INIT_FUNC:
			BNXEF_STATS(dsp, init_comp_cqe_rx);
			bnxef_fw_init_completion(dsp, kcqe);
			break;
		case FCOE_KCQE_OPCODE_STAT_FUNC:
			bnxef_fw_stat_completion(dsp, kcqe);
			break;
		case FCOE_KCQE_OPCODE_DESTROY_FUNC:
			bnxef_fw_destroy_completion(dsp, kcqe);
			break;
		case FCOE_KCQE_OPCODE_DISABLE_CONN:
			bnxef_disable_connection_completion(dsp, kcqe);
			break;
		case FCOE_KCQE_OPCODE_DESTROY_CONN:
			bnxef_destroy_connection_completion(dsp, kcqe);
			break;
		case FCOE_KCQE_OPCODE_FCOE_ERROR:
			bnxef_process_fcoe_error(dsp, kcqe);
			break;
		default:
			cmn_err(CE_WARN,
			"%s%d: Unknown CQE CQE opcode 0x%x 0x%p\n",
				BNXEF_DRIVER_NAME, dsp->instance,
				kcqe->op_code, kcqe);
			debug_enter("Unknown KCQE");
		}
	}
	return (B_TRUE);
}

/*
 * This handles the fast pathc completion notification. The driver is
 * responsible for identifying the session and look into the session specific
 * CQ to identify what types of completion it is.
 */
void
bnxef_fp_cq_notification(bnxef_driver_state_t *dsp, struct fcoe_kcqe *kcqep)
{
	bnxef_session_t *sessionp;
	uint16_t	conn_id;
#if 0
	int ret;
#endif

#if 0
	{
		dev_info_t *pdip;

		pdip = ddi_get_parent(dsp->dip);
		if (!dsp->callbacks.prvCtl(pdip, PRV_CTL_DISABLE_INTR,
			(void *)&dsp->bnxe_params, sizeof (BnxeFcoeInfo))) {
		//	cmn_err(CE_WARN,
		//	"%s%d: Unable to get the Params from Bnxe",
		//			BNXEF_DRIVER_NAME, dsp->instance);
		}
	}
#endif

	ASSERT(dsp != NULL);
	ASSERT(kcqep != NULL);

	conn_id = LE32_TO_CPU(kcqep->fcoe_conn_id);
	ASSERT(conn_id < BNXEF_MAX_SESSIONS_SUPPORTED);
	sessionp = dsp->sessp[conn_id];

	BNXEF_DEBUG(dsp, SCSI, -1, "%s%d: Fast Path completion Indicated",
		BNXEF_DRIVER_NAME, dsp->instance);
	ASSERT(sessionp != NULL);
	bnxef_session_cq_handler(sessionp);
}

/*
 * This will handle session specific cqe's, by reading the CQ.
 */
void
bnxef_session_cq_handler(void *arg)
{
	struct fcoe_cqe *cq;
	struct fcoe_cqe *curcqe;
	uint16_t	wqe;
	bnxef_driver_state_t *dsp;
	uint32_t  more_cqes = 0;
	uint8_t	cq_toggle;
	int ret;
	uint16_t cq_idx;
	uint16_t x_id;
	bnxef_session_t *sessionp = (bnxef_session_t *)arg;
	bnxef_fcoe_task_t *taskp;
	struct fcoe_task_ctx_entry *fwtaskp;
	uint8_t num_rq;

	ASSERT(sessionp != NULL);

	if (sessionp == NULL)
		return;
	if (sessionp->lport == NULL)
		return;
	dsp = ((bnxef_port_t *)(sessionp->lport))->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&sessionp->session_mutex);
	if ((sessionp->state &
		(BNXEF_SESSION_OFFLOADED | BNXEF_SESSION_ENABLED))
			== 0) {
		mutex_exit(&sessionp->session_mutex);
		return;
	}
	if (sessionp->state & BNXEF_SESSION_CQ_PROCESSING_INPROGRESS) {
		mutex_exit(&sessionp->session_mutex);
		// cmn_err(CE_NOTE,
		//	"Exiting because already Session CQ in progress");
		return;
	}
	sessionp->state |= BNXEF_SESSION_CQ_PROCESSING_INPROGRESS;
	mutex_exit(&sessionp->session_mutex);

	ret = ddi_dma_sync(sessionp->cq_dma_handle, 0,
		sessionp->cq_length, DDI_DMA_SYNC_FORCPU);
	ASSERT(ret == DDI_SUCCESS);
	mutex_enter(&sessionp->session_mutex);
	/* LINTED; alignment */
	cq = (struct fcoe_cqe *)sessionp->cq_addr;
	curcqe = &cq[sessionp->cq_cons_idx];
	cq_toggle = (volatile uint8_t)sessionp->cq_toggle;
	mutex_exit(&sessionp->session_mutex);
	wqe = LE16_TO_CPU(curcqe->wqe);
	BNXEF_DEBUG(dsp, SCSI, -1,
		"%s%d: CQ Completion Received Wqe 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, wqe);
	while ((wqe & FCOE_CQE_TOGGLE_BIT) ==
		(cq_toggle  << FCOE_CQE_TOGGLE_BIT_SHIFT)) {
		if (more_cqes == ((2*BNXEF_CQ_WQES_MAX)-1)) {
			// cmn_err(CE_NOTE,
			// "Exiting Loop Here 0x%x", more_cqes);
			break;
		}
		more_cqes++;
		if (wqe  & FCOE_CQE_CQE_TYPE) {
			BNXEF_DEBUG(dsp, SCSI, -1,
				"%s%d: Unsolicited Event handler",
				BNXEF_DRIVER_NAME, dsp->instance);
			/* Indicates it is Unsolicited event */
			bnxef_unsol_event_handler(sessionp, wqe);
		} else  {
			BNXEF_DEBUG(dsp, SCSI, -1,
				"%s%d: Cq Completion Received 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance, wqe);
			x_id =  wqe & FCOE_PEND_WQ_CQE_TASK_ID;
			ASSERT(x_id < BNXEF_MAX_EXCHGS_SUPPORTED);
			taskp = dsp->taskarray[x_id];
			taskp->indicate_lbolt = ddi_get_lbolt();
			taskp->tq_params.reserved4 = (uint64_t)sessionp;
			ASSERT(taskp != NULL);
			fwtaskp = taskp->fwtaskp;

			ret = ddi_dma_sync(
				dsp->task_dma_handle[taskp->dma_handle_idx],
				(taskp->x_id %32) *
				sizeof (struct fcoe_task_ctx_entry),
				sizeof (struct fcoe_task_ctx_entry),
				DDI_DMA_SYNC_FORCPU);
			if (ret != DDI_SUCCESS) {
				// cmn_err(CE_NOTE, "ddi_dma_sync failure");
				return;
			}
			ASSERT(ret == DDI_SUCCESS);
			num_rq =
			((LE16_TO_CPU(fwtaskp->rxwr_txrd.var_ctx.rx_flags) &
			FCOE_TCE_RX_WR_TX_RD_VAR_NUM_RQ_WQE) >>
			FCOE_TCE_RX_WR_TX_RD_VAR_NUM_RQ_WQE_SHIFT);
			if (num_rq == 0) {
				if (ddi_in_panic()) {
					bnxef_cq_completion(taskp);
				} else {
					ret = ddi_taskq_dispatch(dsp->tq,
						bnxef_cq_completion,
						(void *) taskp, DDI_NOSLEEP);
					if (ret != DDI_SUCCESS)  {
					//	cmn_err(CE_NOTE,
					//	"Task Queue dispatch failed");
						bnxef_cq_completion(taskp);
					}
				}

			} else {
				bnxef_cq_completion(taskp);
			}
		}
		curcqe++;
		mutex_enter(&sessionp->session_mutex);
		sessionp->cq_cons_idx++;
		if (sessionp->cq_cons_idx == BNXEF_CQ_WQES_MAX) {
			sessionp->cq_cons_idx = 0;
			curcqe = cq;
			sessionp->cq_toggle = 1 - sessionp->cq_toggle;
		}
		cq_toggle = (volatile uint8_t) sessionp->cq_toggle;
		mutex_exit(&sessionp->session_mutex);
		wqe = LE16_TO_CPU(curcqe->wqe);
	}
	if (more_cqes) {
		mutex_enter(&sessionp->session_mutex);
		cq_idx = sessionp->cq_cons_idx;
		if (cq_idx == sessionp->prev_cq_cons_idx) {
			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: CQ prev Idx 0x%x, local cq_idx 0x%x,\
				session cq idx 0x%x\
				prev_cq_toggle 0x%x cq_toggle 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance,
			sessionp->prev_cq_cons_idx,
			cq_idx, sessionp->cq_cons_idx,
			sessionp->prev_cq_toggle, sessionp->cq_toggle);
			if (sessionp->prev_cq_toggle == sessionp->cq_toggle) {
				BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Num items 0x%x",
					BNXEF_DRIVER_NAME,
					dsp->instance, more_cqes);
				debug_enter("Wrong CQ IDX");
			}
		}
		sessionp->state &= ~BNXEF_SESSION_CQ_PROCESSING_INPROGRESS;
		mutex_exit(&sessionp->session_mutex);
		bnxef_arm_cq(sessionp, cq_idx);
	} else {
		mutex_enter(&sessionp->session_mutex);
		cq_idx = sessionp->cq_cons_idx;
		sessionp->state &= ~BNXEF_SESSION_CQ_PROCESSING_INPROGRESS;
		mutex_exit(&sessionp->session_mutex);
		// bnxef_arm_cq(sessionp, cq_idx);
	}
}

/* Expanded error message for error codes */

char *bnxef_error_message[] = {
	"FCP XFER READY Received out of order",
	"FCP XFER READY Relative Offset not Aligned",
	"FCP XFER READY with Null Burst length",
	"FCP XFER READY with Relative offset Greater than Data Transfer Size",
	"FCP XFER READY with Invalid Payload size",
	"FCP XFER READY received for non write command",
	"FCP XFER READY Pending XFER Set",
	"FCP XFER READY OPENED Sequence",
	"FCP XFER READY FCTL Not good",
	"FCP RSP Bi-directional flag set",
	"FCP RSP Underflow flag set",
	"FCP RSP Overflow flag set",
	"FCP RSP Invalid Length field",
	"FCP RSP Invalid Sense Field",
	"FCP RSP Invalid Payload size",
	"FCP RSP Pend XFER Set",
	"FCP RSP Opened Sequence",
	"FCP RSP FCTL not good",
	"FCP RSP Last Sequence Reset ",
	"FCP RSP confirmation Request not supported yet",
	"FCP DATA out of order Relative offset",
	"FCP Data exceeds max frame size defined",
	"FCP Data exceeds Data to Transmit",
	"FCP Data SOFi3 Sequence Active set",
	"FCP Data SOFn Sequence Active reset",
	"FCP Data EOFn End Sequence Set",
	"FCP Data EOFt End Sequence Reset",
	"FCP Data Task Type not read",
	"FCP Data FCTL not good",
	"Middle path Type not ELS",
	"Middle path Sofi3 sequence active set",
	"Middle path Sofn Sequence active reset",
	"Middle path Eofn end sequence set",
	"Middle Path EoFt End sequence reset",
	"Middle path ELS Reply FCTL not good",
	"Middle path Invalid Reply",
	"Middle Path ELS reply RCTL not good",
	"ABTS Reply FCTL not good",
	"ABTS Reply DDF Rctl field not good",
	"ABTS Reply invalid BLS RCTL not good",
	"ABTS reply invalid RCTL",
	"ABTS Reply RCTL General Mismatch",
	"Common Middle frame with Filler bytes set",
	"Common Sequence init in TCE",
	"Common FC Header RX ID mismatch",
	"Common Incorrect Sequence Count",
	"Common FCP Type Mismatch",
	"Common More data available than Sges given",
	"Common optional FC Header received, not expected",
	"Common Read TCE  OXID too big",
	"Common Data was not transmitted",
	"Unsolicited type not ELS",
	"Unsolicited Type not BLS",
	"Unsolcited fctl ELS",
	"Unsolciited fctl BLS",
	"Unsolcited R_CTL",
	"Read Write task DDF Rctl Info field",
	"Read Write Task Invalid RCTL",
	"Read Write Task RCTL mismatch",
	" Not defined ",
	"EDTOV Timer expiration",
	"RECTOV Timer expiration",
};

/*
 * The following handles the unsolicited error handling for different errors
 * indicated by firmware. When the errors are indicated that means for that
 * task no completion is going to happen.
 */
void
bnxef_unsolicited_error_handler(bnxef_session_t *sessionp,
			bnxef_fcoe_task_t *taskp,  uint16_t error,
		struct fcoe_err_report_entry *err_entry)
{
	bnxef_driver_state_t *dsp;
	bnxef_port_t	*portp;
	int ret;


	ASSERT(sessionp != NULL);
	ASSERT(taskp != NULL);


	portp = sessionp->lport;
	ASSERT(portp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);
	ASSERT(error <= 63);

	mutex_enter(&taskp->task_mutex);
	/* we support Unsolicited error only on SCSI tasks */
	if ((taskp->task_flags & BNXEF_FCOE_TASK_SCSI) == 0) {
		mutex_exit(&taskp->task_mutex);
		return;
	}
	mutex_exit(&taskp->task_mutex);


#if 0
	mutex_enter(&taskp->task_mutex);
	if (taskp->task_flags & BNXEF_FCOE_TASK_COMPLETED) {
		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Ignoring error for already completed task 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
		mutex_exit(&taskp->task_mutex);
		return;
	}
	mutex_exit(&taskp->task_mutex);
#endif
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Error: %d- %s",
		BNXEF_DRIVER_NAME, dsp->instance, error,
		bnxef_error_message[error]);
	mutex_enter(&sessionp->session_mutex);
	/*
	 * If Sequence Retry is enabled for the following errors
	 * send REC and try recovery first.
	 */
	if (sessionp->state & BNXEF_SESSION_SEQ_RETRY_ENABLED) {
		if ((error == FCOE_ERROR_CODE_DATA_OOO_RO) ||
			(error == FCOE_ERROR_CODE_COMMON_INCORRECT_SEQ_CNT) ||
			(error == FCOE_ERROR_CODE_DATA_SOFI3_SEQ_ACTIVE_SET) ||
			(error == FCOE_ERROR_CODE_FCP_RSP_OPENED_SEQ) ||
			(error == FCOE_ERROR_CODE_DATA_SOFN_SEQ_ACTIVE_RESET)) {
			error = FCOE_ERROR_CODE_REC_TOV_TIMER_EXPIRATION;
		}
	}
	mutex_exit(&sessionp->session_mutex);

	BNXEF_TRACE_EVENT(dsp, BNXEF_SCSI_TASK_ERRORS,
		taskp->x_id, -1, 0, sessionp, error, 0, 0);

	switch (error) {
	case FCOE_ERROR_CODE_XFER_OOO_RO:
	case FCOE_ERROR_CODE_XFER_RO_NOT_ALIGNED:
	case FCOE_ERROR_CODE_XFER_NULL_BURST_LEN:
	case FCOE_ERROR_CODE_XFER_RO_GREATER_THAN_DATA2TRNS:
	case FCOE_ERROR_CODE_XFER_INVALID_PAYLOAD_SIZE:
	case FCOE_ERROR_CODE_XFER_TASK_TYPE_NOT_WRITE:
	case FCOE_ERROR_CODE_XFER_PEND_XFER_SET:
	case FCOE_ERROR_CODE_XFER_OPENED_SEQ:
	case FCOE_ERROR_CODE_XFER_FCTL:

// FCP DATA error codes

	case FCOE_ERROR_CODE_DATA_EXCEEDS_DEFINED_MAX_FRAME_SIZE:
	case FCOE_ERROR_CODE_DATA_EXCEEDS_DATA2TRNS:
	case FCOE_ERROR_CODE_DATA_EOFN_END_SEQ_SET:
	case FCOE_ERROR_CODE_DATA_EOFT_END_SEQ_RESET:
	case FCOE_ERROR_CODE_DATA_TASK_TYPE_NOT_READ:
	case FCOE_ERROR_CODE_DATA_FCTL:
// FCP RSP Error code which requires recovery
	case FCOE_ERROR_CODE_FCP_RSP_CONF_REQ_NOT_SUPPORTED_YET:
	case FCOE_ERROR_CODE_MIDPATH_SOFI3_SEQ_ACTIVE_SET:
	case FCOE_ERROR_CODE_MIDPATH_SOFN_SEQ_ACTIVE_RESET:
	case FCOE_ERROR_CODE_MIDPATH_EOFN_END_SEQ_SET:
	case FCOE_ERROR_CODE_MIDPATH_EOFT_END_SEQ_RESET:
	case FCOE_ERROR_CODE_COMMON_MIDDLE_FRAME_WITH_PAD:
	case FCOE_ERROR_CODE_COMMON_DATA_FC_HDR_FCP_TYPE_MISMATCH:
	case FCOE_ERROR_CODE_COMMON_DATA_NO_MORE_SGES:
	case FCOE_ERROR_CODE_COMMON_OPTIONAL_FC_HDR:
	case FCOE_ERROR_CODE_E_D_TOV_TIMER_EXPIRATION:
	// FCP RSP error codes
	case FCOE_ERROR_CODE_FCP_RSP_BIDI_FLAGS_SET:
	case FCOE_ERROR_CODE_FCP_RSP_UNDERFLOW:
	case FCOE_ERROR_CODE_FCP_RSP_OVERFLOW:
	case FCOE_ERROR_CODE_FCP_RSP_INVALID_LENGTH_FIELD:
	case FCOE_ERROR_CODE_FCP_RSP_INVALID_SNS_FIELD:
	case FCOE_ERROR_CODE_FCP_RSP_INVALID_PAYLOAD_SIZE:
	case FCOE_ERROR_CODE_FCP_RSP_PEND_XFER_SET:
	case FCOE_ERROR_CODE_FCP_RSP_FCTL:
	case FCOE_ERROR_CODE_FCP_RSP_LAST_SEQ_RESET:

// Middle path error codes
	case FCOE_ERROR_CODE_MIDPATH_INVALID_TYPE:
	case FCOE_ERROR_CODE_MIDPATH_REPLY_FCTL:
	case FCOE_ERROR_CODE_MIDPATH_INVALID_REPLY:
	case FCOE_ERROR_CODE_MIDPATH_ELS_REPLY_RCTL:
// Common error codes

	case FCOE_ERROR_CODE_COMMON_SEQ_INIT_IN_TCE:
	case FCOE_ERROR_CODE_COMMON_FC_HDR_RX_ID_MISMATCH:
	case FCOE_ERROR_CODE_COMMON_READ_TCE_OX_ID_TOO_BIG:
	case FCOE_ERROR_CODE_COMMON_DATA_WAS_NOT_TRANSMITTED:

// Unsolicited Rx error codes
	case FCOE_ERROR_CODE_UNSOLICITED_TYPE_NOT_ELS:
	case FCOE_ERROR_CODE_UNSOLICITED_TYPE_NOT_BLS:
	case FCOE_ERROR_CODE_UNSOLICITED_FCTL_ELS:
	case FCOE_ERROR_CODE_UNSOLICITED_FCTL_BLS:
	case FCOE_ERROR_CODE_UNSOLICITED_R_CTL:

	case FCOE_ERROR_CODE_RW_TASK_DDF_RCTL_INFO_FIELD:
	case FCOE_ERROR_CODE_RW_TASK_INVALID_RCTL:
	case FCOE_ERROR_CODE_RW_TASK_RCTL_GENERAL_MISMATCH:
	case FCOE_ERROR_CODE_DATA_OOO_RO:
	case FCOE_ERROR_CODE_COMMON_INCORRECT_SEQ_CNT:
	case FCOE_ERROR_CODE_DATA_SOFI3_SEQ_ACTIVE_SET:
	case FCOE_ERROR_CODE_FCP_RSP_OPENED_SEQ:
	case FCOE_ERROR_CODE_DATA_SOFN_SEQ_ACTIVE_RESET:

		mutex_enter(&taskp->task_mutex);
		taskp->task_flags |= BNXEF_FCOE_RECOVERY_IN_PROGRESS;
		mutex_exit(&taskp->task_mutex);
		ret = bnxef_initiate_abts(sessionp, taskp);
		if (ret != BNXEF_SUCCESS) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to initiate ABTS",
			BNXEF_DRIVER_NAME, dsp->instance);
			return;
		}

		break;

	// ABTS error codes
	case FCOE_ERROR_CODE_ABTS_REPLY_F_CTL:
	case FCOE_ERROR_CODE_ABTS_REPLY_DDF_RCTL_FIELD:
	case FCOE_ERROR_CODE_ABTS_REPLY_INVALID_BLS_RCTL:
	case FCOE_ERROR_CODE_ABTS_REPLY_INVALID_RCTL:
	case FCOE_ERROR_CODE_ABTS_REPLY_RCTL_GENERAL_MISMATCH:  {
		uint32_t	task_flags, sectaskflags;
		uint16_t	secondary_x_id;
		timeout_id_t	tid;
		bnxef_fcoe_task_t	*sectaskp;
		int ret;


		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d:ABTS Error happened for task id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
		mutex_enter(&taskp->task_mutex);
		ASSERT(taskp->task_flags & BNXEF_FCOE_RECOVERY_IN_PROGRESS);
		task_flags = taskp->task_flags;
		secondary_x_id = taskp->secondary_x_id;
		taskp->sec_flags |= BNXEF_ABTS_ERROR;
		mutex_exit(&taskp->task_mutex);
		if (task_flags & BNXEF_FCOE_SEC_X_ID_VALID) {
			sectaskp = dsp->taskarray[secondary_x_id];
			mutex_enter(&sectaskp->task_mutex);
			tid = sectaskp->timerhdl;
			sectaskflags = sectaskp->task_flags;
			mutex_exit(&sectaskp->task_mutex);
			if (sectaskflags & BNXEF_FCOE_TASK_TIMER_ARMED) {
				untimeout(tid);
				mutex_enter(&sectaskp->task_mutex);
				sectaskp->task_flags &=
					~BNXEF_FCOE_TASK_TIMER_ARMED;
				sectaskp->task_flags |=
					BNXEF_FCOE_TASK_COMPLETED;
				mutex_exit(&sectaskp->task_mutex);
			}
			kmem_free(sectaskp->pktp, sizeof (fc_packet_t));
			/* Now free the secondary X_ID */
			bnxef_task_free((void *)dsp, sectaskp);
			mutex_enter(&taskp->task_mutex);
			taskp->task_flags &= ~BNXEF_FCOE_SEC_X_ID_VALID;
			mutex_exit(&taskp->task_mutex);
		}

		taskp->state =  FC_PKT_TRAN_ERROR;
		taskp->action = 0;
		taskp->reason = FC_REASON_ABORT_FAILED;
		taskp->expln =  0;

		/* first cleanup the original Task from firmware */
		ret = bnxef_cleanup_task(sessionp, taskp);
		ASSERT(ret == BNXEF_SUCCESS);

		break;
	}

	case FCOE_ERROR_CODE_REC_TOV_TIMER_EXPIRATION:
		if (sessionp->state & BNXEF_SESSION_SEQ_RETRY_ENABLED) {
			bnxef_tq_params_t *tqp;


			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Rec TOV Timer poped for Exchange 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
			bzero(&taskp->error,
				sizeof (struct fcoe_err_report_entry));
			bcopy(err_entry, &taskp->error,
				sizeof (struct fcoe_err_report_entry));


			tqp = &taskp->tq_params;
			tqp->taskp = taskp;
			tqp->dsp = dsp;
			tqp->portp = portp;
			tqp->sessp = sessionp;

			bnxef_send_rec((void *)tqp);
		} else {
			mutex_enter(&taskp->task_mutex);
			taskp->task_flags |= BNXEF_FCOE_RECOVERY_IN_PROGRESS;
			mutex_exit(&taskp->task_mutex);
			ret = bnxef_initiate_abts(sessionp, taskp);
			if (ret != BNXEF_SUCCESS) {
				BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to initiate ABTS",
				BNXEF_DRIVER_NAME, dsp->instance);
				return;
			}

		}
		break;


	// Timer error codes
	default:
		break;

	}

}

void
bnxef_session_cleanup_tq(void * arg)
{
	bnxef_session_t *sessionp = (bnxef_session_t *)arg;

	if (sessionp != NULL) {
		bnxef_session_cleanup(sessionp);
	}

}

void
bnxef_mp_rscn_handler_tq(void *arg)
{
	bnxef_tq_params_t *tqp;
	bnxef_driver_state_t *dsp;
	bnxef_session_t *sessionp;
	bnxef_port_t	*portp;
	fc_unsol_buf_t *ubp;
	bnxef_unsol_buf_t	*unsolbufp;
	uint8_t type;

	tqp = (bnxef_tq_params_t *)arg;
	ASSERT(tqp != NULL);

	sessionp = tqp->sessp;
	portp = tqp->portp;
	dsp = tqp->dsp;
	ubp = (fc_unsol_buf_t *)tqp->reserved1;
	type = (uint8_t)tqp->reserved2;
	unsolbufp = (bnxef_unsol_buf_t *)tqp->reserved3;
	ASSERT(sessionp != NULL);
	ASSERT(dsp != NULL);
	ASSERT(portp != NULL);
	ASSERT(ubp != NULL);

	kmem_cache_free(dsp->tq_params_cache, tqp);

	bnxef_mp_rscn_handler(portp, sessionp, unsolbufp, ubp, type);

}


int
bnxef_mp_rscn_handler(bnxef_port_t *portp,
	bnxef_session_t *sessionp,
	bnxef_unsol_buf_t *unsolbufp,
	fc_unsol_buf_t *ubp,
	uint8_t type)
{
	bnxef_driver_state_t *dsp;
	fc_frame_hdr_t fhdr;
	fc_rscn_t *rscnp;

	ASSERT(portp != NULL);
	ASSERT(ubp != NULL);

	dsp = (bnxef_driver_state_t *)portp->statep;
	ASSERT(dsp != NULL);


	bcopy((uint8_t *)&ubp->ub_frame, (uint8_t *)&fhdr,
			sizeof (fc_frame_hdr_t));

	/* LINTED: alignment */
	rscnp = (fc_rscn_t *)(ubp->ub_buffer);
	rscnp->rscn_payload_len = htons(rscnp->rscn_payload_len);
	if (rscnp->rscn_payload_len < 8) {
		bnxef_send_ls_rjt(portp,
			sessionp, unsolbufp,
			BNXEF_LA_RJT_LOGICAL_ERR, 0);
		return (BNXEF_FAILURE);
	}
	if ((rscnp->rscn_payload_len % 4) != 0) {
		bnxef_send_ls_rjt(portp,
			sessionp, unsolbufp,
			BNXEF_LA_RJT_LOGICAL_ERR, 0);
		return (BNXEF_FAILURE);
	}

	if (rscnp->rscn_len != 4) {
		bnxef_send_ls_rjt(portp,
			sessionp, unsolbufp,
			BNXEF_LA_RJT_LOGICAL_ERR, 0);
		return (BNXEF_FAILURE);
	}



	portp->pbind.port_unsol_cb(
		(opaque_t)portp->pbind.port_handle,
		ubp, type);

	return (BNXEF_SUCCESS);
}



void
bnxef_mp_prlo_handler_tq(void *arg)
{
	bnxef_tq_params_t *tqp;
	bnxef_driver_state_t *dsp;
	bnxef_session_t *sessionp;
	bnxef_port_t	*portp;
	fc_unsol_buf_t *ubp;
	bnxef_unsol_buf_t	*unsolbufp;
	uint8_t type;

	tqp = (bnxef_tq_params_t *)arg;
	ASSERT(tqp != NULL);

	sessionp = tqp->sessp;
	portp = tqp->portp;
	dsp = tqp->dsp;
	ubp = (fc_unsol_buf_t *)tqp->reserved1;
	type = (uint8_t)tqp->reserved2;
	unsolbufp = (bnxef_unsol_buf_t *)tqp->reserved3;
	ASSERT(sessionp != NULL);
	ASSERT(dsp != NULL);
	ASSERT(portp != NULL);
	ASSERT(ubp != NULL);

	kmem_cache_free(dsp->tq_params_cache, tqp);

	bnxef_mp_prlo_handler(portp, sessionp, unsolbufp, ubp, type);

}

int
bnxef_mp_prlo_handler(bnxef_port_t *portp,
	bnxef_session_t *sessionp,
	bnxef_unsol_buf_t *unsolbufp,
	fc_unsol_buf_t *ubp,
	uint8_t type)
{
	bnxef_session_t *newsessionp;
	bnxef_driver_state_t *dsp;
	fc_frame_hdr_t fhdr;

	ASSERT(portp != NULL);
	ASSERT(ubp != NULL);

	dsp = (bnxef_driver_state_t *)portp->statep;
	ASSERT(dsp != NULL);


	bcopy((uint8_t *)&ubp->ub_frame, (uint8_t *)&fhdr,
		sizeof (fc_frame_hdr_t));

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Nport ID seen in PRLO Hdr is 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, fhdr.s_id);

	newsessionp = bnxef_session_find_remote_port(portp,
			portp->fcf->vlan_id,
			fhdr.s_id,
			portp->fcf->mac_addr);
	if (newsessionp == NULL) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Returning failure as given NPORT_ID is unknown",
			BNXEF_DRIVER_NAME, dsp->instance);
		bnxef_send_ls_rjt(portp,
			sessionp, unsolbufp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM, 0);
		return (BNXEF_FAILURE);
	}

	mutex_enter(&newsessionp->session_mutex);
	if (newsessionp->sec_state & BNXEF_UNSOL_LOGO_INPROGRESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Rejecting LOGO Frame, LOGO already in progress\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		mutex_exit(&newsessionp->session_mutex);
		bnxef_send_ls_rjt(portp,
			sessionp, unsolbufp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM, 0);
		return (BNXEF_FAILURE);
	}

	newsessionp->sec_state |= BNXEF_UNSOL_LOGO_INPROGRESS;
	mutex_exit(&newsessionp->session_mutex);

	portp->pbind.port_unsol_cb(
		(opaque_t)portp->pbind.port_handle,
		ubp, type);

	return (BNXEF_SUCCESS);
}



void
bnxef_mp_logo_handler_tq(void *arg)
{

	bnxef_tq_params_t *tqp;
	bnxef_driver_state_t *dsp;
	bnxef_session_t *sessionp;
	bnxef_port_t	*portp;
	fc_unsol_buf_t *ubp;
	bnxef_unsol_buf_t	*unsolbufp;
	uint8_t type;

	tqp = (bnxef_tq_params_t *)arg;
	ASSERT(tqp != NULL);

	sessionp = tqp->sessp;
	portp = tqp->portp;
	dsp = tqp->dsp;
	ubp = (fc_unsol_buf_t *)tqp->reserved1;
	type = (uint8_t)tqp->reserved2;
	unsolbufp = (bnxef_unsol_buf_t *)tqp->reserved3;
	ASSERT(sessionp != NULL);
	ASSERT(dsp != NULL);
	ASSERT(portp != NULL);
	ASSERT(ubp != NULL);

	kmem_cache_free(dsp->tq_params_cache, tqp);

	bnxef_mp_logo_handler(portp, sessionp, unsolbufp, ubp, type);

}



int
bnxef_mp_logo_handler(bnxef_port_t *portp,
	bnxef_session_t *sessionp,
	bnxef_unsol_buf_t *unsolbufp,
	fc_unsol_buf_t *ubp,
	uint8_t type)
{

	la_els_logo_t logo;
	bnxef_session_t *newsessionp;
	bnxef_driver_state_t *dsp;

	ASSERT(portp != NULL);
	ASSERT(ubp != NULL);

	dsp = (bnxef_driver_state_t *)portp->statep;
	ASSERT(dsp != NULL);


	bcopy(ubp->ub_buffer, &logo, sizeof (la_els_logo_t));

	bnxef_big_endian((uint8_t *)&logo, 8);

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Nport ID seen in LOGO payload 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, logo.nport_id.port_id);

	newsessionp = bnxef_session_find_remote_port(portp,
			portp->fcf->vlan_id,
			logo.nport_id.port_id,
			portp->fcf->mac_addr);
	if (newsessionp == NULL) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Returning failure as given NPORT_ID is unknown",
			BNXEF_DRIVER_NAME, dsp->instance);
		bnxef_send_ls_rjt(portp,
			sessionp, unsolbufp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM, 0);
		return (BNXEF_FAILURE);
	}

	mutex_enter(&newsessionp->session_mutex);
	if (newsessionp->sec_state & BNXEF_UNSOL_LOGO_INPROGRESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Rejecting LOGO Frame, LOGO already in progress\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		mutex_exit(&newsessionp->session_mutex);
		bnxef_send_ls_rjt(portp,
			sessionp, unsolbufp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM, 0);
		return (BNXEF_FAILURE);
	}

	newsessionp->sec_state |= BNXEF_UNSOL_LOGO_INPROGRESS;
	mutex_exit(&newsessionp->session_mutex);



#if 0
	if (newsessionp != NULL) {
		mutex_enter(&newsessionp->session_mutex);
		if (newsessionp->state & BNXEF_SESSION_CLEANUP_INPROGRESS) {
			mutex_exit(&newsessionp->session_mutex);
			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Session Cleanup in progress- Dropping Frame",
					BNXEF_DRIVER_NAME, dsp->instance);
			return (BNXEF_FAILURE);
		}
		mutex_exit(&newsessionp->session_mutex);
		BNXEF_DEBUG(dsp, GENERAL, -1, "%s%d: Implicit logo Called",
			BNXEF_DRIVER_NAME, dsp->instance);
		bnxef_session_cleanup(newsessionp);
	}
#endif

	portp->pbind.port_unsol_cb(
		(opaque_t)portp->pbind.port_handle,
		ubp, type);

	return (BNXEF_SUCCESS);
}

/*
 * THis will handle unsolicited events/sequence coming on the wire will be
 * handled.
 */
void
bnxef_unsol_event_handler(bnxef_session_t *sessionp, uint16_t wqe)
{
	bnxef_driver_state_t		*dsp;
	bnxef_port_t			*portp;
	uint8_t				num_rq;
	uint16_t			frame_len;
	uint8_t				*rqep;
	fc_frame_hdr_t			*fcp;
	bnxef_unsol_buf_t	*unsolbufp;
	fc_unsol_buf_t		*ubp;
	uint16_t	error = 64;
	int	 i, ret;
	uint16_t	rq_cons_idx;


	ASSERT(sessionp != NULL);
	if (sessionp == NULL)
		return;
	portp = sessionp->lport;
	ASSERT(portp != NULL);
	if (portp == NULL)
		return;

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	/* Synchronize the RQ DMA area for CPU to read */
	ret = ddi_dma_sync(sessionp->rq_dma_handle, 0,
		sessionp->rq_length, DDI_DMA_SYNC_FORCPU);
	ASSERT(ret == DDI_SUCCESS);
	mutex_enter(&sessionp->session_mutex);
	rq_cons_idx = sessionp->rq_cons_idx;
	mutex_exit(&sessionp->session_mutex);
	ret = ddi_dma_sync(sessionp->rq_dma_handle,
			rq_cons_idx * BNXEF_RQ_BUF_SIZE,
			BNXEF_RQ_BUF_SIZE, DDI_DMA_SYNC_FORCPU);
	ASSERT(ret == DDI_SUCCESS);


	switch (wqe & FCOE_UNSOLICITED_CQE_SUBTYPE) {
	case  FCOE_UNSOLICITED_FRAME_CQE_TYPE: {
		uint8_t	els_code;

		frame_len = (wqe & FCOE_UNSOLICITED_CQE_PKT_LEN) >>
				FCOE_UNSOLICITED_CQE_PKT_LEN_SHIFT;

		num_rq = (frame_len + BNXEF_RQ_BUF_SIZE -1)/BNXEF_RQ_BUF_SIZE;
		/* We have given RQ bufs enough space to hold a full frame */
		ASSERT(num_rq == 1);
		rqep	= (uint8_t *)bnxef_get_next_rqe(sessionp, num_rq);
		if (rqep != NULL) {
			/* LINTED: alignment */
			fcp = (fc_frame_hdr_t *)rqep;
			bnxef_big_endian(fcp, sizeof (fc_frame_hdr_t));

			if (fcp->type == FC_TYPE_BASIC_LS) {
				bnxef_return_rqe(sessionp, num_rq);
				return;
			}
			/*
			 * Now look for the unsolicited buffer from the
			 * Unsolicited buffer pool
			 */
			unsolbufp = bnxef_find_unsol_buf(portp, fcp->type);
			if (unsolbufp == NULL) {
				fc_packet_t *pktp;
				bnxef_tq_params_t tq;
				bnxef_fcoe_task_t *taskp;
				la_els_rjt_t rjt;

				BNXEF_DEBUG(dsp, ERROR, portp->id,
					"%s%d: Unable to find a release \
					buffer of type 0x%x\n",
					BNXEF_DRIVER_NAME, dsp->instance,
						fcp->type);
				/* Prepare LS_RJT */
				pktp = bnxef_prep_ls_rjt_with_fhdr(dsp, fcp);
				ASSERT(pktp != NULL);
				tq.dsp = dsp;
				tq.portp = portp;
				tq.sessp = sessionp;
				bnxef_pkt_cmd_res_alloc(&tq, pktp);
				bnxef_build_ls_rjt_cmd(&rjt, pktp,
					BNXEF_LA_RJT_UNABLE_TO_PERFORM,	0);
				taskp =
				(bnxef_fcoe_task_t *)pktp->pkt_fca_private;
				ASSERT(taskp != NULL);
				bnxef_big_endian(pktp->pkt_cmd, 4);
				if (sessionp->state & BNXEF_SESSION_OFFLOADED) {
					bnxef_els_tx_nonofld_session_noresp(
						portp, sessionp, pktp,
						BNXEF_USE_RX_ID);
				}

				bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
				kmem_free(taskp->frame_hdrp,
					sizeof (fc_frame_hdr_t));
				kmem_free(taskp->payloadp,
					sizeof (la_els_rjt_t));
				bnxef_task_free(dsp,
				(bnxef_fcoe_task_t *)pktp->pkt_fca_private);
				kmem_free(pktp, sizeof (fc_packet_t));

				bnxef_return_rqe(sessionp, num_rq);
				return;
			}

			ubp = unsolbufp->unsol_bufp;

			/*
			 * Now set the Unsolicited buffer with all the
			 * information.
			 */
			ubp->ub_class = FC_TRAN_CLASS3;
			frame_len = MIN(BNXEF_RQ_BUF_SIZE, frame_len);
			frame_len  = MIN(frame_len, ubp-> ub_bufsize);

			bcopy((uint8_t *)fcp, (uint8_t *)&ubp->ub_frame,
					sizeof (fc_frame_hdr_t));
			bcopy((uint8_t *)(fcp+1), (uint8_t *)ubp->ub_buffer,
				frame_len - sizeof (fc_frame_hdr_t));

			els_code = ubp->ub_buffer[0];
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Unsolicited ELS received 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				els_code);
			if ((els_code == LA_ELS_LOGO) ||
				(els_code == LA_ELS_RSCN) ||
				(els_code == LA_ELS_PRLO) ||
				(els_code == LA_ELS_ADISC)) {

				if (els_code == LA_ELS_LOGO) {
					int ret;
					bnxef_tq_params_t *tqp;

					if ((frame_len -
						sizeof (fc_frame_hdr_t))
						< sizeof (la_els_logo_t)) {
						bnxef_return_rqe(sessionp,
							num_rq);
						mutex_enter(
						&unsolbufp->unsol_mutex);
						unsolbufp->flags |=
							BNXEF_UB_RELEASED;
						mutex_exit(
						&unsolbufp->unsol_mutex);
						return;
					}

					tqp =
						kmem_cache_alloc(
						dsp->tq_params_cache,
						KM_NOSLEEP);
					if (tqp == NULL) {
						BNXEF_DEBUG(dsp, ERROR, -1,
						"%s%d: Unable to allocate tqp",
							BNXEF_DRIVER_NAME,
							dsp->instance);
						bnxef_return_rqe(sessionp,
							num_rq);
						mutex_enter(
						&unsolbufp->unsol_mutex);
						unsolbufp->flags |=
							BNXEF_UB_RELEASED;
						mutex_exit(
						&unsolbufp->unsol_mutex);
						return;
					}
					tqp->dsp = dsp;
					tqp->sessp = (void *)sessionp;
					tqp->portp = (void *)portp;
					tqp->reserved1 = (uint64_t)ubp;
					tqp->reserved2 = (uint8_t)fcp->type;
					tqp->reserved3 = (uint64_t)unsolbufp;

					ret = ddi_taskq_dispatch(dsp->mtq,
						bnxef_mp_logo_handler_tq,
						(void *) tqp,
						DDI_NOSLEEP);

					if (ret != BNXEF_SUCCESS) {
						kmem_cache_free(
							dsp->tq_params_cache,
							tqp);
						bnxef_return_rqe(sessionp,
								num_rq);
						mutex_enter(
						&unsolbufp->unsol_mutex);
						unsolbufp->flags |=
							BNXEF_UB_RELEASED;
						mutex_exit(
						&unsolbufp->unsol_mutex);
						return;
					}
				} else if (els_code == LA_ELS_PRLO) {
					int ret;
					bnxef_tq_params_t *tqp;
					if ((frame_len -
						sizeof (fc_frame_hdr_t))
						< sizeof (la_els_prlo_t)) {
						bnxef_return_rqe(
							sessionp,
							num_rq);
						mutex_enter(
						&unsolbufp->unsol_mutex);
						unsolbufp->flags |=
						BNXEF_UB_RELEASED;
						mutex_exit(
						&unsolbufp->unsol_mutex);
						return;
					}

					tqp =
					kmem_cache_alloc(
						dsp->tq_params_cache,
						KM_NOSLEEP);
					if (tqp == NULL) {
						BNXEF_DEBUG(dsp, ERROR, -1,
						"%s%d: Unable to allocate tqp",
							BNXEF_DRIVER_NAME,
							dsp->instance);
							bnxef_return_rqe(
								sessionp,
								num_rq);
							mutex_enter(
						&unsolbufp->unsol_mutex);
							unsolbufp->flags |=
							BNXEF_UB_RELEASED;
							mutex_exit(
						&unsolbufp->unsol_mutex);
							return;
					}
					tqp->dsp = dsp;
					tqp->sessp = (void *)sessionp;
					tqp->portp = (void *)portp;
					tqp->reserved1 = (uint64_t)ubp;
					tqp->reserved2 =
					(uint8_t)fcp->type;
					tqp->reserved3 =
					(uint64_t)unsolbufp;

					ret = ddi_taskq_dispatch(dsp->mtq,
						bnxef_mp_prlo_handler_tq,
						(void *) tqp,
						DDI_NOSLEEP);

					if (ret != BNXEF_SUCCESS) {
						kmem_cache_free(
							dsp->tq_params_cache,
							tqp);
						bnxef_return_rqe(sessionp,
							num_rq);
						mutex_enter(
						&unsolbufp->unsol_mutex);
						unsolbufp->flags |=
							BNXEF_UB_RELEASED;
						mutex_exit(
						&unsolbufp->unsol_mutex);
						return;
					}
				} else if (els_code == LA_ELS_RSCN) {
					int ret;
					bnxef_tq_params_t *tqp;
					tqp =
					kmem_cache_alloc(dsp->tq_params_cache,
							KM_NOSLEEP);
					if (tqp == NULL) {
						BNXEF_DEBUG(dsp, ERROR, -1,
						"%s%d: Unable to allocate tqp",
							BNXEF_DRIVER_NAME,
							dsp->instance);
						bnxef_return_rqe(sessionp,
							num_rq);
						mutex_enter(
						&unsolbufp->unsol_mutex);
						unsolbufp->flags |=
							BNXEF_UB_RELEASED;
						mutex_exit(
						&unsolbufp->unsol_mutex);
						return;
					}
					tqp->dsp = dsp;
					tqp->sessp = (void *)sessionp;
					tqp->portp = (void *)portp;
					tqp->reserved1 = (uint64_t)ubp;
					tqp->reserved2 = (uint8_t)fcp->type;
					tqp->reserved3 = (uint64_t)unsolbufp;

					ret = ddi_taskq_dispatch(dsp->mtq,
						bnxef_mp_rscn_handler_tq,
						(void *) tqp,
						DDI_NOSLEEP);

					if (ret != BNXEF_SUCCESS) {
						kmem_cache_free(
						dsp->tq_params_cache,
							tqp);
						bnxef_return_rqe(sessionp,
								num_rq);
						mutex_enter(
						&unsolbufp->unsol_mutex);
						unsolbufp->flags |=
							BNXEF_UB_RELEASED;
						mutex_exit(
						&unsolbufp->unsol_mutex);
						return;
					}
				} else
					portp->pbind.port_unsol_cb(
					(opaque_t)portp->pbind.port_handle,
					ubp, fcp->type);
			} else {
				bnxef_session_t *sessionp;
				BNXEF_DEBUG(dsp, ERROR, -1,
					"%s%d: S_ID 0x%x, Vlan ID 0x%x",
					BNXEF_DRIVER_NAME, dsp->instance,
						fcp->s_id, portp->fcf->vlan_id);

				sessionp =
					bnxef_session_find_remote_port(portp,
						portp->fcf->vlan_id,
						fcp->s_id,
						portp->fcf->mac_addr);
				if (sessionp != NULL) {
					if (els_code == LA_ELS_REC) {
						bnxef_send_ls_rjt(portp,
							sessionp,
							unsolbufp,
						BNXEF_LA_RJT_UNABLE_TO_PERFORM,
							0x17);
					} else  {
						if ((els_code == LA_ELS_TEST) ||
						(els_code == LA_ELS_FAN) ||
						(els_code == LA_ELS_ESTC) ||
						(els_code == LA_ELS_CSU)) {
							uint64_t token[1];

							token[0] =
							(uint64_t)unsolbufp;
							bnxef_ub_release(
							(opaque_t)portp, 1,
								token);
						} else {
							bnxef_send_ls_rjt(portp,
							sessionp, unsolbufp,
						BNXEF_LA_RJT_NOT_SUPPORTED,
							0);
						}
					}
				}
			}
		bnxef_return_rqe(sessionp, num_rq);
		}
		break;
	}
	case FCOE_ERROR_DETECTION_CQE_TYPE: {
		struct fcoe_err_report_entry *err_entry;
		uint16_t		ox_id;
		bnxef_fcoe_task_t	*taskp;
		uint32_t			task_flags;
		timeout_id_t			tid;
		uint64_t		error_bit_map;

		// LINTED: alignment */
		err_entry = (struct fcoe_err_report_entry *)
				bnxef_get_next_rqe(sessionp, 1);
		ox_id = LE16_TO_CPU(err_entry->fc_hdr.ox_id);
		if (ox_id > BNXEF_MAX_EXCHGS_SUPPORTED) {
			bnxef_return_rqe(sessionp, 1);
			return;
		}

		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Got the Error detection event from firmware \
			on X_ID 0x%x error entry %p\n",
			BNXEF_DRIVER_NAME, dsp->instance,
			ox_id, err_entry);
		ASSERT(ox_id <= BNXEF_MAX_EXCHGS_SUPPORTED);
		taskp = dsp->taskarray[ox_id];
		bcopy(err_entry, &taskp->error,
			sizeof (struct fcoe_err_report_entry));
		err_entry = &taskp->error;
		bnxef_return_rqe(sessionp, 1);


		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Error bit map returned 0x%lx%lx\n",
			BNXEF_DRIVER_NAME, dsp->instance,
			LE32_TO_CPU(err_entry->data.err_warn_bitmap_hi),
			LE32_TO_CPU(err_entry->data.err_warn_bitmap_lo));
		BNXEF_DEBUG(dsp, ERROR, portp->id,
		"%s%d: The Rx buf offset 0x%x, Tx buf offset 0x%x\n",
		BNXEF_DRIVER_NAME, dsp->instance,
			LE32_TO_CPU(err_entry->data.rx_buf_off),
			LE32_TO_CPU(err_entry->data.tx_buf_off));
		error_bit_map = (uint64_t)
		((uint64_t)LE32_TO_CPU(err_entry->data.err_warn_bitmap_hi)
			<< 32)|
		(uint64_t)LE32_TO_CPU(err_entry->data.err_warn_bitmap_lo);
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: The Consolidated error bitmap is 0x%llx",
			BNXEF_DRIVER_NAME, dsp->instance, error_bit_map);
		for (i = 0; i < 63; i++) {
			if (error_bit_map & (uint64_t)((uint64_t)1 << i)) {
				error = i;
				break;
			}
		}

		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Error identified 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, error);
		mutex_enter(&taskp->task_mutex);
		task_flags = taskp->task_flags;
		tid = taskp->timerhdl;
		mutex_exit(&taskp->task_mutex);

		if ((task_flags & BNXEF_FCOE_TASK_SCSI)) {
			if (task_flags & BNXEF_FCOE_TASK_TIMER_ARMED) {
				untimeout(tid);
				mutex_enter(&taskp->task_mutex);
				taskp->task_flags &=
				~BNXEF_FCOE_TASK_TIMER_ARMED;
				mutex_exit(&taskp->task_mutex);
			}

			bnxef_unsolicited_error_handler(sessionp,
				taskp, error, err_entry);
		}
		break;
	}
	case  FCOE_WARNING_DETECTION_CQE_TYPE: {
		uint16_t		ox_id;
		uint64_t		warn_bit_map;
		uint8_t			warn;
		struct fcoe_err_report_entry *err_entry;

		/* LINTED: alignment */
		err_entry = (struct fcoe_err_report_entry *)
				bnxef_get_next_rqe(sessionp, 1);
		ox_id = LE16_TO_CPU(err_entry->fc_hdr.ox_id);

		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Got the Error detection event from firmware \
			on X_ID 0x%x\n", BNXEF_DRIVER_NAME, dsp->instance,
			ox_id);
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Warning bit map returned 0xlx%lx\n",
			BNXEF_DRIVER_NAME, dsp->instance,
			LE32_TO_CPU(err_entry->data.err_warn_bitmap_hi),
			LE32_TO_CPU(err_entry->data.err_warn_bitmap_lo));
		BNXEF_DEBUG(dsp, ERROR, portp->id,
		"%s%d: The Rx buf offset 0x%x, Tx buf offset 0x%x\n",
		BNXEF_DRIVER_NAME, dsp->instance,
			LE32_TO_CPU(err_entry->data.rx_buf_off),
			LE32_TO_CPU(err_entry->data.tx_buf_off));
		warn_bit_map = (uint64_t)
		((uint64_t)LE32_TO_CPU(err_entry->data.err_warn_bitmap_hi)
			<< 32)|
		(uint64_t)LE32_TO_CPU(err_entry->data.err_warn_bitmap_lo);
		for (i = 0; i < 63; i++) {
			if (warn_bit_map & (uint64_t)(1 << i)) {
				warn = i;
				break;
			}
		}
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Warning identified 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, warn);
		switch (warn) {
		case  FCOE_ERROR_CODE_REC_TOV_TIMER_EXPIRATION: {
			bnxef_fcoe_task_t *taskp;
			bnxef_tq_params_t *tqp;

			taskp = dsp->taskarray[ox_id];
			ASSERT(taskp != NULL);
			bzero(&taskp->error,
				sizeof (struct fcoe_err_report_entry));
			bcopy(err_entry, &taskp->error,
				sizeof (struct fcoe_err_report_entry));


			tqp = &taskp->tq_params;
			tqp->taskp = taskp;
			tqp->dsp = dsp;
			tqp->portp = portp;
			tqp->sessp = sessionp;

			bnxef_send_rec((void *)tqp);
			break;
		}
		default :
			debug_enter("Unsol Warning");
			break;
		}

		bnxef_return_rqe(sessionp, 1);
		break;
	}
	default:
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unknown event received from firmware 0x%x\n",
		BNXEF_DRIVER_NAME, dsp->instance, wqe);
	}

}

/*
 * This handles the Work Queue request completion under the context of
 * ELSes, SCSI CMD, task management and ABTS.
 */
void
bnxef_cq_completion(void *arg)
{
	bnxef_fcoe_task_t *taskp = (bnxef_fcoe_task_t *)arg;
	bnxef_session_t *sessionp;
	bnxef_driver_state_t *dsp;
	struct fcoe_task_ctx_entry *fwtaskp;
	uint8_t num_rq;
	uint8_t rx_state;
	int ret;

	ASSERT(taskp != NULL);

	sessionp = (bnxef_session_t *)taskp->tq_params.reserved4;
	ASSERT(sessionp != NULL);

	dsp = taskp->dsp;
	ASSERT(dsp != NULL);

#if 0
	x_id =  wqe & FCOE_PEND_WQ_CQE_TASK_ID;
	ASSERT(x_id < BNXEF_MAX_EXCHGS_SUPPORTED);
	taskp = dsp->taskarray[x_id];
#endif
	fwtaskp = taskp->fwtaskp;

	ret = ddi_dma_sync(dsp->task_dma_handle[taskp->dma_handle_idx],
		(taskp->x_id %32) * sizeof (struct fcoe_task_ctx_entry),
		sizeof (struct fcoe_task_ctx_entry),
		DDI_DMA_SYNC_FORCPU);
	if (ret != DDI_SUCCESS) {
		return;
	}
	ASSERT(ret == DDI_SUCCESS);


	num_rq = ((LE16_TO_CPU(fwtaskp->rxwr_txrd.var_ctx.rx_flags) &
			FCOE_TCE_RX_WR_TX_RD_VAR_NUM_RQ_WQE) >>
			FCOE_TCE_RX_WR_TX_RD_VAR_NUM_RQ_WQE_SHIFT);
	rx_state = ((LE16_TO_CPU(fwtaskp->rxwr_txrd.var_ctx.rx_flags) &
			FCOE_TCE_RX_WR_TX_RD_VAR_RX_STATE) >>
			FCOE_TCE_RX_WR_TX_RD_VAR_RX_STATE_SHIFT);
	BNXEF_DEBUG(dsp, SCSI, -1,
		"%s%d: bnxef_cq_completion num_rq 0x%x,\
			rx_state 0x%x task id 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		num_rq, rx_state, taskp->x_id);

	if (taskp->task_flags & BNXEF_FCOE_TASK_SCSI) {
		bnxef_handle_scsi_cmd_completion(sessionp, taskp, num_rq,
			rx_state);
	} else if (taskp->task_flags & BNXEF_FCOE_TASK_ELS) {
		bnxef_handle_els_mp_completion_handler(sessionp, taskp, num_rq,
				rx_state);
	} else if (taskp->task_flags & BNXEF_FCOE_TASK_CLEANUP) {
		bnxef_handle_task_cleanup_completion(sessionp, taskp);
	} else if (taskp->task_flags & BNXEF_FCOE_TASK_SEQ_CLEANUP) {
		bnxef_handle_task_sequence_cleanup_completion(sessionp, taskp,
			rx_state);
	} else if (taskp->task_flags & BNXEF_FCOE_TASK_ABTS) {
		bnxef_handle_abts_completion(sessionp, taskp);
	} else if (taskp->task_flags & BNXEF_FCOE_TASK_MGMT_CMD) {
		bnxef_handle_tm_completion(sessionp, taskp);
	} else {
		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: bnxef_cq_completion num_rq 0x%x, \
		rx_state 0x%x task id 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		num_rq, rx_state, taskp->x_id);
	}


}

void
bnxef_tm_pkt_return(bnxef_session_t *sessionp, bnxef_fcoe_task_t *taskp)
{

	fc_packet_t *pktp;
	fcp_cmd_t	*cmdp;
	bnxef_fcoe_task_t *tp;
	uint32_t	task_flags;
	timeout_id_t	tid;
	bnxef_task_list_t *tasklstp;

	ASSERT(sessionp != NULL);
	ASSERT(taskp != NULL);

	pktp = (fc_packet_t *)taskp->pktp;
	/* LINTED: Alignment */
	cmdp = (fcp_cmd_t *)pktp->pkt_cmd;

	if (cmdp->fcp_cntl.cntl_reset_tgt) {
#if 0
		mutex_enter(&sessionp->session_mutex);
		sessionp->state |= BNXEF_TM_CLEANUP_IN_PROGRESS;
		mutex_exit(&sessionp->session_mutex);
		/* Delay 20 secs to Drain commands */
		delay(BNXEF_SEC2TICK(20));
#endif
		tp = bnxef_task_session_list_get_first(sessionp);
		ASSERT(tp != NULL);
		tasklstp = &sessionp->sessiontasklist;
		mutex_enter(&tasklstp->tasklist_mutex);
		while (tp != NULL) {


			mutex_enter(&tp->task_mutex);
			task_flags = tp->task_flags;
			tid = tp->timerhdl;
			mutex_exit(&tp->task_mutex);
			if ((task_flags & BNXEF_FCOE_TASK_MGMT_CMD) ==
					BNXEF_FCOE_TASK_MGMT_CMD) {
				tp = tp->snextp;
				continue;
			}
			if ((task_flags & BNXEF_FCOE_TASK_RRQ) == 0) {
				if ((task_flags &
					BNXEF_FCOE_RECOVERY_IN_PROGRESS) == 0) {
					if (task_flags &
						BNXEF_FCOE_TASK_TIMER_ARMED) {
						untimeout(tid);
						mutex_enter(&tp->task_mutex);
						tp->task_flags &=
						~BNXEF_FCOE_TASK_TIMER_ARMED;
						mutex_exit(&tp->task_mutex);
					}
					mutex_enter(&tp->task_mutex);
					tp->task_flags |=
						BNXEF_FCOE_RECOVERY_IN_PROGRESS;
					mutex_exit(&tp->task_mutex);



					bnxef_initiate_abts(sessionp, tp);
				}
			}
			tp = tp->snextp;
		}
		mutex_exit(&tasklstp->tasklist_mutex);
		mutex_enter(&sessionp->session_mutex);
		sessionp->state &= ~BNXEF_TM_CLEANUP_IN_PROGRESS;
		mutex_exit(&sessionp->session_mutex);
	}
}

/*
 * THis handles the task management requests.
 */
void
bnxef_handle_tm_completion(bnxef_session_t *sessionp, bnxef_fcoe_task_t *taskp)
{
	bnxef_driver_state_t	*dsp;
	bnxef_port_t		*portp;
	fc_packet_t		*pktp;
	timeout_id_t		tid;
	uint32_t		flags;
	fcp_rsp_t	*fcprsp;


	ASSERT(sessionp != NULL);
	ASSERT(taskp != NULL);

	portp = sessionp->lport;
	ASSERT(portp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&taskp->task_mutex);
	tid = taskp->timerhdl;
	flags = taskp->task_flags;
	pktp = taskp->pktp;
	mutex_exit(&taskp->task_mutex);

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Task Management Complete x-id 0x%x, pktp 0x%p",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id, taskp->pktp);

	if (flags & BNXEF_FCOE_TASK_TIMER_ARMED) {
		untimeout(tid);
		mutex_enter(&taskp->task_mutex);
		taskp->task_flags &= ~ BNXEF_FCOE_TASK_TIMER_ARMED;
		mutex_exit(&taskp->task_mutex);
	}

	ddi_dma_sync(dsp->task_dma_handle[taskp->dma_handle_idx],
		(taskp->x_id %32) * sizeof (struct fcoe_task_ctx_entry),
		sizeof (struct fcoe_task_ctx_entry),
		DDI_DMA_SYNC_FORCPU);

	/* LINTED: alignment */
	fcprsp = (fcp_rsp_t *)pktp->pkt_resp;
	bnxef_big_endian(fcprsp, 8);
	/* Third word you retain it the way it except for reserved filed */
	fcprsp->fcp_u.fcp_status.reserved_0 =
		htons(fcprsp->fcp_u.fcp_status.reserved_0);
	/* REset of the 12 bytes you swap as 4 bytes each */
	bnxef_big_endian((uint8_t *)fcprsp + 12, 12);


	if (sessionp != NULL) {
		bnxef_task_session_list_remove(sessionp, taskp);
	}

#if 0
	/*
	 * Now cleanup all the packets- Which are pending on this session if
	 * it is target reset that completed.
	 */
	bnxef_tm_pkt_return(sessionp, taskp);
#else

	mutex_enter(&sessionp->session_mutex);
	sessionp->state &= ~BNXEF_TM_CLEANUP_IN_PROGRESS;
	mutex_exit(&sessionp->session_mutex);
#endif




	/*
	 * Now the FCP resp should be available in pkt_resp. Therefore
	 * it is safe to complete the pkt.
	 */
	pktp->pkt_resp_resid = 0;
	pktp->pkt_data_resid = 0;
	bnxef_complete_pkt(pktp, FC_PKT_SUCCESS, 0, 0, 0);
}

/*
 * This will handle the ABTS request has been received.
 */
void
bnxef_handle_abts_completion(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp)
{

	bnxef_driver_state_t *dsp;
	bnxef_port_t		*portp;

	ASSERT(sessionp != NULL);
	ASSERT(taskp != NULL);

	portp = sessionp->lport;
	ASSERT(portp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	BNXEF_DEBUG(dsp, GENERAL, portp->id,
		"%s%d: ABTS request received by firmware for sending\n",
		BNXEF_DRIVER_NAME, dsp->instance);
}

/*
 * This will handle the task cleanup completion.
 */
void
bnxef_handle_task_cleanup_completion(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp)
{
	bnxef_driver_state_t *dsp;
	bnxef_port_t		 *portp;

	ASSERT(sessionp != NULL);
	ASSERT(taskp != NULL);
	ASSERT((taskp->task_flags & BNXEF_FCOE_TASK_TIMER_ARMED) == 0);

	portp = sessionp->lport;
	ASSERT(portp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&taskp->task_mutex);
	if (taskp->task_flags & BNXEF_FCOE_TASK_CLEANUP) {
		taskp->task_flags  &= ~ BNXEF_FCOE_TASK_CLEANUP;
	}
	mutex_exit(&taskp->task_mutex);

	/* IGnore the completion */
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Ignoring the Task Cleanup Completion for task 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);

	mutex_enter(&taskp->task_mutex);
		/* Wake up the thread waiting for completion */
		cv_signal(&taskp->task_cv);
		mutex_exit(&taskp->task_mutex);


	/* Free the allocated task */
	bnxef_task_free(dsp, taskp);
}

void
bnxef_handle_task_sequence_cleanup_completion(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp, uint8_t rx_state)
{
	bnxef_driver_state_t *dsp;
	bnxef_port_t		 *portp;
	bnxef_tq_params_t *tqp;
	bnxef_fcoe_task_t *otaskp;

	ASSERT(sessionp != NULL);
	ASSERT(taskp != NULL);
	ASSERT((taskp->task_flags & BNXEF_FCOE_TASK_TIMER_ARMED) == 0);

	portp = sessionp->lport;
	ASSERT(portp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&taskp->task_mutex);
	if (taskp->task_flags & BNXEF_FCOE_TASK_SEQ_CLEANUP) {
		taskp->task_flags  &= ~ BNXEF_FCOE_TASK_SEQ_CLEANUP;
	}
	mutex_exit(&taskp->task_mutex);

	/* IGnore the completion */
	BNXEF_DEBUG(dsp, ERROR, -1,
	"%s%d: Ignoring the Task Sequence Cleanup Completion for task 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);

	tqp = &taskp->tq_params;
	otaskp = tqp->taskp;

	/* Contents of tqp are already initiatlized */
	tqp = &otaskp->tq_params;


	if (rx_state ==  FCOE_TASK_RX_STATE_IGNORED_SEQUENCE_CLEANUP) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d:Sequence cleanup Ignored for Task id 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
		bnxef_task_free(dsp, taskp);
		return;
	}

	/* Send SRR */
	bnxef_send_srr(tqp);

	/* Free the allocated task */
	bnxef_task_free(dsp, taskp);
}


static void
bnxef_mp_logo_ls_acc_rx_handler(bnxef_driver_state_t *dsp, fc_packet_t *pktp)
{

	ASSERT(dsp != NULL);
	ASSERT(pktp != NULL);

	bnxef_big_endian(pktp->pkt_resp, 4);

	/* Set back the cmd to original value */
	bnxef_big_endian(pktp->pkt_cmd, pktp->pkt_cmdlen);

}

static void
bnxef_mp_logo_ls_rjt_rx_handler(bnxef_driver_state_t *dsp, fc_packet_t *pktp)
{

	la_els_rjt_t *rjtp;

	ASSERT(dsp != NULL);
	ASSERT(pktp != NULL);

	bnxef_big_endian(pktp->pkt_resp, 4);
	/* LINTED: alignment */
	rjtp = (la_els_rjt_t *)pktp->pkt_resp;
	ASSERT(rjtp != NULL);

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Ls RJT reason 0x%x, Expln 0x%x, VU 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		rjtp->reason, rjtp->reserved, rjtp->vu);

	pktp->pkt_reason = rjtp->reason;


	/* set back the command to origianl value */
	bnxef_big_endian(pktp->pkt_cmd, pktp->pkt_cmdlen);
}

static void
bnxef_mp_rls_ls_acc_rx_handler(bnxef_driver_state_t *dsp, fc_packet_t *pktp)
{

	ASSERT(dsp != NULL);
	ASSERT(pktp != NULL);

	/*
	 * We know we have sent RLS, we have received LS_ACC.
	 */
	bnxef_big_endian(pktp->pkt_resp, 28);


	/* Set back the cmd to original value */
	bnxef_big_endian(pktp->pkt_cmd, 8);
}

static void
bnxef_mp_rls_ls_rjt_rx_handler(bnxef_driver_state_t *dsp, fc_packet_t *pktp)
{

	la_els_rjt_t *rjtp;

	ASSERT(dsp != NULL);
	ASSERT(pktp != NULL);

	/* We know that we have send RLS and we have received LS_RJT */
	bnxef_big_endian(pktp->pkt_resp, 4);

	/* LINTED: alignment */
	rjtp = (la_els_rjt_t *)pktp->pkt_resp;
	ASSERT(rjtp != NULL);

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Ls RJT reason 0x%x, Expln 0x%x, VU 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		rjtp->reason, rjtp->reserved, rjtp->vu);

	pktp->pkt_reason = rjtp->reason;

	/* Set back the cmd to the original value */
	bnxef_big_endian(pktp->pkt_cmd, 8);
}

static void
bnxef_mp_prli_ls_acc_rx_handler(bnxef_driver_state_t *dsp, fc_packet_t *pktp)
{
	typedef struct __bnxef_prli_service_params__ {
		uint8_t type;
		uint8_t reserved;
		uint16_t  flags;
		uint32_t	opa;
		uint32_t	rpa;
		uint32_t	serv_params;
	} prli_service_params_t;
	prli_service_params_t  *prlisvp;
	bnxef_fcoe_task_t	*taskp;

	ASSERT(dsp != NULL);
	ASSERT(pktp != NULL);

	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: MP PRLI LS ACC received 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);

	bnxef_big_endian(pktp->pkt_resp, 4);
	/* LINTED: alignment */
	prlisvp = (prli_service_params_t *)((uint8_t *)pktp->pkt_resp + 4);
	prlisvp->flags = htons(prlisvp->flags);
	prlisvp->opa = htonl(prlisvp->opa);
	prlisvp->rpa = htonl(prlisvp->rpa);
	prlisvp->serv_params = htonl(prlisvp->serv_params);

	/* Copy back the original commmand received as we tampered that area */
	bcopy(taskp->orig_payloadp, pktp->pkt_cmd, pktp->pkt_cmdlen);

}

static void
bnxef_mp_prli_ls_rjt_rx_handler(bnxef_driver_state_t *dsp, fc_packet_t *pktp)
{

	la_els_rjt_t *rjtp;
	bnxef_fcoe_task_t *taskp;

	ASSERT(dsp != NULL);
	ASSERT(pktp != NULL);

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: MP PRLI LS RJT received",
		BNXEF_DRIVER_NAME, dsp->instance);
	/*
	 * We now know that we have sent ADISC, we have received LS_RJT
	 */
	bnxef_big_endian(pktp->pkt_resp, 4);

	/* LINTED: alignment */
	rjtp = (la_els_rjt_t *)pktp->pkt_resp;
	ASSERT(rjtp != NULL);

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Ls RJT reason 0x%x, Expln 0x%x, VU 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		rjtp->reason, rjtp->reserved, rjtp->vu);

	pktp->pkt_reason = rjtp->reason;

	/* Set back the original format of comand structure */
	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	ASSERT(taskp != NULL);
	bcopy(taskp->orig_payloadp, pktp->pkt_cmd, pktp->pkt_cmdlen);
}


static void
bnxef_mp_adisc_ls_acc_rx_handler(bnxef_driver_state_t *dsp, fc_packet_t *pktp)
{
	ASSERT(dsp != NULL);
	ASSERT(pktp != NULL);

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: MP ADISC LS ACC received ",
		BNXEF_DRIVER_NAME, dsp->instance);
	/*
	 * We know we have sent ADISC, we have received LS_ACC
	 */
	bnxef_big_endian(pktp->pkt_resp, 8);
	bnxef_big_endian(pktp->pkt_resp+24, 4);

	/* Also set back the orginal format of command structure */
	bnxef_big_endian(pktp->pkt_cmd, 8);
	bnxef_big_endian(pktp->pkt_cmd +24, 4);
}

static void
bnxef_mp_adisc_ls_rjt_rx_handler(bnxef_driver_state_t *dsp, fc_packet_t *pktp)
{

	la_els_rjt_t  *rjtp;

	ASSERT(dsp != NULL);
	ASSERT(pktp != NULL);

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: MP ADISC LS RJT received",
		BNXEF_DRIVER_NAME, dsp->instance);
	/*
	 * We now know that we have sent ADISC, we have received LS_RJT
	 */
	bnxef_big_endian(pktp->pkt_resp, 4);

	/* LINTED: alignment */
	rjtp = (la_els_rjt_t *)pktp->pkt_resp;
	ASSERT(rjtp != NULL);

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Ls RJT reason 0x%x, Expln 0x%x, VU 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		rjtp->reason, rjtp->reserved, rjtp->vu);

	pktp->pkt_reason = rjtp->reason;

	/* Set back the original format of comand structure */
	bnxef_big_endian(pktp->pkt_cmd, 8);
	bnxef_big_endian(pktp->pkt_cmd + 24, 4);
}


/*
 * THis handles the ELS Middle Path Completions.
 */
void
bnxef_handle_els_mp_completion_handler(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp, uint8_t num_rq, uint8_t rx_state)
{

	timeout_id_t	tid;
	uint32_t	flags;
	bnxef_driver_state_t *dsp;

	ASSERT(sessionp != NULL);
	ASSERT(taskp != NULL);

	dsp = ((bnxef_port_t *)sessionp->lport)->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&taskp->task_mutex);
	tid = taskp->timerhdl;
	flags = taskp->task_flags;
	mutex_exit(&taskp->task_mutex);

	if (flags & BNXEF_FCOE_TASK_TIMER_ARMED) {
		untimeout(tid);
		mutex_enter(&taskp->task_mutex);
		taskp->task_flags &= ~ BNXEF_FCOE_TASK_TIMER_ARMED;
		mutex_exit(&taskp->task_mutex);
	}
	BNXEF_DEBUG(dsp, ELS, -1, "%s%d: Timer stopped for task id 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);

	switch (rx_state) {
	case FCOE_TASK_RX_STATE_COMPLETED:
		bnxef_handle_els_mp_completion(sessionp, taskp, num_rq,
				rx_state);
		break;
	case  FCOE_TASK_RX_STATE_ABTS_COMPLETED:
		bnxef_handle_els_mp_abts_completion(sessionp, taskp);
		break;
	case  FCOE_TASK_RX_STATE_EXCHANGE_CLEANUP_COMPLETED:
		bnxef_handle_els_exch_cleanup_completion(sessionp, taskp);
		break;
	default:
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unknown Completion code 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, rx_state);
		break;
	}
}

void
bnxef_handle_els_mp_abts_completion(bnxef_session_t *sessionp,
		bnxef_fcoe_task_t *taskp)
{
	struct fcoe_task_ctx_entry	*fwtaskp;
	fc_packet_t	*pktp;
	bnxef_port_t	*portp;
	bnxef_driver_state_t	*dsp;
	uint8_t	rctl;
	bnxef_tq_params_t	*tqp;
	uint16_t	secondary_x_id;
	timeout_id_t	tid;
	bnxef_fcoe_task_t	*sectaskp;
	int	ret;

	ASSERT(sessionp != NULL);
	portp = sessionp->lport;
	ASSERT(portp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);
	fwtaskp = taskp->fwtaskp;
	ASSERT(fwtaskp != NULL);
	pktp = taskp->pktp;
	ASSERT(pktp != NULL);

	ASSERT(taskp->task_flags & BNXEF_FCOE_RECOVERY_IN_PROGRESS);
	/* This will clear the timeout started for ABTS */
	if (taskp->task_flags & BNXEF_FCOE_SEC_X_ID_VALID) {
		secondary_x_id = taskp->secondary_x_id;
		sectaskp = dsp->taskarray[secondary_x_id];
		mutex_enter(&sectaskp->task_mutex);
		tid = sectaskp->timerhdl;
		mutex_exit(&sectaskp->task_mutex);
		if (sectaskp->task_flags &  BNXEF_FCOE_TASK_TIMER_ARMED) {
			untimeout(tid);
			mutex_enter(&sectaskp->task_mutex);
			sectaskp->task_flags &= ~BNXEF_FCOE_TASK_TIMER_ARMED;
			sectaskp->task_flags |= BNXEF_FCOE_TASK_COMPLETED;
			mutex_exit(&sectaskp->task_mutex);
		}
		kmem_free(sectaskp->pktp, sizeof (fc_packet_t));
		/* Now free the secondary ID */
		bnxef_task_free((void *)dsp, sectaskp);
		mutex_enter(&taskp->task_mutex);
		taskp->task_flags &= ~BNXEF_FCOE_SEC_X_ID_VALID;
		mutex_exit(&taskp->task_mutex);
	}

	rctl = (uint8_t)fwtaskp->rxwr_only.union_ctx.comp_info.abts_rsp.r_ctl;
	if (rctl == R_CTL_LS_BA_ACC) {
		mutex_enter(&taskp->task_mutex);
		taskp->sec_flags |= BNXEF_BA_ACC_RCVD;
		mutex_exit(&taskp->task_mutex);
		/*
		 * Now make sure  you schedule a task queue routine to send
		 * RRQ for reinstating this resource for subsequent use.
		 */
		tqp = kmem_cache_alloc(dsp->tq_params_cache, KM_NOSLEEP);
		if (tqp == NULL) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unble to allocate Tq params for RRQ\n",
			BNXEF_DRIVER_NAME, dsp->instance);
			bnxef_task_session_list_remove(taskp->sessionp, taskp);
			bnxef_complete_pkt(pktp, FC_PKT_TRAN_ERROR,
				0, FC_REASON_ABORT_FAILED, 0);
		}
		tqp->dsp = dsp;
		tqp->portp = portp;
		tqp->sessp = sessionp;
		tqp->taskp = taskp;
		tqp->type = BNXEF_RRQ_SEND_REQ_TYPE;

		ret = ddi_taskq_dispatch(dsp->mtq, bnxef_send_rrq, tqp,
			DDI_NOSLEEP);
		if (ret != DDI_SUCCESS) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to dispatch Task queue from intr\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			bnxef_task_session_list_remove(taskp->sessionp,
				taskp);
			bnxef_complete_pkt(pktp, FC_PKT_TRAN_ERROR,
				0, FC_REASON_ABORT_FAILED, 0);
			return;
		}
	} else if (rctl == R_CTL_LS_BA_RJT) {
		mutex_enter(&taskp->task_mutex);
		taskp->sec_flags |= BNXEF_BA_RJT_RCVD;
		mutex_exit(&taskp->task_mutex);
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: BA_RJT Received for X-id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
		bnxef_task_session_list_remove(taskp->sessionp, taskp);
		bnxef_complete_pkt(pktp, FC_PKT_TIMEOUT,
			0, FC_REASON_ABORTED, 0);
		return;
	}

}

void
bnxef_handle_els_exch_cleanup_completion(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp)
{

	bnxef_driver_state_t *dsp;
	bnxef_port_t	*portp;
	fc_packet_t	*pktp;
	uint32_t task_flags;

	ASSERT(sessionp != NULL);
	ASSERT(taskp != NULL);

	portp = sessionp->lport;
	ASSERT(portp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&taskp->task_mutex);
		pktp = taskp->pktp;
		task_flags = taskp->task_flags;
		mutex_exit(&taskp->task_mutex);

		ASSERT(pktp != NULL);

	/* Remove this task from the session task List */
	bnxef_task_session_list_remove(sessionp, taskp);

		/* Get the packet */
		if (task_flags & BNXEF_FCOE_TASK_RRQ) {
		if (task_flags & BNXEF_FCOE_SEC_X_ID_VALID) {
			uint32_t	sec_flags;
			bnxef_fcoe_task_t *otaskp;
			fc_packet_t	  *opktp;
			otaskp = dsp->taskarray[taskp->secondary_x_id];
			opktp = otaskp->pktp;
			mutex_enter(&otaskp->task_mutex);
			// task_flags = otaskp->task_flags;
			sec_flags = otaskp->sec_flags;
			mutex_exit(&otaskp->task_mutex);
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Cleanup Completion  for RRQ id 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Completion Called for Sec id 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance, otaskp->x_id);
			if ((sec_flags & BNXEF_RRQ_TIMEDOUT)  == 0) {
				if (otaskp->sessionp != NULL) {
					bnxef_task_session_list_remove(
						otaskp->sessionp,
						otaskp);
					bnxef_complete_pkt(opktp,
						FC_PKT_TIMEOUT,
						0, FC_REASON_ABORTED, 0);
				}
			} else return;
		}
			/* Free all DMA resources allocated for RRQ */
			bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
			bnxef_pkt_resp_res_free(pktp, BNXEF_PKT_RESP_ALL);
		}

		mutex_enter(&taskp->task_mutex);
		/* Wake up the thread waiting for completion */
		cv_signal(&taskp->task_cv);
		mutex_exit(&taskp->task_mutex);

	if ((task_flags & BNXEF_FCOE_TASK_RRQ) == 0) {
		/*
		 * Now complete the packet as Local RJT  reason
		 * No connecion
		 */
		bnxef_complete_pkt(pktp, taskp->state, taskp->action,
			taskp->reason, taskp->expln);
	}

		if (task_flags & BNXEF_FCOE_TASK_RRQ) {
			kmem_free(pktp, sizeof (fc_packet_t));
			bnxef_task_free((void *)dsp, taskp);
			taskp->tq_params.reserved2 = 6;
		}


}


/*
 * This will handle the ELS middle path normalcompletions.
 */
/*ARGSUSED*/
void
bnxef_handle_els_mp_completion(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp, uint8_t num_rq, uint8_t rx_state)
{
	bnxef_driver_state_t	 *dsp;
	bnxef_port_t		*portp;
	fc_packet_t		*pktp;
	struct fcoe_task_ctx_entry *fwtaskp;
	uint64_t		*tempfp;
	fc_frame_hdr_t		fp;
	uint64_t		*lfp;
	timeout_id_t		tid;
	uint32_t		flags;
	fc_packet_t		*opktp;
	bnxef_fcoe_task_t	*otaskp;
	ls_code_t		sentels;
	ls_code_t		rxels;

	NOTE(ARGUNUSED(rx_state))
	NOTE(ARGUNUSED(num_rq))

	ASSERT(sessionp != NULL);
	ASSERT(taskp != NULL);
	pktp = taskp->pktp;
	ASSERT(pktp != NULL);
	portp = sessionp->lport;
	ASSERT(portp != NULL);
	dsp = portp->statep;

	ASSERT(dsp != NULL);

	fwtaskp = taskp->fwtaskp;
	ASSERT(fwtaskp != NULL);

	mutex_enter(&taskp->task_mutex);
	tid = taskp->timerhdl;
	flags = taskp->task_flags;
	mutex_exit(&taskp->task_mutex);

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Middle path ELS completed  0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
	/*
	 * Now that the task is complete, we should untimeout the timer
	 * if enabled.
	 */
	if (flags & BNXEF_FCOE_TASK_TIMER_ARMED)  {
		untimeout(tid);
		mutex_enter(&taskp->task_mutex);
		taskp->task_flags &= ~BNXEF_FCOE_TASK_TIMER_ARMED;
		mutex_exit(&taskp->task_mutex);
	}


	/* Now the ELS has completed and the data is available in pkt_resp */
	tempfp = (uint64_t *)
		&fwtaskp->rxwr_only.union_ctx.comp_info.mp_rsp.fc_hdr;
	lfp = (uint64_t *)&fp;
	lfp[0] = htonll(tempfp[0]);
	lfp[1] = htonll(tempfp[1]);
	lfp[2] = htonll(tempfp[2]);

	/* Now copy this to response header */
	bcopy((uint8_t *)lfp, (uint8_t *)&pktp->pkt_resp_fhdr,
		sizeof (fc_frame_hdr_t));
	ddi_dma_sync(pktp->pkt_resp_dma, 0, pktp->pkt_rsplen,
		DDI_DMA_SYNC_FORCPU);

	ddi_rep_get8(pktp->pkt_resp_acc, (uint8_t *)&rxels,
		(uint8_t *)pktp->pkt_resp, 4, DDI_DEV_AUTOINCR);
	bnxef_big_endian((uint8_t *)&rxels, 4);
	/*
	 * Now get the first few bytes from pkt_cmd_acc and
	 * check to which
	 * ELS the completion has happened
	 */
	ddi_dma_sync(pktp->pkt_cmd_dma, 0, pktp->pkt_cmdlen,
		DDI_DMA_SYNC_FORCPU);
	/* Get the ELS code for analysis from pkt_cmd field. */
	ddi_rep_get8(pktp->pkt_cmd_acc, (uint8_t *)&sentels,
		(uint8_t *)pktp->pkt_cmd, 4,  DDI_DEV_AUTOINCR);
	bnxef_big_endian((uint8_t *)&sentels, 4);
	if (rxels.ls_code == LA_ELS_ACC) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: ELS MP Completion LS_ACC",
			BNXEF_DRIVER_NAME, dsp->instance);
		switch (sentels.ls_code) {
		case LA_ELS_RLS:
			bnxef_mp_rls_ls_acc_rx_handler(dsp, pktp);
			break;
		case LA_ELS_ADISC:
			bnxef_mp_adisc_ls_acc_rx_handler(dsp, pktp);
			break;
		case LA_ELS_PRLI:
			bnxef_mp_prli_ls_acc_rx_handler(dsp, pktp);
			break;
		case LA_ELS_LOGO:
			bnxef_mp_logo_ls_acc_rx_handler(dsp, pktp);
			break;
		case LA_ELS_REC:
			bnxef_mp_rec_ls_acc_rx_handler(dsp, pktp);
			break;
		case LA_FCPLS_SRR:
			bnxef_mp_srr_ls_acc_rx_handler(dsp, pktp);
			break;
		default:
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Unknown Completion for ELS",
			BNXEF_DRIVER_NAME, dsp->instance);
		}
	} else  {
		/* LS RJT Path */
		switch (sentels.ls_code) {
		case LA_ELS_RLS:
			bnxef_mp_rls_ls_rjt_rx_handler(dsp, pktp);
			break;
		case LA_ELS_ADISC:
			bnxef_mp_adisc_ls_rjt_rx_handler(dsp, pktp);
			break;
		case LA_ELS_PRLI:
			bnxef_mp_prli_ls_rjt_rx_handler(dsp, pktp);
			break;
		case LA_ELS_LOGO:
			bnxef_mp_logo_ls_rjt_rx_handler(dsp, pktp);
			break;
		case LA_ELS_REC:
			bnxef_mp_rec_ls_rjt_rx_handler(dsp, pktp);
			break;
		case LA_FCPLS_SRR:
			bnxef_mp_srr_ls_rjt_rx_handler(dsp, pktp);
			break;
		case LA_ELS_RRQ:
			/* Do not do anything */
			break;
		default:
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Unknown completion for ELS",
				BNXEF_DRIVER_NAME, dsp->instance);
			ASSERT(0);
		}
	}


	/* Special handling for Localy generated RRQ */
	if (flags & BNXEF_FCOE_TASK_RRQ) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Completion happened for RRQ",
				BNXEF_DRIVER_NAME, dsp->instance);
		bnxef_task_session_list_remove(sessionp, taskp);
		BNXEF_TRACE_EVENT(dsp, BNXEF_SCSI_TASK_RRQ_COMPLETED,
			taskp->secondary_x_id, taskp->x_id, 0,
			sessionp, 0, 0, 0);
		/* This was a RRQ generated for ABTS completion */
		if (flags & BNXEF_FCOE_SEC_X_ID_VALID) {
			uint32_t	sec_flags, s_flags;

			otaskp = dsp->taskarray[taskp->secondary_x_id];
			opktp = otaskp->pktp;
			mutex_enter(&otaskp->task_mutex);
			// task_flags = otaskp->task_flags;
			sec_flags = otaskp->sec_flags;
			mutex_exit(&otaskp->task_mutex);
			mutex_enter(&taskp->task_mutex);
			// t_flags = taskp->task_flags;
			s_flags = taskp->sec_flags;
			mutex_exit(&taskp->task_mutex);
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Completion Called for Sec id 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance, otaskp->x_id);
			if ((sec_flags & BNXEF_RRQ_TIMEDOUT)  == 0) {
				if ((s_flags &
					BNXEF_FCOE_DROP_RRQ_PROCESSING) == 0) {
					if (otaskp->sessionp != NULL) {
						bnxef_task_session_list_remove(
							otaskp->sessionp,
							otaskp);
						bnxef_complete_pkt(opktp,
						FC_PKT_TIMEOUT,
						0, FC_REASON_ABORTED, 0);
					}
				}
			} else  {
				return;
			}

		}
		// untimeout(taskp->timerhdl);
		/* Free all DMA resources allocated for RRQ */
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		bnxef_pkt_resp_res_free(pktp, BNXEF_PKT_RESP_ALL);
		kmem_free(pktp, sizeof (fc_packet_t));
		bnxef_task_free((void *)dsp, taskp);
		taskp->tq_params.reserved2 = 7;
		return;
	}
	bnxef_task_session_list_remove(taskp->sessionp, taskp);
	pktp->pkt_resp_resid = (pktp->pkt_rsplen -
		fwtaskp->rxwr_only.union_ctx.comp_info.mp_rsp.mp_payload_len);
	if (rxels.ls_code ==  LA_ELS_ACC) {
		bnxef_complete_pkt(pktp, FC_PKT_SUCCESS, 0, 0, 0);
	} else {
		bnxef_complete_pkt(pktp, FC_PKT_LS_RJT, 0, pktp->pkt_reason, 0);
	}

	if ((flags & BNXEF_FCOE_TASK_SRR) || (flags & BNXEF_FCOE_TASK_REC)) {
		/* Free all DMA resources allocated for RRQ */
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		bnxef_pkt_resp_res_free(pktp, BNXEF_PKT_RESP_ALL);
		kmem_free(pktp, sizeof (fc_packet_t));
		// bnxef_task_free((void *)dsp, taskp);
	}

}



/*
 * THis will handle all types of SCSI command completion.
 */
void
bnxef_handle_scsi_cmd_completion(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp, uint8_t num_rq, uint8_t rx_state)
{
	timeout_id_t	tid;
	uint32_t	flags;
	bnxef_driver_state_t *dsp;

	ASSERT(sessionp != NULL);
	ASSERT(taskp != NULL);

	dsp = ((bnxef_port_t *)sessionp->lport)->statep;

	mutex_enter(&taskp->task_mutex);
	tid = taskp->timerhdl;
	flags = taskp->task_flags;
	mutex_exit(&taskp->task_mutex);

	/*
	 * Now that the task is complete, we should untimeout the timer
	 * if enabled.
	 */
	if (flags & BNXEF_FCOE_TASK_TIMER_ARMED) {
		untimeout(tid);
		mutex_enter(&taskp->task_mutex);
		taskp->task_flags &= ~BNXEF_FCOE_TASK_TIMER_ARMED;
		mutex_exit(&taskp->task_mutex);
	}

	BNXEF_DEBUG(dsp, SCSI, -1, "%s%d:Timer Stopped for task Id 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
	switch (rx_state) {
	case FCOE_TASK_RX_STATE_COMPLETED:
		bnxef_scsi_normal_completion(sessionp, taskp, num_rq);
		break;
	case FCOE_TASK_RX_STATE_ABTS_COMPLETED:
		bnxef_scsi_recovery_completion(sessionp, taskp, num_rq);
		break;
	case FCOE_TASK_RX_STATE_EXCHANGE_CLEANUP_COMPLETED:
		bnxef_scsi_exch_cleanup_completion(sessionp, taskp);
		break;
	default:
		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Unknown Completion code  0x%x for task id 0x%x\n",
		BNXEF_DRIVER_NAME, dsp->instance, rx_state, taskp->x_id);
	}
}

/*
 * This will handle the excchange cleanup request completion.
 */
void
bnxef_scsi_exch_cleanup_completion(bnxef_session_t *sessionp,
		bnxef_fcoe_task_t *taskp)
{
	bnxef_driver_state_t *dsp;
	bnxef_port_t	*portp;
	fc_packet_t	*pktp;
	uint32_t task_flags;

	ASSERT(sessionp != NULL);
	ASSERT(taskp != NULL);

	portp = sessionp->lport;
	ASSERT(portp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&taskp->task_mutex);
	pktp = taskp->pktp;
	task_flags = taskp->task_flags;
	mutex_exit(&taskp->task_mutex);

	ASSERT(pktp != NULL);

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d:Cleanup Complete Indication from fw for echange 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);

	/* Remove this task from the session task List */
	bnxef_task_session_list_remove(sessionp, taskp);

	BNXEF_TRACE_EVENT(dsp, BNXEF_SCSI_TASK_CLEANUP_COMP,
		taskp->x_id, -1, 0, sessionp, 0, 0, 0);

	/* Get the packet */
	if (task_flags & BNXEF_FCOE_TASK_RRQ) {
		/* Free all DMA resources allocated for RRQ */
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		bnxef_pkt_resp_res_free(pktp, BNXEF_PKT_RESP_ALL);
	}

	mutex_enter(&taskp->task_mutex);
	/* Wake up the thread waiting for completion */
	cv_signal(&taskp->task_cv);
	mutex_exit(&taskp->task_mutex);

	/*
	 * Now complete the packet as Local RJT  reason
	 * No connecion
	 */
	bnxef_complete_pkt(pktp, taskp->state, taskp->action,
		taskp->reason, taskp->expln);
	if (task_flags & BNXEF_FCOE_TASK_RRQ) {
		kmem_free(pktp, sizeof (fc_packet_t));
		bnxef_task_free((void *)dsp, taskp);
	}

}

#if 0
uint32_t global_prof_count = 0;
#endif
/*
 * The following routine will handle the normal SCSI completion.
 * This will also handle SCSI commands which fails by providing the sense
 * information. This completion routine is also used by Task management
 * scsi commands, for which the completion is indicated by response code in
 * fcp_response.
 */
void
bnxef_scsi_normal_completion(bnxef_session_t *sessionp,
		bnxef_fcoe_task_t *taskp, uint8_t num_rq)
{
	struct fcoe_task_ctx_entry *fwtaskp;
	struct fcoe_fcp_rsp_payload *fwrsp;
	fcp_rsp_t	fcprsp;
	fc_packet_t	*pktp;
	uint8_t		*rqep;
	int		 i;
	bnxef_port_t	 *portp;
	bnxef_driver_state_t *dsp;

	ASSERT(sessionp != NULL);
	ASSERT(taskp != NULL);

	portp = sessionp->lport;
	ASSERT(portp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	fwtaskp = taskp->fwtaskp;
	pktp = taskp->pktp;
	ddi_dma_sync(dsp->task_dma_handle[taskp->dma_handle_idx],
		(taskp->x_id %32) * sizeof (struct fcoe_task_ctx_entry),
		sizeof (struct fcoe_task_ctx_entry),
		DDI_DMA_SYNC_FORCPU);

	ASSERT(fwtaskp != NULL);
	fwrsp = (struct fcoe_fcp_rsp_payload *)
		&(fwtaskp->rxwr_only.union_ctx.comp_info.fcp_rsp.payload);
	/* Call a ddi DMA sync here */

	ASSERT(fwrsp != NULL);
	memset((uint8_t *)&fcprsp, 0, sizeof (fcp_rsp_t));
	fcprsp.fcp_u.fcp_status.rsp_len_set =
	(fwrsp->fcp_flags.flags & FCOE_FCP_RSP_FLAGS_FCP_RSP_LEN_VALID)?1:0;
	fcprsp.fcp_u.fcp_status.sense_len_set =
	(fwrsp->fcp_flags.flags & FCOE_FCP_RSP_FLAGS_FCP_SNS_LEN_VALID)? 1:0;
	fcprsp.fcp_u.fcp_status.resid_over =
	(fwrsp->fcp_flags.flags & FCOE_FCP_RSP_FLAGS_FCP_RESID_OVER)? 1:0;
	fcprsp.fcp_u.fcp_status.resid_under =
	(fwrsp->fcp_flags.flags & FCOE_FCP_RSP_FLAGS_FCP_RESID_UNDER)?1:0;
	fcprsp.fcp_u.fcp_status.scsi_status =  fwrsp->scsi_status_code;

	fcprsp.fcp_resid = LE32_TO_CPU(fwrsp->fcp_resid);
	fcprsp.fcp_response_len = LE32_TO_CPU(fwrsp->fcp_rsp_len);
	fcprsp.fcp_sense_len = LE32_TO_CPU(fwrsp->fcp_sns_len);

	ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)&fcprsp,
		(uint8_t *)pktp->pkt_resp, sizeof (fcp_rsp_t),
			DDI_DEV_AUTOINCR);

	BNXEF_DEBUG(dsp, SCSI,  -1,
	"%s%d:Task Id 0x%x, SCSI status 0x%x, resid 0x%x, \
		response_len 0x%x, sense_len 0x%x\
			flags 0x%x sense_len_set 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id,
		fcprsp.fcp_u.fcp_status.scsi_status,
		fcprsp.fcp_resid, fcprsp.fcp_response_len,
		fcprsp.fcp_sense_len, fwrsp->fcp_flags.flags,
		fcprsp.fcp_u.fcp_status.sense_len_set);

	if (fcprsp.fcp_u.fcp_status.scsi_status == 0) {
		BNXEF_STATS(dsp, successfull_scsi_cmds);
		BNXEF_TRACE_EVENT(dsp, BNXEF_SCSI_TASK_COMPLETE,
			taskp->x_id, -1, 0, sessionp, 0, 0, 0);
	} else  {
		BNXEF_STATS(dsp, errored_scsi_cmds);
		BNXEF_TRACE_EVENT(dsp, BNXEF_SCSI_TASK_SENSE_COMPLETED,
			taskp->x_id, -1, 0, sessionp, fcprsp.fcp_resid,
			fcprsp.fcp_u.fcp_status.scsi_status, 0);
		BNXEF_DEBUG(dsp, SCSI,  -1,
	"%s%d:Task Id 0x%x, SCSI status 0x%x, resid 0x%x, response_len 0x%x,\
			sense_len 0x%x  flags 0x%x sense_len_set 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id,
		fcprsp.fcp_u.fcp_status.scsi_status,
		fcprsp.fcp_resid, fcprsp.fcp_response_len,
		fcprsp.fcp_sense_len, fwrsp->fcp_flags.flags,
		fcprsp.fcp_u.fcp_status.sense_len_set);
	}

	/* Now copy the Response information and sense information */
	if (num_rq) {
		BNXEF_DEBUG(dsp, SCSI, -1, "%s%d: Num RQ is 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, num_rq);
		if ((fcprsp.fcp_sense_len + fcprsp.fcp_response_len) >
			num_rq * BNXEF_RQ_BUF_SIZE) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Wrong length provided \n",
				BNXEF_DRIVER_NAME, dsp->instance);
		}

		rqep = bnxef_get_next_rqe(sessionp, 1);
		(void) ddi_dma_sync(sessionp->rq_dma_handle, 0,
			BNXEF_RQ_BUF_SIZE, DDI_DMA_SYNC_FORCPU);
		/*
		 * Since out RQ buffer size is  1024, we donot have to
		 * worry about handling data spanning accross the RQ entries.
		 */
		if (fcprsp.fcp_u.fcp_status.rsp_len_set) {
			ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)rqep,
			(uint8_t *)pktp->pkt_resp + sizeof (fcp_rsp_t),
			fcprsp.fcp_response_len, DDI_DEV_AUTOINCR);
		}

		if (fcprsp.fcp_u.fcp_status.sense_len_set) {
			BNXEF_DEBUG(dsp, SCSI, -1,
				"%s%d: Copying the Sense Data properly",
				BNXEF_DRIVER_NAME, dsp->instance);
			ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)(rqep +
				fcprsp.fcp_response_len),
			(uint8_t *) (pktp->pkt_resp + sizeof (fcp_rsp_t) +
				fcprsp.fcp_response_len),
				fcprsp.fcp_sense_len, DDI_DEV_AUTOINCR);
		}

		if (num_rq > 1) {
			BNXEF_DEBUG(dsp, SCSI, portp->id,
			"%s%d,: num_rq should ebe 1 in our implementation\n",
			BNXEF_DRIVER_NAME, dsp->instance);

			for (i = 1; i < num_rq; i++)
				(void) bnxef_get_next_rqe(sessionp, 1);
		}
		bnxef_return_rqe(sessionp, num_rq);
	}


	if (sessionp != NULL) {
		mutex_enter(&taskp->task_mutex);
		taskp->tq_params.reserved1 = 1;
		mutex_exit(&taskp->task_mutex);
		bnxef_task_session_list_remove(sessionp, taskp);
	}

	if (taskp->task_flags & BNXEF_FCOE_RECOVERY_IN_PROGRESS) {
		if (taskp->sec_flags == BNXEF_ABTS_INITIATED) {
			bnxef_fcoe_task_t *sectaskp;
			timeout_id_t tid;
			uint32_t sectask_flags;
		//	cmn_err(CE_NOTE,
		//	"ABTS sent out but completion happend 0x%x",
		//		taskp->x_id);
			BNXEF_TRACE_EVENT(dsp, BNXEF_SCSI_TASK_COMP_WHILE_RECOV,
				taskp->x_id, taskp->secondary_x_id, 0,
				sessionp, taskp->sec_flags, 0, 0);
			if (taskp->task_flags & BNXEF_FCOE_SEC_X_ID_VALID) {
				sectaskp =
					dsp->taskarray[taskp->secondary_x_id];
				mutex_enter(&sectaskp->task_mutex);
				tid = sectaskp->timerhdl;
				sectask_flags = sectaskp->task_flags;
				mutex_exit(&sectaskp->task_mutex);
				if (sectask_flags &
					BNXEF_FCOE_TASK_TIMER_ARMED) {
					untimeout(tid);
					mutex_enter(&sectaskp->task_mutex);
					sectaskp->task_flags &=
						~BNXEF_FCOE_TASK_TIMER_ARMED;
					sectaskp->task_flags |=
						BNXEF_FCOE_TASK_COMPLETED;
					mutex_exit(&sectaskp->task_mutex);
				}
				mutex_enter(&taskp->task_mutex);
				taskp->task_flags &= ~BNXEF_FCOE_SEC_X_ID_VALID;
				mutex_exit(&taskp->task_mutex);
				bnxef_task_free((void *)dsp, sectaskp);
			}
		} else
			cmn_err(CE_PANIC, "Got it - Recovery");
	}

	pktp->pkt_resp_resid = 0;
	pktp->pkt_data_resid = fcprsp.fcp_resid;

	memset((uint8_t *)taskp->fwtaskp, 0,
			sizeof (struct fcoe_task_ctx_entry));
	taskp->end_lbolt = ddi_get_lbolt();

#if 0
	ticks = taskp->end_lbolt - taskp->start_lbolt;
	if (ticks >= drv_usectohz(130*1000)) {
		cmn_err(CE_NOTE,
		"ticks 0x%x, Posting 0x%x, Post to Indicate 0x%x,\
			Indicate to comp 0x%x task id 0x%x",
		ticks,
		(taskp->post_lbolt - taskp->start_lbolt),
		(taskp->indicate_lbolt - taskp->post_lbolt),
		(taskp->end_lbolt - taskp->indicate_lbolt), taskp->x_id);
		global_prof_count++;
		if (global_prof_count == 5) {
			dev_info_t *pdip;
			pdip = ddi_get_parent(dsp->dip);
			if (!dsp->callbacks.prvCtl(pdip, PRV_CTL_QUERY_PARAMS,
				(void *)&dsp->bnxe_params,
				sizeof (BnxeFcoeInfo))) {
				cmn_err(CE_WARN,
				"%s%d: Unable to get the Params from Bnxe",
				BNXEF_DRIVER_NAME, dsp->instance);
			}

			debug_enter("Got it");
		}
	}
#endif

	/* Now complete the pkt */
	bnxef_complete_pkt(pktp, FC_PKT_SUCCESS, 0, 0, 0);

}


/*
 * The following handles the scsi recovery completion for the task under
 * question. This indicates that BA_ACC has been received or BA_RJT has been
 * received. We have to decide whether to send RRQ after RA_TOV time and
 * schedule such sending of RRQ to the device.
 */
/*ARGSUSED*/
void
bnxef_scsi_recovery_completion(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp, int num_rq)
{
	struct fcoe_task_ctx_entry 	*fwtaskp;
	fc_packet_t			 *pktp;
	bnxef_port_t			*portp;
	bnxef_driver_state_t		*dsp;
	uint8_t				rctl;
	bnxef_tq_params_t		*tqp;
	uint16_t			secondary_x_id;
	timeout_id_t			tid;
	bnxef_fcoe_task_t		*sectaskp;
	int				ret;

	NOTE(ARGUNUSED(num_rq))

	ASSERT(sessionp != NULL);
	portp = sessionp->lport;
	ASSERT(portp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);
	fwtaskp = taskp->fwtaskp;
	ASSERT(fwtaskp != NULL);
	pktp = taskp->pktp;
	ASSERT(pktp != NULL);

	ASSERT(taskp->task_flags & BNXEF_FCOE_RECOVERY_IN_PROGRESS);

	if (taskp->task_flags & BNXEF_FCOE_SEC_X_ID_VALID) {
		secondary_x_id = taskp->secondary_x_id;
		sectaskp = dsp->taskarray[secondary_x_id];
		mutex_enter(&sectaskp->task_mutex);
		tid = sectaskp->timerhdl;
		mutex_exit(&sectaskp->task_mutex);

		if (sectaskp->task_flags &  BNXEF_FCOE_TASK_TIMER_ARMED) {
			untimeout(tid);
			mutex_enter(&sectaskp->task_mutex);
			sectaskp->task_flags &= ~BNXEF_FCOE_TASK_TIMER_ARMED;
			sectaskp->task_flags |= BNXEF_FCOE_TASK_COMPLETED;
			mutex_exit(&sectaskp->task_mutex);
		}
		kmem_free(sectaskp->pktp, sizeof (fc_packet_t));
		BNXEF_TRACE_EVENT(dsp, BNXEF_SCSI_TASK_ABTS_TASK_FREED,
			taskp->x_id, taskp->secondary_x_id, 0, sessionp,
				0, 0, 0);
		/* Now free the secondary ID */
		bnxef_task_free((void *)dsp, sectaskp);
		mutex_enter(&taskp->task_mutex);
		taskp->task_flags &= ~BNXEF_FCOE_SEC_X_ID_VALID;
		mutex_exit(&taskp->task_mutex);
	}


	rctl = (uint8_t)fwtaskp->rxwr_only.union_ctx.comp_info.abts_rsp.r_ctl;
	if (rctl == R_CTL_LS_BA_ACC) {
		mutex_enter(&taskp->task_mutex);
		taskp->sec_flags |= BNXEF_BA_ACC_RCVD;
		mutex_exit(&taskp->task_mutex);
		BNXEF_TRACE_EVENT(dsp, BNXEF_SCSI_TASK_BAACC_RECVD,
			taskp->x_id, taskp->secondary_x_id, 0,
			sessionp, 0, 0, 0);
		/*
		 * Now make sure  you schedule a task queue routine to send
		 * RRQ reinstating this resource for subsequent use.
		 */
		tqp = kmem_cache_alloc(dsp->tq_params_cache, KM_SLEEP);
		if (tqp == NULL) {
			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unble to allocate Tq params for RRQ\n",
			BNXEF_DRIVER_NAME, dsp->instance);
			taskp->tq_params.reserved1 = 3;
			bnxef_task_session_list_remove(taskp->sessionp, taskp);
			bnxef_complete_pkt(pktp, FC_PKT_TRAN_ERROR,
				0, FC_REASON_ABORT_FAILED, 0);
			return;
		}
		tqp->dsp = dsp;
		tqp->portp = portp;
		tqp->sessp = sessionp;
		tqp->taskp = taskp;
		tqp->type = BNXEF_RRQ_SEND_REQ_TYPE;

		ret = ddi_taskq_dispatch(dsp->mtq, bnxef_send_rrq, tqp,
				DDI_SLEEP);
		if (ret != DDI_SUCCESS) {
			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to dispatch Task queue from intr\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			taskp->tq_params.reserved1 = 2;
			bnxef_task_session_list_remove(taskp->sessionp,
					taskp);
			bnxef_complete_pkt(pktp, FC_PKT_TRAN_ERROR,
				0, FC_REASON_ABORT_FAILED, 0);
			return;
		}
	} else if (rctl == R_CTL_LS_BA_RJT) {
		mutex_enter(&taskp->task_mutex);
		taskp->sec_flags |= BNXEF_BA_RJT_RCVD;
		mutex_exit(&taskp->task_mutex);
		BNXEF_TRACE_EVENT(dsp, BNXEF_SCSI_TASK_BARJT_RECVD,
			taskp->x_id, taskp->secondary_x_id, 0,
			sessionp, 0, 0, 0);
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: BA_RJT Received for X-id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
		taskp->tq_params.reserved1 = 4;
		bnxef_task_session_list_remove(taskp->sessionp, taskp);
		bnxef_complete_pkt(pktp, FC_PKT_TRAN_ERROR,
			0, FC_REASON_ABORTED, 0);
		return;
	}

}

/*
 * This indicates whether the offload request completed successfully or not.
 */
void
bnxef_ofld_completion(bnxef_driver_state_t *dsp, struct fcoe_kcqe *kcqep)
{
	bnxef_session_t	 *sessionp;
	uint16_t		conn_id;
	int			ret;

	ASSERT(dsp != NULL);
	ASSERT(kcqep != NULL);

	conn_id = LE32_TO_CPU(kcqep->fcoe_conn_id);
	ASSERT(conn_id < BNXEF_MAX_SESSIONS_SUPPORTED);
	sessionp = dsp->sessp[conn_id];

	ASSERT(sessionp != NULL);

	BNXEF_DEBUG(dsp, GENERAL, -1, "%s%d:Offload Complete with 0x%x\n",
		BNXEF_DRIVER_NAME, dsp->instance,
		LE32_TO_CPU(kcqep->completion_status));
	BNXEF_TRACE_EVENT(dsp, BNXEF_SESSION_OFFLOAD_COMP,
		-1, -1, 0, sessionp, LE32_TO_CPU(kcqep->completion_status),
		0, 0);
	if (LE32_TO_CPU(kcqep->completion_status)) {
		BNXEF_DEBUG(dsp, ERROR, ((bnxef_port_t *)sessionp->lport)->id,
		"%s%d: Error Offloading connection between 0x%x and 0x%x\n",
			BNXEF_DRIVER_NAME, dsp->instance,
			((bnxef_port_t *)sessionp->lport)->id,
			((bnxef_port_t *)sessionp->rport)->id);
		mutex_enter(&sessionp->session_mutex);
		sessionp->session_req_error =
			LE32_TO_CPU(kcqep->completion_status);
		cv_signal(&sessionp->session_cv);
		mutex_exit(&sessionp->session_mutex);
		return;
	}

	mutex_enter(&sessionp->session_mutex);
	sessionp->context_id = LE32_TO_CPU(kcqep->fcoe_conn_context_id);
	mutex_exit(&sessionp->session_mutex);

	/* Now calculate the door bell register address and store it */
	ret = bnxef_door_bell_bar_map(dsp, sessionp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_DEBUG(dsp, GENERAL, -1,
		"%s%d:Unable to map the door bell register for session 0x%p",
			BNXEF_DRIVER_NAME, dsp->instance);
	}


	BNXEF_DEBUG(dsp, GENERAL, -1, "%s%d: Doorbel Reg 0x%p",
		BNXEF_DRIVER_NAME, dsp->instance, sessionp->doorbell_reg);
	mutex_enter(&sessionp->session_mutex);
	cv_signal(&sessionp->session_cv);
	mutex_exit(&sessionp->session_mutex);
}

/*
 * This will handle the CQE which indicates the status for enable connection
 * request.
 */
void
bnxef_enable_connection_completion(bnxef_driver_state_t *dsp,
		struct fcoe_kcqe *kcqep)
{
	uint32_t		context_id;
	bnxef_session_t	 *sessionp;
	uint16_t		conn_id;

	ASSERT(dsp != NULL);
	ASSERT(kcqep != NULL);

	conn_id = LE32_TO_CPU(kcqep->fcoe_conn_id);
	ASSERT(conn_id < BNXEF_MAX_SESSIONS_SUPPORTED);
	sessionp = dsp->sessp[conn_id];

	context_id = LE32_TO_CPU(kcqep->fcoe_conn_context_id);
	ASSERT(sessionp != NULL);

	BNXEF_DEBUG(dsp, GENERAL, -1,
		"%s%d: Enable Completion for conn_id 0x%x, context_id 0x%x\n",
		BNXEF_DRIVER_NAME, dsp->instance, conn_id, context_id);
	BNXEF_DEBUG(dsp, GENERAL, -1,
		"%s%d: Enable Completion Session context_id 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, sessionp->context_id);
	if (sessionp->context_id != context_id) {
		BNXEF_DEBUG(dsp, ERROR, ((bnxef_port_t *)sessionp->lport)->id,
		"%s%d: Error Enabling connection between 0x%x and 0x%x -\
				context id mismatch\n",
			BNXEF_DRIVER_NAME, dsp->instance,
			((bnxef_port_t *)sessionp->lport)->id,
			((bnxef_port_t *)sessionp->rport)->id);
		mutex_enter(&sessionp->session_mutex);
		sessionp->session_req_error = BNXEF_CONTEXT_ID_MISMATCH;
		mutex_exit(&sessionp->session_mutex);
	}
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Completion Status for Enable Connection 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		LE32_TO_CPU(kcqep->completion_status));
	BNXEF_TRACE_EVENT(dsp, BNXEF_SESSION_ENABLE_COMP,
		-1, -1, 0, sessionp, LE32_TO_CPU(kcqep->completion_status),
		0, 0);
	if (LE32_TO_CPU(kcqep->completion_status)) {
		BNXEF_DEBUG(dsp, GENERAL, ((bnxef_port_t *)sessionp->lport)->id,
		"%s%d: Error enabling connection between 0x%x and 0x%x\n",
			BNXEF_DRIVER_NAME, dsp->instance,
			((bnxef_port_t *)sessionp->lport)->id,
			((bnxef_port_t *)sessionp->rport)->id);
		mutex_enter(&sessionp->session_mutex);
		sessionp->session_req_error =
			LE32_TO_CPU(kcqep->completion_status);
		mutex_exit(&sessionp->session_mutex);
	}

	BNXEF_DEBUG(dsp, GENERAL, -1,
		"%s%d: Signaling Completion for Enable Connection",
		BNXEF_DRIVER_NAME, dsp->instance);
	mutex_enter(&sessionp->session_mutex);
	cv_signal(&sessionp->session_cv);
	mutex_exit(&sessionp->session_mutex);
}

void
bnxef_fw_stat_completion(bnxef_driver_state_t *dsp, struct fcoe_kcqe *kcqep)
{
	ASSERT(dsp != NULL);
	ASSERT(kcqep != NULL);


	if (LE32_TO_CPU(kcqep->completion_status) ==
		FCOE_KCQE_COMPLETION_STATUS_SUCCESS) {
		struct fcoe_statistics_params *fwstatsp;
		uint32_t val;

		BNXEF_DEBUG(dsp, GENERAL, -1,
			"%s%d: Stat Req Successfully completed",
			BNXEF_DRIVER_NAME, dsp->instance);
		ddi_dma_sync(dsp->stats_dma_handle, 0, dsp->stats_size,
				DDI_DMA_SYNC_FORCPU);
		/* LINTED: alignment */
		fwstatsp = (struct fcoe_statistics_params *)dsp->stats_buffer;
		ASSERT(fwstatsp != NULL);

		/* Now add all the returned stats to kstats */
		val = LE32_TO_CPU(fwstatsp->tx_stat.fcoe_tx_pkt_cnt);
		BNXEF_STATS_ADD(dsp, tx_stat, fcoe_tx_pkt_cnt, val);
		val = LE32_TO_CPU(fwstatsp->tx_stat.fcoe_tx_byte_cnt);
		BNXEF_STATS_ADD(dsp, tx_stat, fcoe_tx_byte_cnt, val);
		val = LE32_TO_CPU(fwstatsp->tx_stat.fcoe_tx_pkt_cnt);
		BNXEF_STATS_ADD(dsp, tx_stat, fcoe_tx_pkt_cnt, val);

		val = LE32_TO_CPU(fwstatsp->rx_stat1.fcoe_ver_cnt);
		BNXEF_STATS_ADD(dsp, rx_stat1, fcoe_ver_cnt, val);
		val = LE32_TO_CPU(fwstatsp->rx_stat2.fcoe_rx_drop_pkt_cnt);
		BNXEF_STATS_ADD(dsp, rx_stat2, fcoe_rx_drop_pkt_cnt, val);
		val = LE32_TO_CPU(fwstatsp->rx_stat1.fcoe_rx_drop_pkt_cnt);
		BNXEF_STATS_ADD(dsp, rx_stat1, fcoe_rx_drop_pkt_cnt, val);
		val = LE32_TO_CPU(fwstatsp->rx_stat0.fcoe_rx_pkt_cnt);
		BNXEF_STATS_ADD(dsp, rx_stat0, fcoe_rx_pkt_cnt, val);
		val = LE32_TO_CPU(fwstatsp->rx_stat0.fcoe_rx_byte_cnt);
		BNXEF_STATS_ADD(dsp, rx_stat0, fcoe_rx_byte_cnt, val);
		val = LE32_TO_CPU(fwstatsp->rx_stat2.fc_crc_cnt);
		BNXEF_STATS_ADD(dsp, rx_stat2, fc_crc_cnt, val);
		val = LE32_TO_CPU(fwstatsp->rx_stat2.eofa_del_cnt);
		BNXEF_STATS_ADD(dsp, rx_stat2, eofa_del_cnt, val);
		val = LE32_TO_CPU(fwstatsp->rx_stat2.miss_frame_cnt);
		BNXEF_STATS_ADD(dsp, rx_stat2, miss_frame_cnt, val);
		val = LE32_TO_CPU(fwstatsp->rx_stat2.seq_timeout_cnt);
		BNXEF_STATS_ADD(dsp, rx_stat2, seq_timeout_cnt, val);
		val = LE32_TO_CPU(fwstatsp->rx_stat2.drop_seq_cnt);
		BNXEF_STATS_ADD(dsp, rx_stat2, drop_seq_cnt, val);
		val = LE32_TO_CPU(fwstatsp->rx_stat2.fcoe_rx_drop_pkt_cnt);
		BNXEF_STATS_ADD(dsp, rx_stat2, fcoe_rx_drop_pkt_cnt, val);
		bcopy(dsp->stats_buffer, &dsp->prevstats,
			sizeof (struct fcoe_statistics_params));
	} else {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Stats Request failed",
			BNXEF_DRIVER_NAME, dsp->instance);
	}
	/* This will signal stats has completed */
	mutex_enter(&dsp->state_mutex);
	cv_signal(&dsp->stats_cv);
	mutex_exit(&dsp->state_mutex);

}

/*
 * This indicates the completion status for the firmware init request issued.
 */
void
bnxef_fw_init_completion(bnxef_driver_state_t *dsp, struct fcoe_kcqe *kcqep)
{

	ASSERT(dsp != NULL);
	ASSERT(kcqep != NULL);

	BNXEF_DEBUG(dsp, ERROR, -1, " %s%d: Init completion Received %d",
		BNXEF_DRIVER_NAME, dsp->instance,
		LE32_TO_CPU(kcqep->completion_status));

	if (LE32_TO_CPU(kcqep->completion_status) !=
		FCOE_KCQE_COMPLETION_STATUS_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: Fw init request failed\n",
			BNXEF_DRIVER_NAME, dsp->instance);
	}
	BNXEF_DEBUG(dsp, GENERAL, -1, " %s%d: Init completion Received",
		BNXEF_DRIVER_NAME, dsp->instance);
	mutex_enter(&dsp->fw_init_mutex);
	dsp->fw_init_error = LE32_TO_CPU(kcqep->completion_status);
	cv_signal(&dsp->fw_init_cond);
	mutex_exit(&dsp->fw_init_mutex);

}


/*
 * This handles the completion indicated for the fw destroy request.
 */
void
bnxef_fw_destroy_completion(bnxef_driver_state_t *dsp, struct fcoe_kcqe *kcqep)
{

	ASSERT(dsp != NULL);
	ASSERT(kcqep != NULL);


	BNXEF_TRACE_EVENT(dsp, BNXEF_SESSION_DESTROY_COMP,
		-1, -1, 0, 0,
		LE32_TO_CPU(kcqep->completion_status), 0, 0);
	if (LE32_TO_CPU(kcqep->completion_status) !=
		FCOE_KCQE_COMPLETION_STATUS_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: fw destroy request failed\n",
			BNXEF_DRIVER_NAME, dsp->instance);
	}
	mutex_enter(&dsp->fw_init_mutex);
	dsp->fw_init_error = LE32_TO_CPU(kcqep->completion_status);
	cv_signal(&dsp->fw_init_cond);
	mutex_exit(&dsp->fw_init_mutex);
}

/*
 * This handles the completion for the disable connection request sent.
 */
void
bnxef_disable_connection_completion(bnxef_driver_state_t *dsp,
	struct fcoe_kcqe *kcqep)
{
	uint32_t		 conn_id;
	bnxef_session_t	 *sessionp;

	ASSERT(dsp != NULL);
	ASSERT(kcqep != NULL);

	conn_id = LE32_TO_CPU(kcqep->fcoe_conn_id);
	ASSERT(conn_id <= BNXEF_MAX_SESSIONS_SUPPORTED);
	sessionp = dsp->sessp[conn_id];
	ASSERT(sessionp != NULL);

	BNXEF_TRACE_EVENT(dsp, BNXEF_SESSION_DISABLE_COMP,
		-1, -1, 0, sessionp,
		LE32_TO_CPU(kcqep->completion_status),
		0, 0);
	if (LE32_TO_CPU(kcqep->completion_status)) {
		BNXEF_DEBUG(dsp, ERROR, ((bnxef_port_t *)sessionp->lport)->id,
		"%s%d: Error disabling connection between 0x%x and 0x%x\n",
			BNXEF_DRIVER_NAME, dsp->instance,
			((bnxef_port_t *)sessionp->lport)->id,
			((bnxef_port_t *)sessionp->rport)->id);
		mutex_enter(&sessionp->session_mutex);
		sessionp->session_req_error =
			LE32_TO_CPU(kcqep->completion_status);
		mutex_exit(&sessionp->session_mutex);
	}

	mutex_enter(&sessionp->session_mutex);
	cv_signal(&sessionp->session_cv);
	mutex_exit(&sessionp->session_mutex);

}

void
bnxef_destroy_connection_completion(bnxef_driver_state_t *dsp,
	struct fcoe_kcqe *kcqep)
{
	uint32_t		 conn_id;
	bnxef_session_t	 *sessionp;
	int			ret;

	ASSERT(dsp != NULL);
	ASSERT(kcqep != NULL);

	conn_id = LE32_TO_CPU(kcqep->fcoe_conn_id);
	ASSERT(conn_id < BNXEF_MAX_SESSIONS_SUPPORTED);
	sessionp = dsp->sessp[conn_id];
	ASSERT(sessionp != NULL);

	if (LE32_TO_CPU(kcqep->completion_status)) {
		BNXEF_DEBUG(dsp, ERROR, ((bnxef_port_t *)sessionp->lport)->id,
		"%s%d: Error destroy connection between 0x%x and 0x%x\n",
			BNXEF_DRIVER_NAME, dsp->instance,
			((bnxef_port_t *)sessionp->lport)->id,
			((bnxef_port_t *)sessionp->rport)->id);
		mutex_enter(&sessionp->session_mutex);
		sessionp->session_req_error =
			LE32_TO_CPU(kcqep->completion_status);
		mutex_exit(&sessionp->session_mutex);
	} else {
		/* Now unmap the door bell register address */
		ret = bnxef_door_bell_bar_unmap(dsp, sessionp);
		if (ret != BNXEF_SUCCESS) {
			BNXEF_DEBUG(dsp, GENERAL, -1,
				"%s%d:Unable to unmap the door bell register\
				for session 0x%p",
				BNXEF_DRIVER_NAME, dsp->instance);
		}
	}

	mutex_enter(&sessionp->session_mutex);
	cv_signal(&sessionp->session_cv);
	mutex_exit(&sessionp->session_mutex);

}

/*
 * This handles other errors indicated from firmware.
 */
void
bnxef_process_fcoe_error(bnxef_driver_state_t *dsp, struct fcoe_kcqe *kcqep)
{

	ASSERT(dsp != NULL);
	ASSERT(kcqep != NULL);

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Error Reported ",
		BNXEF_DRIVER_NAME, dsp->instance);

}
