/*
 * The information contained in this file is confidential and proprietary to
 * Broadcom Corporation.  No part of this file may be reproduced or
 * distributed, in any form or by any means for any purpose, without the
 * express written permission of Broadcom Corporation.
 *
 * (c) COPYRIGHT 2010-2012 Broadcom Corporation, ALL RIGHTS RESERVED.
 */

#pragma ident "(C) 2010-2012 Broadcom Corporation"
#pragma ident " $File$$Revision$$Change$$DateTime$"

#include <sys/conf.h>
#include <sys/ddi.h>
#include <sys/stat.h>
#include <sys/pci.h>
#include <sys/sunddi.h>
#include <sys/modctl.h>
#include <sys/cmn_err.h>
#include <sys/file.h>
#include <sys/cred.h>
#include <sys/byteorder.h>
#include <sys/atomic.h>
#include <sys/scsi/scsi.h>
#include <sys/modhash.h>
#include <sys/sunldi.h>
#include <sys/kstat.h>
#include <sys/kmem.h>
#include <sys/ethernet.h>
#include <sys/stream.h>
#include <sys/sunldi.h>
#include <note.h>
/*
 * leadville header files
 */
#include <sys/fibre-channel/fc_types.h>
#include <sys/fibre-channel/impl/fc_fcaif.h>
#include <bnxe_binding.h>
#include <bnxef_tq_param.h>
#include <bnxef_fcf_info.h>
#include <bnxef_hsi.h>
#include <bnxef_fcoe_task.h>
#include <bnxef_fcoe_session.h>
#include <bnxef_state.h>
#include <bnxef_fip.h>
#include <bnxef_fcoe.h>
#include <bnxef_debug.h>

#define	C_TRUE (1 == 1)

/* prototypes */
extern void  * bnxef_state;
extern void bnxef_fip_tq_handler(void * paramsp);
extern void bnxef_fip_disc_adv_enforce(void *arg);
extern void bnxef_select_fcf(bnxef_driver_state_t *dsp);
extern void bnxef_trigger_fp_attach(void *arg);
extern void bnxef_big_endian(void *bufp, int size);
extern bnxef_fcf_info_t *bnxef_fcf_list_find_mac_addr(
			bnxef_driver_state_t *dsp, uint8_t *mac_addr);
extern void bnxef_fc_port_offline(void *arg);
extern void bnxef_fc_port_online(void *arg);
extern void bnxef_fc_port_reset(void *arg);
extern void bnxef_cleanup_port(bnxef_port_t *portp);
extern void bnxef_shutdown_port(bnxef_port_t *portp);
extern uint8_t all_fcf_mac[];
extern boolean_t bnxef_bringup_all_ports(bnxef_driver_state_t *dsp);
extern uint8_t bnxef_session_gen_hash(int16_t vlan_id,
	uint32_t d_id, uint8_t *macaddr);
extern int bnxef_session_list_add(bnxef_port_t *portp,
	bnxef_session_t *sessionp,
	uint8_t hashbucket);
extern mblk_t *
bnxef_prep_mblk_fip_ls_rjt(bnxef_driver_state_t *dsp, bnxef_lport_t *portp,
	uint16_t ox_id, uint32_t s_id);
extern  mblk_t *
bnxef_prep_mblk_fip_ls_acc(bnxef_driver_state_t *dsp, bnxef_lport_t *portp,
	uint16_t ox_id);



boolean_t bnxef_send_frame(bnxef_driver_state_t  *dsp, mblk_t *mp,
	uint16_t vlan_id);
int bnxef_fip_discover_prot_handler(bnxef_driver_state_t *dsp, mblk_t *mp,
		int flags);
int bnxef_fip_vlan_prot_handler(bnxef_driver_state_t *dsp, mblk_t *mp,
		int flags);
void bnxef_fip_vlink_maintenance_prot_handler(void *params);
int bnxef_fip_vlink_prot_handler(bnxef_driver_state_t *bnxef, mblk_t *mp,
	int flags);
void bnxef_fip_sm_send_disc_sol(void * arg);
int bnxef_fip_sm_send_flogi_fdisc(bnxef_driver_state_t *dsp, uint8_t opcode,
	uint16_t ox_id, uint8_t *port_name, uint8_t *node_name);
int bnxef_fip_rx_handler(dev_info_t *dip, mblk_t *mp, int flags);
int bnxef_port_get_id(bnxef_port_t *portp, int cmd);
void
bnxef_create_rport_session(bnxef_lport_t *portp, fc_frame_hdr_t *fhp,
		la_els_logi_t *plogi_infop,
		struct ether_header *etherp);
extern void bnxef_implicit_fabric_logout(void *arg);
extern void bnxef_bringup_ports(void *arg);
extern void bnxef_fcf_list_purge(bnxef_driver_state_t *dsp);



/*
 * FIP State Machine
 *
 * The routines implementing the FIP state machine are called using TASK Q
 * mechanism. These task queue routines are scheduled based on different
 * events identified by different parts
 * of the code.
 *
 * ONLINE Event from Bnxe driver
 *	  This triggers the FIP State machine to start, by preparing the VLAN
 *	 request and send the same on the wire and wait for the VLAN response
 *	to happen. Enables the timer, to make sure the response comes back in
 *	time. If the response didnot come back, it will recover by moving the
 *	state machine back to the beginning and keep trying with certain amount
 *	of delay.
 *
 * VLAN Response received from FCF
 *	Validate the response and save all the information. This need to
 *	be handled from  possibly the interrupt context, therefore it should
 *	sleep for any resource allocation. Once the validation is done and
 *	information saved, this will schedule a new task queue to send next
 *	FIP frame. This handler will change the state to move discover
 *	FCF state.
 *
 * Move to next Discover State.
 *	Send the Multi-cast discovery solicitation to all FCF mac.
 *	when the unicast discovery advertizement is recieved it will update
 *	the state  to move to READY to LOGIN State and wait for the bind port
 *	 routine to send establish virtual link, by sending FIP FLOGI descriptor
 *	to the selected FCF. The bind routine will wait for the response to come
 *	 before it returns to higher level layer. This port bind routine
 *	will move the state to LINK Mantainance and will use the FKA_ADV_PERIOD
 *	to enforce reception of frequent discovery advertisements from the
 *	selected FCF.
 *
 * If at any point in the state machine if the L2 layer indicates that port
 * is offline, then the complete resources are cleaned up and the FIP state
 * machine moves back to the beginning state.
 */
/*
 * The following routine starts the state machine by sending the VLAN request
 * first. This also starts the  timeout to catch the runway conditions like
 * VLAN response not received within the required time.
 */
void
bnxef_fip_sm_start(void * arg)
{
	mblk_t *mp = NULL;
	int  ret = DDI_FAILURE;
	int  retry_count = BNXEF_FIP_FRAME_RETRY_COUNT;
	uint32_t	type;
	bnxef_tq_params_t *paramp = NULL;
	ddi_taskq_t	*tq;
	kmem_cache_t	*tq_param_cache;
	bnxef_driver_state_t *dsp = (bnxef_driver_state_t *)arg;
	timeout_id_t t_id;

	ASSERT(dsp != NULL);

	BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Entering the FIP SM",
			BNXEF_DRIVER_NAME, dsp->instance);

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);

	if (dsp->physical_port_state == BNXEF_PHYPORT_OFFLINE) {
		mutex_exit(&dsp->state_mutex);
		return;
	}

	if (dsp->fip_disc_status & FIP_VLAN_RESPONSE_RECEIVED) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Calling Send Disc Sol",
			BNXEF_DRIVER_NAME, dsp->instance);
		mutex_exit(&dsp->state_mutex);
		bnxef_fip_sm_send_disc_sol((void *)dsp);
		return;
	}
	/* Sets the initial state of the state machine */
	dsp->fip_disc_state = FIP_VLAN_DISC_STATE;
	mutex_exit(&dsp->state_mutex);

	tq = dsp->tq;
	tq_param_cache = dsp->tq_params_cache;

	/* prepare the VLAN Request for sending */
	mp = bnxef_prep_mblk_fip_vlan_request(dsp);
	if (mp == NULL) {
		type = BNXEF_TQ_FIP_VLAN_REQ_NO_RESOURCE;
		goto fip_start_error;
	}
	/* Send the Frame out on Wire by calling the Bnxe driver */
	do {
		/* VLAN Request is always sent on VLAN ID 0 */
		if (!bnxef_send_frame(dsp, mp, 0)) {
			retry_count--;
			if (retry_count == 0) break;
		} else  {
			ret = BNXEF_SUCCESS;
			break;
		}
	} while (retry_count > 0);

	if (ret != BNXEF_SUCCESS) {
		freemsg(mp);
		type = BNXEF_TQ_FIP_VLAN_REQ_SEND_FAILURE;
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: FIP VLAN REQ Transmission Failure",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto fip_start_error;
	}
	BNXEF_STATS(dsp, l2_tx);
	BNXEF_STATS(dsp, l2_fip_tx);

	ASSERT(ret == BNXEF_SUCCESS);
	BNXEF_DEBUG(dsp, FIP, -1,
		"%s%d: VLAN Request Transmission Succeeded",
		BNXEF_DRIVER_NAME, dsp->instance);
	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	/* Set the timeout, response should come in this time period */
	dsp->fip_timeout = timeout(bnxef_fip_sm_start, (void *) dsp,
			BNXEF_SEC2TICK(5));
	dsp->fip_disc_status |= FIP_VLAN_REQUEST_SENT | FIP_TIMEOUT_ARMED;
	mutex_exit(&dsp->state_mutex);
	retry_count = BNXEF_FIP_FRAME_RETRY_COUNT;
	do {
		delay(1);
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		if ((volatile uint32_t)dsp->fip_disc_status &
			FIP_VLAN_RESPONSE_RECEIVED) {
			mutex_exit(&dsp->state_mutex);
			break;
		}
		retry_count--;
		mutex_exit(&dsp->state_mutex);
	} while (retry_count > 0);
	if (retry_count == 0) {
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		if ((volatile uint32_t) dsp->fip_disc_status &
			FIP_VLAN_RESPONSE_RECEIVED) {
			mutex_exit(&dsp->state_mutex);
		} else {
			mutex_exit(&dsp->state_mutex);
			return;
		}
	}
	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	t_id = dsp->fip_timeout;
	dsp->fip_disc_status &= ~FIP_TIMEOUT_ARMED;
	mutex_exit(&dsp->state_mutex);
	untimeout(t_id);

	/* Now start the second stage in FIP process */
	bnxef_fip_sm_send_disc_sol((void *) dsp);
	return;

fip_start_error:
	paramp = kmem_cache_alloc(tq_param_cache, KM_SLEEP);
	if (paramp == NULL) {
		cmn_err(CE_PANIC, "%s%dUnable to allocate Tq Param\n",
				BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}
	paramp->type =  type;
	paramp->dsp = dsp;
	/*
	 * Resources not available - Dispatch TAsk Queue to restart
	 * This can be done because this is the first frame sent out
	 */
	ret = ddi_taskq_dispatch(tq, bnxef_fip_tq_handler,
		(void *) paramp, DDI_SLEEP);
	if (ret == DDI_FAILURE)  {
		cmn_err(CE_WARN, "%s%d Unable to Schedule in task Q\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}
}

/*
 * The following routine will send the multi-cast Discovery Solicitation to
 * all FCF MAC.
 */
void
bnxef_fip_sm_send_disc_sol(void * arg)
{
	bnxef_driver_state_t *dsp = (bnxef_driver_state_t *)arg;
	mblk_t	*mp = NULL;
	int	ret = BNXEF_FAILURE;
	int	retry_count = BNXEF_FIP_FRAME_RETRY_COUNT;
	uint32_t	type;
	ddi_taskq_t	*tq;
	bnxef_tq_params_t *paramp = NULL;
	kmem_cache_t	*tq_param_cache;

	ASSERT(dsp != NULL);

	BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Entered to send FIP Disc Sol",
		BNXEF_DRIVER_NAME, dsp->instance);
	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	if (dsp->physical_port_state == BNXEF_PHYPORT_OFFLINE) {
		mutex_exit(&dsp->state_mutex);
		return;
	}

	if (dsp->fip_disc_status & FIP_UNICAST_DISC_ADV_RECEIVED) {
		dsp->fip_disc_status  &= ~FIP_TIMEOUT_ARMED;
		mutex_exit(&dsp->state_mutex);
		return;
	}


	/* Sets the initial state of the state machine */
	dsp->fip_disc_state = FIP_DISC_FCF_STATE;
	dsp->fip_disc_status  &= ~FIP_TIMEOUT_ARMED; /* Callout can also call */
	ASSERT((dsp->fip_disc_status & FIP_TIMEOUT_ARMED) == 0);
	/* Set the timeout, response should come in this time period */
	dsp->fip_timeout = timeout(bnxef_fip_sm_send_disc_sol,
		(void *) dsp, BNXEF_SEC2TICK(5));
	mutex_exit(&dsp->state_mutex);

	tq = dsp->tq;
	tq_param_cache = dsp->tq_params_cache;

	/* prepare the VLAN Request for sending */
	mp = bnxef_prep_mblk_fip_disc_sol(dsp);
	if (mp == NULL) {
		type = BNXEF_TQ_FIP_DISC_SOL_NO_RESOURCE;
		BNXEF_DEBUG(dsp, FIP, -1,  "%s%d: Resource Allocation Failure",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto fip_sol_error;
	}
	/* Send the Frame out on Wire by calling the Bnxe driver */
	do {
		if (!bnxef_send_frame(dsp, mp, dsp->fcf_ident->vlan_id)) {
			retry_count--;
			BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Transmission Failed",
				BNXEF_DRIVER_NAME, dsp->instance);
			if (retry_count == 0) break;
		} else  {
			ret = BNXEF_SUCCESS;
			break;
		}
	} while (retry_count > 0);

	if (ret != BNXEF_SUCCESS) {
		freemsg(mp);
		type = BNXEF_TQ_FIP_DISC_SOL_SEND_FAILURE;
		BNXEF_DEBUG(dsp, FIP, -1, "%s%d:Transmit Failed after retries",
			BNXEF_DRIVER_NAME, dsp->instance);
		BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Tranmit failed after retriees",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto fip_sol_error;
	}

	BNXEF_STATS(dsp, l2_tx);
	BNXEF_STATS(dsp, l2_fip_tx);

	ASSERT(ret == BNXEF_SUCCESS);
	BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Discovery Solicitation Sent",
		BNXEF_DRIVER_NAME, dsp->instance);
	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	dsp->fip_disc_status |= FIP_DISC_SOL_SENT | FIP_TIMEOUT_ARMED;
	mutex_exit(&dsp->state_mutex);
	return;

fip_sol_error:
	paramp = kmem_cache_alloc(tq_param_cache, KM_NOSLEEP);
	if (paramp == NULL) {
		cmn_err(CE_NOTE, "%s%d unable to allocate task params\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}
	paramp->type = type;
	paramp->dsp = dsp;

	/*
	 * Resources not available - Dispatch TAsk Queue to restart
	 */
	ret = ddi_taskq_dispatch(tq, bnxef_fip_tq_handler,
		(void *) paramp, DDI_SLEEP);
	if (ret == DDI_FAILURE)  {
		cmn_err(CE_WARN, "%s%d Unable to Schedule in task Q\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}
}

/*
 * The following routine will send FLOGI or FDISC depending on what is
 * requested
 */
int
bnxef_fip_sm_send_flogi_fdisc(bnxef_driver_state_t *dsp, uint8_t opcode,
	uint16_t ox_id, uint8_t *port_name, uint8_t *node_name)
{

	mblk_t	*mp = NULL;
	int	ret = BNXEF_FAILURE;
	int	retry_count = BNXEF_FIP_FRAME_RETRY_COUNT;
	uint32_t fip_flags;

	ASSERT(dsp != NULL);

	/* Sets the initial state of the state machine */
	ASSERT((dsp->fip_disc_state == FIP_LOGIN_READY_STATE) ||
		(dsp->fip_disc_state == FIP_VLINK_MAINT_STATE));

	if (dsp->fcf_ident == NULL)
		return (BNXEF_FAILURE);

	if (dsp->fcf_ident->flags_a == 0)
		return (BNXEF_FAILURE);
	/* prepare the VLAN Request for sending */
	mp = bnxef_prep_mblk_fip_flogi_fdisc(dsp, opcode, ox_id, port_name,
			node_name);
	if (mp == NULL) {
		goto fip_fc_error;
	}
	/* Send the Frame out on Wire by calling the Bnxe driver */
	do {
		if (!bnxef_send_frame(dsp, mp, dsp->fcf_ident->vlan_id)) {
			retry_count--;
			if (retry_count == 0) break;
		} else {
			ret = BNXEF_SUCCESS;
			break;
		}
	} while (retry_count > 0);

	if (ret != BNXEF_SUCCESS) {
		freemsg(mp);
		goto fip_fc_error;
	}
	BNXEF_STATS(dsp, l2_tx);
	BNXEF_STATS(dsp, l2_fip_tx);

	ASSERT(ret == BNXEF_SUCCESS);

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	ASSERT((opcode == LA_ELS_FLOGI) || (opcode == LA_ELS_FDISC));
	fip_flags = (opcode == LA_ELS_FLOGI)? FIP_FLOGI_SENT:FIP_FDISC_SENT;

	dsp->fip_disc_status |= fip_flags;
	mutex_exit(&dsp->state_mutex);
	return (BNXEF_SUCCESS);

fip_fc_error:
	return (BNXEF_FAILURE);
}

/*
 * The following routine will send the FIP LOGO LS_RJt with reason
 * command not supported and no additional explanantion.
 */
int
bnxef_fip_sm_send_ls_rjt(bnxef_driver_state_t *dsp, bnxef_lport_t *portp,
	uint16_t ox_id, uint32_t s_id)
{
	mblk_t	*mp = NULL;
	int	ret = BNXEF_FAILURE;
	int	retry_count = BNXEF_FIP_FRAME_RETRY_COUNT;

	ASSERT(dsp != NULL);
	ASSERT(portp != NULL);

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);

	/* Sets the initial state of the state machine */
	ASSERT(dsp->fip_disc_state == FIP_VLINK_MAINT_STATE);
	mutex_exit(&dsp->state_mutex);

	/* prepare the VLAN Request for sending */
	mp = bnxef_prep_mblk_fip_ls_rjt(dsp, portp, ox_id, s_id);
	if (mp == NULL) {
		goto fip_ls_rjt_error;
	}
	/* Send the Frame out on Wire by calling the Bnxe driver */
	do {
		if (!bnxef_send_frame(dsp, mp, dsp->fcf_ident->vlan_id)) {
			retry_count--;
			if (retry_count == 0) break;
		} else {
			ret = BNXEF_SUCCESS;
			break;
		}
	} while (retry_count > 0);

	if (ret != BNXEF_SUCCESS) {
		freemsg(mp);
		goto fip_ls_rjt_error;
	}

	ASSERT(ret == BNXEF_SUCCESS);
	BNXEF_STATS(dsp, l2_tx);
	BNXEF_STATS(dsp, l2_fip_tx);
	return (BNXEF_SUCCESS);

fip_ls_rjt_error:
	return (BNXEF_FAILURE);
}


int
bnxef_fip_sm_send_ls_acc(bnxef_driver_state_t *dsp, bnxef_lport_t *portp,
	uint16_t ox_id)
{
	mblk_t	*mp = NULL;
	int	ret = BNXEF_FAILURE;
	int	retry_count = BNXEF_FIP_FRAME_RETRY_COUNT;

	ASSERT(dsp != NULL);
	ASSERT(portp != NULL);

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);

	/* Sets the initial state of the state machine */
	ASSERT(dsp->fip_disc_state == FIP_VLINK_MAINT_STATE);
	mutex_exit(&dsp->state_mutex);

	/* prepare the VLAN Request for sending */
	mp = bnxef_prep_mblk_fip_ls_acc(dsp, portp, ox_id);
	if (mp == NULL) {
		goto fip_ls_acc_error;
	}
	/* Send the Frame out on Wire by calling the Bnxe driver */
	do {
		if (!bnxef_send_frame(dsp, mp, dsp->fcf_ident->vlan_id)) {
			retry_count--;
			if (retry_count == 0) break;
		} else {
			ret = BNXEF_SUCCESS;
			break;
		}
	} while (retry_count > 0);

	if (ret != BNXEF_SUCCESS) {
		freemsg(mp);
		goto fip_ls_acc_error;
	}

	ASSERT(ret == BNXEF_SUCCESS);
	BNXEF_STATS(dsp, l2_tx);
	BNXEF_STATS(dsp, l2_fip_tx);
	return (BNXEF_SUCCESS);

fip_ls_acc_error:
	return (BNXEF_FAILURE);
}

/*
 * The following routine will send the FIP Fabric Logo for the VN port
 * referenced by the parameter.
 */
int
bnxef_fip_sm_send_logo(bnxef_driver_state_t *dsp, bnxef_lport_t *portp)
{
	mblk_t	*mp = NULL;
	int	ret = BNXEF_FAILURE;
	int	retry_count = BNXEF_FIP_FRAME_RETRY_COUNT;

	ASSERT(dsp != NULL);
	ASSERT(portp != NULL);

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	/* Sets the initial state of the state machine */
	ASSERT(dsp->fip_disc_state == FIP_VLINK_MAINT_STATE);
	mutex_exit(&dsp->state_mutex);

	/* prepare the VLAN Request for sending */
	mp = bnxef_prep_mblk_fip_logo(dsp, portp);
	if (mp == NULL) {
		goto fip_logo_error;
	}
	/* Send the Frame out on Wire by calling the Bnxe driver */
	do {
		if (!bnxef_send_frame(dsp, mp, dsp->fcf_ident->vlan_id)) {
			retry_count--;
			if (retry_count == 0) break;
		} else {
			ret = BNXEF_SUCCESS;
			break;
		}
	} while (retry_count > 0);

	if (ret != BNXEF_SUCCESS) {
		freemsg(mp);
		goto fip_logo_error;
	}

	ASSERT(ret == BNXEF_SUCCESS);
	BNXEF_STATS(dsp, l2_tx);
	BNXEF_STATS(dsp, l2_fip_tx);
	return (BNXEF_SUCCESS);

fip_logo_error:
	return (BNXEF_FAILURE);
}


/*
 * The following routine will send  FIP Keep Alive for Permanent port or
 * a VN  port referenced by the port structure passed.
 */
int
bnxef_fip_sm_send_fka(bnxef_driver_state_t *dsp, bnxef_lport_t *portp)
{

	mblk_t	*mp = NULL;
	int	ret = BNXEF_FAILURE;
	int	retry_count = BNXEF_FIP_FRAME_RETRY_COUNT;

	ASSERT(dsp != NULL);
	ASSERT(portp != NULL);

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	if (dsp->physical_port_state == BNXEF_PHYPORT_OFFLINE) {
		mutex_exit(&dsp->state_mutex);
		/* Nothing to do, just say success */
		return (BNXEF_SUCCESS);
	}
	/* Sets the initial state of the state machine */
	if (dsp->fip_disc_state != FIP_VLINK_MAINT_STATE) {
		mutex_exit(&dsp->state_mutex);
		return (BNXEF_SUCCESS);
	}
	if (dsp->fcf_ident == NULL) {
		mutex_exit(&dsp->state_mutex);
		return (BNXEF_SUCCESS);
	}

	if (dsp->fcf_ident->d_bit_info) {
		mutex_exit(&dsp->state_mutex);
		return (BNXEF_SUCCESS);
	}

	mutex_exit(&dsp->state_mutex);


	/* prepare the VLAN Request for sending */
	mp = bnxef_prep_mblk_fip_keep_alive(dsp, portp);
	if (mp == NULL) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Keep Alive Frame Preparation error",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto fip_fka_error;
	}
	/* Send the Frame out on Wire by calling the Bnxe driver */
	do {
		if (!bnxef_send_frame(dsp, mp, dsp->fcf_ident->vlan_id)) {
			retry_count--;
			if (retry_count == 0) break;
		} else {
			ret = BNXEF_SUCCESS;
			break;
		}
	} while (retry_count > 0);

	if (ret != BNXEF_SUCCESS) {
		freemsg(mp);
		goto fip_fka_error;
	}

	BNXEF_STATS(dsp, l2_tx);
	BNXEF_STATS(dsp, l2_fip_tx);
	ASSERT(ret == BNXEF_SUCCESS);
	return (BNXEF_SUCCESS);

fip_fka_error:
	BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: FKA Send Error",
		BNXEF_DRIVER_NAME, dsp->instance);
	return (BNXEF_FAILURE);
}

/*
 * The following function is the callback routine which is called from
 * bnxe driver. This can be called in any context, therefore this should not
 * sleep.
 */

/*
 * The following function is the callback routine which is called from
 * bnxe driver. This can be called in any context, therefore this should not
 * sleep.
 *
 *
 * TBE - To be enhanced to include handling multiple frames, indicated by a
 * chain of MBLKS
 */
int
bnxef_fip_rx_handler(dev_info_t *dip, mblk_t *mp, int flags)
{
	int instance;
	bnxef_driver_state_t *dsp;
	bnxef_fip_frame_t	*fp;
	bnxef_fip_frame_novlan_t	*fpnovlan;
	fip_operation_fmt_hdr_t  *ophp;
	int ret = BNXEF_FAILURE;

	ASSERT(dip != NULL);
	ASSERT(mp != NULL);

	instance = ddi_get_instance(dip);
	dsp = ddi_get_soft_state(bnxef_state, instance);
	ASSERT((mp->b_next == NULL) && (mp->b_prev == NULL));
	ASSERT(dsp != NULL);
	BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Receive frame 0x%p",
		BNXEF_DRIVER_NAME, dsp->instance, mp);
	BNXEF_STATS(dsp, l2_fip_rx);
	/*
	 * This will use the frame format template to validate certain fields
	 * and call appropriate handler for handling the received frame.
	 */

	if (flags) {
		fp = (bnxef_fip_frame_t *)mp->b_rptr;
		ASSERT(ntohs(fp->vlan.ether_type) == FIP_ETHERTYPE);
		ASSERT(ntohs(fp->ether.ether_type) == ETHERTYPE_VLAN);
		if (fp->pdu.version != FIP_FRAME_VER) {
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			/* Ignore the frame received */
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}
		ASSERT(fp->pdu.version == FIP_FRAME_VER);
		ophp = &fp->ophdr;
	} else {
		fpnovlan = (bnxef_fip_frame_novlan_t *)mp->b_rptr;
		ASSERT(ntohs(fpnovlan->ether.ether_type) == FIP_ETHERTYPE);
		if (fpnovlan->pdu.version != FIP_FRAME_VER) {
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			cmn_err(CE_NOTE, "mp 0x%p, fpnovlan 0x%p",
				mp, fpnovlan);
			cmn_err(CE_PANIC, "no vlan reservd 0x%x",
				fpnovlan->pdu.reserved);
			/* Ignore the frame received */
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}
		ASSERT(fpnovlan->pdu.version == FIP_FRAME_VER);
		ophp = &fpnovlan->ophdr;
	}
	BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Protocol Code 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, ntohs(ophp->fip_prot_code));
	switch (ntohs(ophp->fip_prot_code)) {
	case FIP_PROT_DISCOVERY:
		ret = bnxef_fip_discover_prot_handler(dsp, mp, flags);
		break;
	case FIP_PROT_VLAN:
		ret = bnxef_fip_vlan_prot_handler(dsp, mp, flags);
		break;
	case FIP_PROT_VLINK_MAIN: {
		bnxef_tq_params_t *tqp = NULL;

		tqp = kmem_cache_alloc(dsp->tq_params_cache, KM_NOSLEEP);
		if (tqp == NULL)  {
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			freemsg(mp);
			ret = BNXEF_SUCCESS;
			break;
		}

		tqp->dsp = dsp;
		tqp->mp = mp;
		tqp->flags = flags;
		ret = ddi_taskq_dispatch(dsp->tq,
			bnxef_fip_vlink_maintenance_prot_handler,
			(void *) tqp, DDI_NOSLEEP);
		if (ret == DDI_FAILURE)  {
			cmn_err(CE_WARN, "%s%d Unable to Schedule in task Q\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			freemsg(mp);
			ret  = BNXEF_SUCCESS;
			break;
		}
		break;
	}
	case FIP_PROT_VLINK:
		ret = bnxef_fip_vlink_prot_handler(dsp, mp, flags);
		break;
	default:
		cmn_err(CE_WARN, "%s%d: Unknown fip protocol code received\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		BNXEF_STATS(dsp, l2_fip_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		/* Ignore the frame received */
		freemsg(mp);
		ret = BNXEF_SUCCESS; /* Indicate frame has been consumed */
	}
	return (ret);
}


/*
 * The following routine handles the complete VLAN Request and response.
 */
int
bnxef_fip_vlan_prot_handler(bnxef_driver_state_t *dsp, mblk_t *mp,
	int flags)
{
	bnxef_fip_frame_t	*fp;
	uint8_t	fip_frame[256];
	bnxef_fip_frame_novlan_t *fpnovlan;
	fip_operation_fmt_hdr_t  *ophp;
	bnxef_fcf_info_t *fcfp = NULL;
	int ret = BNXEF_SUCCESS;

	ASSERT(dsp != NULL);
	ASSERT(mp != NULL);

	if (flags) {
		memcpy((uint8_t *)fip_frame, mp->b_rptr,
			(mp->b_wptr - mp->b_rptr));
		fp  = (bnxef_fip_frame_t *)fip_frame;

		ASSERT(ntohs(fp->vlan.ether_type) == FIP_ETHERTYPE);
		ASSERT(ntohs(fp->ether.ether_type) == ETHERTYPE_VLAN);
		ASSERT(fp->pdu.version == FIP_FRAME_VER);
		ophp =  &fp->ophdr;
	} else {
		memcpy((uint8_t *)fip_frame, mp->b_rptr,
			(mp->b_wptr - mp->b_rptr));
		fpnovlan  = (bnxef_fip_frame_novlan_t *)fip_frame;

		ASSERT(ntohs(fpnovlan->ether.ether_type) == FIP_ETHERTYPE);
		ASSERT(fpnovlan->pdu.version == FIP_FRAME_VER);
		ophp = &fpnovlan->ophdr;
	}

	switch (ophp->fip_subcode) {
	case FIP_PROT_SUB_VLAN_NOTIF: {
		fip_mac_addr_desc_fmt_t *macp = NULL;
		fip_vlan_desc_fmt_t *vlanp = NULL;
		ether_addr_t	macaddr;
		ether_addr_t	srcmacaddr;
		uint32_t	length;
		uint8_t	 *curdescp;
		uint32_t	cur_length;
		uint32_t	error = 0;

		length = htons(ophp->desc_len);

		if (flags)
			curdescp = fp->desc;
		else
			curdescp = fpnovlan->desc;

		while (length > 0) {
			cur_length = curdescp[1];
			switch (curdescp[0]) {
			case  FIP_DESC_TYPE_MAC_ADDR:
				if (macp == NULL) {
					macp =
					/* LINTED: alignment */
					(fip_mac_addr_desc_fmt_t *)curdescp;
					if (macp->length !=
						FIP_MAC_ADDR_DESC_LEN)
						error++;
				} else {
					/* Duplicate descriptor */
					error++;
				}
				break;
			case  FIP_DESC_VLAN:
				if (vlanp == NULL) {
					vlanp =
						/* LINTED: alignment */
						(fip_vlan_desc_fmt_t *)curdescp;
					if (vlanp->length != FIP_VLAN_DESC_LEN)
						error++;
				}
				break;
			default:
				if (curdescp[0] <= FIP_CRITICAL_DESC_TYPE_MAX)
					error++;
				break;
			}
			if (error) break;
			curdescp += (cur_length * sizeof (uint32_t));
			length -= cur_length;
		}

		if ((vlanp == NULL) || (macp == NULL)) {
			error++;
		}

		if (error) {
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}

		if (flags) {
			/* macp = (fip_mac_addr_desc_fmt_t *)fp->desc; */
			bcopy((void *)&fp->ether.ether_dhost,
				(void *)&macaddr, 6);
			bcopy((void *)&fp->ether.ether_shost,
				(void *)&srcmacaddr, 6);
		} else {
			/* macp = (fip_mac_addr_desc_fmt_t *)fpnovlan->desc; */
			bcopy((void *)&fpnovlan->ether.ether_dhost,
				(void *)&macaddr, 6);
			bcopy((void *)&fpnovlan->ether.ether_shost,
				(void *)&srcmacaddr, 6);
		}

		/* vlanp = (fip_vlan_desc_fmt_t *)(macp + 1); */

		/* What should be done for Non Debug Mode */
		ASSERT(macp->type == FIP_DESC_TYPE_MAC_ADDR);
		ASSERT(macp->length == 2);
		ASSERT(vlanp->type == FIP_DESC_VLAN);
		ASSERT(vlanp->length == 1);

		/* Check whether we have sent the VLAN request */
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		/*
		 * TBD - VLAN Response (unicast) can come to update the change
		 * in VLAN config. There for the following ASSERT may not be
		 * good. Possibly we should remove it.
		 */
		ASSERT((dsp->fip_disc_status & FIP_VLAN_REQUEST_SENT) ==
				FIP_VLAN_REQUEST_SENT);
		/* VAlidate it was sent to the MAC Address of this port */
		/* LINTED: alignment */
		if (!ether_cmp(dsp->mac_add, &macaddr)) {
			BNXEF_DEBUG(dsp, FIP, -1,
				"%s%d: Ethernet Address Compared Good",
				BNXEF_DRIVER_NAME, dsp->instance);
			fcfp = bnxef_fcf_list_find_mac_addr(dsp,
					(uint8_t *)&srcmacaddr);
			if (fcfp == NULL) {
				fcfp = kmem_cache_alloc(dsp->fcf_cache,
						KM_NOSLEEP);
				if (fcfp == NULL) {
					cmn_err(CE_WARN,
					"%s%d: Unable to allocate FCF",
					BNXEF_DRIVER_NAME,
					dsp->instance);
					return (BNXEF_FAILURE);
				}
				bcopy(&srcmacaddr, &fcfp->mac_addr, 6);
				bnxef_fcf_list_add(dsp, fcfp);
			}
			mutex_enter(&fcfp->fcf_mutex);
			fcfp->fcf_state |= FCF_INFO_VLAN_NOTIF_RECEIVED;
			mutex_exit(&fcfp->fcf_mutex);

			if (dsp->fcf_ident == NULL) {
				/*
				 * Selection Happens when we
				 * send VLAN request
				 */
				bnxef_select_fcf(dsp);
			}
			/*
			 * Save all the information like MAC address and VLAN
			 * information into FCF structure
			 */
			mutex_enter(&dsp->fcf_ident->fcf_mutex);
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Received VLAN ID 0x%x",
				BNXEF_DRIVER_NAME,
				dsp->instance, htons(vlanp->vlan_id));
			dsp->fcf_ident->vlan_id = htons(vlanp->vlan_id);
			dsp->fcf_ident->vlan_tag_pcp =
				VLAN_PRI(htons(fp->vlan.ether_tci));
			dsp->fcf_ident->fcf_state |=
				FCF_INFO_VLAN_NOTIF_RECEIVED;
			mutex_exit(&dsp->fcf_ident->fcf_mutex);
			dsp->fip_disc_status |= FIP_VLAN_RESPONSE_RECEIVED;
			mutex_exit(&dsp->state_mutex);
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: VLAN Response Receievd",
				BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			freemsg(mp);
		} else {
			/*
			 * Not addressed to my MAC address  Could be addressed
			 * to ALL ENODE MAC address. Either case Ignore the
			 * frame.
			 */
			ASSERT(0); /* In debug mode ASSERT */
			/* In Non-debug mode, Ignore this frame and move on */
			mutex_exit(&dsp->state_mutex);
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			freemsg(mp);
		}
		break;
	}

	case  FIP_PROT_SUB_VLAN_REQUEST:
		/*
		 * We are a ENODE, if this comes ignore and release the frame
		 */
		/* FALLTHRU */
	default:
		BNXEF_STATS(dsp, l2_fip_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		/* Unknown sub protocol code, discard the frame and return */
		freemsg(mp);
	}
	return (ret);
}


/*
 * The following handles the discovery protocol
 */
int
bnxef_fip_discover_prot_handler(bnxef_driver_state_t *dsp, mblk_t *mp,
		int flags)
{
	bnxef_fip_frame_t	*fp;
	uint8_t	*fip_frame;
	uint16_t	fip_frame_length;
	bnxef_fip_frame_novlan_t *fpnovlan;
	int ret = BNXEF_FAILURE;
	uint32_t	fip_status;
	bnxef_fcf_info_t *fcfp = NULL;
	uint8_t  mac_addr[ETHERADDRL];
	uint8_t	 wwn[8];
	timeout_id_t	t_id;
	int tid_valid = 0;
	uint8_t	 *curdescp;
	uint32_t	length;
	uint8_t		fip_subcode;
	uint16_t 	vlan_id;
	uint8_t		vlan_tag_pcp;
	uint8_t		vlan_tag_cfi;
	uint16_t	ophdrflags;

	ASSERT(dsp != NULL);
	ASSERT(mp != NULL);


	fip_frame_length = mp->b_wptr - mp->b_rptr;
	fip_frame = kmem_zalloc(fip_frame_length, KM_NOSLEEP);
	if (fip_frame == NULL) {
		BNXEF_STATS(dsp, l2_fip_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		freemsg(mp);
		return (BNXEF_SUCCESS);
	}

	BNXEF_DEBUG(dsp, FIP, -1, "%s%d:Flags 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, flags);
	if (flags) {
		memcpy((uint8_t *)fip_frame, mp->b_rptr,
			(mp->b_wptr - mp->b_rptr));
		fp  = (bnxef_fip_frame_t *)fip_frame;
		ASSERT(ntohs(fp->vlan.ether_type) == FIP_ETHERTYPE);
		ret = bcmp((void *)fp->ether.ether_dhost.ether_addr_octet,
				(void *)all_fcf_mac, 6);
		if (ret == 0) {
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_frame, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}
		ASSERT(ntohs(fp->ether.ether_type) == ETHERTYPE_VLAN);
		ASSERT(fp->pdu.version == FIP_FRAME_VER);
		fip_subcode = fp->ophdr.fip_subcode;
		length = htons(fp->ophdr.desc_len);
		curdescp = fp->desc;
		vlan_id = VLAN_ID(htons(fp->vlan.ether_tci));
		vlan_tag_pcp = VLAN_PRI(htons(fp->vlan.ether_tci));
		vlan_tag_cfi = VLAN_CFI(htons(fp->vlan.ether_tci));
	} else {
		memcpy((uint8_t *)fip_frame, mp->b_rptr,
			(mp->b_wptr - mp->b_rptr));
		fpnovlan  = (bnxef_fip_frame_novlan_t *)fip_frame;

		ASSERT(ntohs(fp->ether.ether_type) == FIP_ETHERTYPE);
		ret = bcmp((void *)fpnovlan->ether.ether_dhost.ether_addr_octet,
				(void *)all_fcf_mac, 6);
		if (ret == 0) {
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_frame, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}
		ASSERT(fpnovlan->pdu.version == FIP_FRAME_VER);
		fip_subcode = fpnovlan->ophdr.fip_subcode;
		length = htons(fpnovlan->ophdr.desc_len);
		curdescp = fpnovlan->desc;
		vlan_id = 0;
		vlan_tag_pcp = 0;
		vlan_tag_cfi = 0;
	}

	switch (fip_subcode) {
	case FIP_PROT_SUB_DISC_ADV: {
		fip_priority_desc_fmt_t *prip = NULL;
		fip_mac_addr_desc_fmt_t *macp = NULL;
		fip_name_id_desc_fmt_t *np = NULL;
		fip_fabric_desc_fmt_t	*fabp = NULL;
		fip_fka_adv_period_desc_fmt_t *fkap = NULL;
		uint32_t	cur_length;
		uint32_t	error = 0;

		while (length > 0) {
			cur_length = curdescp[1];
			switch (curdescp[0]) {
			case FIP_DESC_TYPE_PRIORITY:
				if (prip == NULL) {
					prip =
					/* LINTED: alignment */
					(fip_priority_desc_fmt_t *)curdescp;
					if (prip->length !=
						FIP_PRIORITY_DESC_LEN)
						error++;
				} else {
					/* Duplicate Descriptor */
					error++;
				}
				break;

			case FIP_DESC_TYPE_MAC_ADDR:
				if (macp == NULL) {
					macp =
					/* LINTED: alignment */
					(fip_mac_addr_desc_fmt_t *)curdescp;
					if (macp->length !=
						FIP_MAC_ADDR_DESC_LEN)
						error++;
				} else {
					/* Duplicate Descriptor */
					error++;
				}
				break;
			case FIP_DESC_NAME_IDENTIFIER:
				if (np == NULL) {
					/* LINTED: alignment */
					np = (fip_name_id_desc_fmt_t *)curdescp;
					if (np->length != FIP_NAME_ID_DESC_LEN)
						error++;
				} else {
					/* Duplicate Descriptor */
					error++;
				}
				break;
			case FIP_DESC_NAME_FABRIC:
				if (fabp == NULL) {
					fabp =
					/* LINTED: alignment */
					(fip_fabric_desc_fmt_t *)curdescp;
					if (fabp->length != FIP_FABRIC_DESC_LEN)
						error++;
					if ((fabp->fabric_name_msb == 0) &&
						(fabp->fabric_name_lsb == 0))
						error++;
				} else {
					/* Duplicate Descriptor */
					error++;
				}
				break;
			case FIP_DESC_FKA_ADV_PERIOD:
				if (fkap == NULL) {
					fkap =
					/* LINTED: alignment */
					(fip_fka_adv_period_desc_fmt_t *)
							curdescp;
					if (fkap->length !=
						FIP_FKA_ADV_PERIOD_DESC_LEN)
						error++;
				} else {
					/* Duplicate Descriptor */
					error++;
				}
				break;

			default:
				if (curdescp[0] <= FIP_CRITICAL_DESC_TYPE_MAX)
					error++;
				break;
			}
			if (error) break;
			curdescp += (cur_length * sizeof (uint32_t));
			length -= cur_length;
		}
		if (error) {
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_frame, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}

		/*
		 * If any of the mandatory descriptors required is not provided
		 * ignore and move on.
		 */
		if ((prip == NULL) || (macp == NULL) ||
			(np == NULL) || (fabp == NULL) || (fkap == NULL)) {
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_frame, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}

		/* If any of the Order is changed- Reject this FIP Frame */
		if ((prip->type != FIP_DESC_TYPE_PRIORITY) ||
			(macp->type != FIP_DESC_TYPE_MAC_ADDR) ||
			(np->type	!= FIP_DESC_NAME_IDENTIFIER) ||
			(fabp->type != FIP_DESC_NAME_FABRIC) ||
			(fkap->type != FIP_DESC_FKA_ADV_PERIOD)) {
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_frame, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}

		ASSERT(prip->type == FIP_DESC_TYPE_PRIORITY);
		ASSERT(prip->length == 1);
		ASSERT(macp->type == FIP_DESC_TYPE_MAC_ADDR);
		ASSERT(macp->length == 2);
		ASSERT(np->type == FIP_DESC_NAME_IDENTIFIER);
		ASSERT(np->length == 3);
		ASSERT(fabp->type == FIP_DESC_NAME_FABRIC);
		ASSERT(fabp->length == 4);
		ASSERT(fkap->type == FIP_DESC_FKA_ADV_PERIOD);
		ASSERT(fkap->length == 2);

		/* Find whether this FCF MAC is already in the list */
		bcopy(&macp->mac_addr_lsb, &mac_addr[2], 4);
		mac_addr[0] = macp->mac_addr_msb1;
		mac_addr[1] = macp->mac_addr_msb0;
		BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Mac Addr %x:%x:%x:%x:%x:%x",
			BNXEF_DRIVER_NAME, dsp->instance, mac_addr[5],
			mac_addr[4], mac_addr[3], mac_addr[2], mac_addr[1],
			mac_addr[0]);
		bcopy((uint8_t *)&fabp->fabric_name_lsb, &wwn[4], 4);
		bcopy((uint8_t *)&fabp->fabric_name_msb, wwn, 4);
		BNXEF_DEBUG(dsp, FIP, -1,
			"%s%d:Fabric Name %x:%x:%x:%x:%x:%x:%x:%x",
			BNXEF_DRIVER_NAME, dsp->instance,
			wwn[0], wwn[1], wwn[2], wwn[3],
			wwn[4], wwn[5], wwn[6], wwn[7]);
		fcfp = bnxef_fcf_list_find_mac_addr(dsp, (uint8_t *)mac_addr);
		if (fcfp == NULL) {
			/* Allocate New FCF_INFO Structure */
			fcfp = kmem_cache_alloc(dsp->fcf_cache, KM_NOSLEEP);
			if (fcfp == NULL) {
				bnxef_tq_params_t *param;
				/*
				 * schedule a task Queue to
				 * Allocate FCF and Save FCF info, attach to
				 * FCF list for use later
				 */
				param = kmem_cache_alloc(dsp->tq_params_cache,
						KM_NOSLEEP);
				param->type =  0; /* To be Set */
				if (param == NULL) {
					cmn_err(CE_PANIC,
					"Unable to allocate tq param\n",
					BNXEF_DRIVER_NAME, dsp->instance);
					BNXEF_STATS(dsp, l2_fip_rx_free);
					BNXEF_STATS(dsp, l2_rx_free);
					kmem_free(fip_frame, fip_frame_length);
					freemsg(mp);
					return (BNXEF_FAILURE);
				}
				ddi_taskq_dispatch(dsp->tq,
					bnxef_fip_tq_handler, param,
					DDI_NOSLEEP);
				BNXEF_STATS(dsp, l2_fip_rx_free);
				BNXEF_STATS(dsp, l2_rx_free);
				kmem_free(fip_frame, fip_frame_length);
				freemsg(mp);
				return (ret);
			}
			/* All descriptors are in order, now save information */
			bcopy(mac_addr, fcfp->mac_addr, 6);

			/* Add the Fcf to the list */
			bnxef_fcf_list_add(dsp, fcfp);
		}

		BNXEF_DEBUG(dsp, FIP, -1,
			"%s%d: fcf fcf_state 0x%x\n", BNXEF_DRIVER_NAME,
			dsp->instance, fcfp->fcf_state);
		mutex_enter(&fcfp->fcf_mutex);
		if (fcfp->fcf_state & FCF_SELECTED_FOR_LOGIN) {
			/*
			 * Vlan ID on selected FCF not same as received
			 * Vlan ID on the frame. Just drop it we donot
			 * care about it such discovery advertizement.
			 * coming from the same FCF with the same mac
			 * address.
			 */
			if (fcfp->vlan_id != vlan_id) {
				mutex_exit(&fcfp->fcf_mutex);
				BNXEF_DEBUG(dsp, FIP, -1,
			"%s%d: Ignoring the DA coming on another VLAN 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				vlan_id);
				BNXEF_STATS(dsp, l2_fip_rx_free);
				BNXEF_STATS(dsp, l2_rx_free);
				kmem_free(fip_frame, fip_frame_length);
				freemsg(mp);
				return (BNXEF_SUCCESS);
			}
			if (dsp->fcf_ident == NULL)
				dsp->fcf_ident = fcfp;
		}

		if ((fcfp->fcf_state & FCF_SELECTED_FOR_LOGIN) == 0) {
			mutex_exit(&fcfp->fcf_mutex);
			BNXEF_DEBUG(dsp, FIP, -1,
		"%s%d: Ignoring the DA because not from FCF selected 0x%p",
				BNXEF_DRIVER_NAME, dsp->instance, fcfp);

			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_frame, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}
		BNXEF_DEBUG(dsp, FIP, -1,
			"%s%d: fka_adv_period 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance,
			htonl(fkap->fka_adv_period));
		/* if fka_adv_period > 90000), drop the frame */
		if (htonl(fkap->fka_adv_period) > 90000) {
			mutex_exit(&fcfp->fcf_mutex);
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_frame, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}

		/* if fka_adv_perios < 250, drop the frame */
		if (htonl(fkap->fka_adv_period) < 250) {
			mutex_exit(&fcfp->fcf_mutex);
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_frame, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}

		if (flags) {
			fcfp->available_for_login =
			(htons(fp->ophdr.flags) & BNXEF_FIP_FLAGS_A)? 1:0;
			BNXEF_DEBUG(dsp, FIP, -1,
				"%s%d: available for login 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				fcfp->available_for_login);
			if (!fcfp->available_for_login) {
				mutex_exit(&fcfp->fcf_mutex);
				BNXEF_STATS(dsp, l2_fip_rx_free);
				BNXEF_STATS(dsp, l2_rx_free);
				kmem_free(fip_frame, fip_frame_length);
				freemsg(mp);
				return (BNXEF_SUCCESS);
			}

			fcfp->vlan_id = vlan_id;
			fcfp->vlan_tag_pcp = vlan_tag_pcp;
			fcfp->vlan_tag_cfi = vlan_tag_cfi;
			fcfp->priority = prip->priority;
			bcopy(np->name, fcfp->name, 8);
			bcopy(wwn, fcfp->fabric_name, 8);
			fcfp->vf_id = htons(fabp->vf_id);
			fcfp->fc_map = htonl(fabp->fc_map);
			fcfp->fka_adv_period = htonl(fkap->fka_adv_period);
			fcfp->d_bit_info	= htons(fkap->d);
			BNXEF_DEBUG(dsp, FIP, -1,
				"%s%d: D Bit Info set in %p, 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				fcfp, fcfp->d_bit_info);
			fcfp->available_for_login =
			(htons(fp->ophdr.flags) & BNXEF_FIP_FLAGS_A)? 1:0;
			fcfp->flags_sp =
			(htons(fp->ophdr.flags) & BNXEF_FIP_FLAGS_SP)? 1:0;
			fcfp->flags_fp =
			(htons(fp->ophdr.flags) & BNXEF_FIP_FLAGS_FP)? 1:0;
			fcfp->flags_a  =
			(htons(fp->ophdr.flags) & BNXEF_FIP_FLAGS_A)? 1: 0;
			fcfp->flags_f =
			(htons(fp->ophdr.flags) & BNXEF_FIP_FLAGS_F)? 1:0;
			fcfp->flags_s =
			(htons(fp->ophdr.flags) & BNXEF_FIP_FLAGS_S)? 1:0;
			ophdrflags = htons(fp->ophdr.flags);

		} else {
			fcfp->available_for_login =
			(htons(fpnovlan->ophdr.flags) & BNXEF_FIP_FLAGS_A)? 1:0;
			BNXEF_DEBUG(dsp, FIP, -1,
				"%s%d: available for login 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				fcfp->available_for_login);
			if (!fcfp->available_for_login) {
				mutex_exit(&fcfp->fcf_mutex);
				BNXEF_STATS(dsp, l2_fip_rx_free);
				BNXEF_STATS(dsp, l2_rx_free);
				kmem_free(fip_frame, fip_frame_length);
				freemsg(mp);
				return (BNXEF_SUCCESS);
			}

			fcfp->vlan_id = vlan_id;
			fcfp->vlan_tag_pcp = vlan_tag_pcp;
			fcfp->vlan_tag_cfi = vlan_tag_cfi;
			fcfp->priority = prip->priority;
			bcopy(np->name, fcfp->name, 8);
			bcopy(wwn, fcfp->fabric_name, 8);
			fcfp->vf_id = htons(fabp->vf_id);
			fcfp->fc_map = htonl(fabp->fc_map);
			fcfp->fka_adv_period = htonl(fkap->fka_adv_period);
			fcfp->d_bit_info	= htons(fkap->d);
			BNXEF_DEBUG(dsp, FIP, -1,
				"%s%d: D Bit Info set in %p, 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				fcfp, fcfp->d_bit_info);
			fcfp->available_for_login =
			(htons(fpnovlan->ophdr.flags) & BNXEF_FIP_FLAGS_A)?1:0;
			fcfp->flags_sp =
			(htons(fpnovlan->ophdr.flags) & BNXEF_FIP_FLAGS_SP)?1:0;
			fcfp->flags_fp =
			(htons(fpnovlan->ophdr.flags) & BNXEF_FIP_FLAGS_FP)?1:0;
			fcfp->flags_a  =
			(htons(fpnovlan->ophdr.flags) & BNXEF_FIP_FLAGS_A)?1: 0;
			fcfp->flags_f =
			(htons(fpnovlan->ophdr.flags) & BNXEF_FIP_FLAGS_F)? 1:0;
			fcfp->flags_s =
			(htons(fpnovlan->ophdr.flags) & BNXEF_FIP_FLAGS_S)? 1:0;
			ophdrflags = htons(fpnovlan->ophdr.flags);
		}
		mutex_exit(&fcfp->fcf_mutex);
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		if (ophdrflags & BNXEF_FIP_FLAGS_S) {
			ASSERT((dsp->fip_disc_status & FIP_VLAN_REQUEST_SENT) ==
				FIP_VLAN_REQUEST_SENT);
			ASSERT((dsp->fip_disc_status &
				FIP_VLAN_RESPONSE_RECEIVED) ==
				FIP_VLAN_RESPONSE_RECEIVED);
			ASSERT((dsp->fip_disc_status & FIP_DISC_SOL_SENT) ==
				FIP_DISC_SOL_SENT);
			mutex_enter(&fcfp->fcf_mutex);
			fcfp->max_fcoe_size_verified = 1;
			mutex_exit(&fcfp->fcf_mutex);
			if ((dsp->fip_disc_status &
				FIP_UNICAST_DISC_ADV_RECEIVED) == 0) {
				dsp->fip_disc_status  |=
					FIP_UNICAST_DISC_ADV_RECEIVED;
				/*
				 * Now trigger the FP attach
				 * as soon as possible
				 */
				if (dsp->physical_port_state &
					BNXEF_PHYPORT_ONLINE) {
					if ((dsp->state &
						BNXEF_TRIGGER_FP_ATTACH) == 0) {
						dsp->state |=
							BNXEF_TRIGGER_FP_ATTACH;
						mutex_exit(&dsp->state_mutex);
						(void) timeout(
							bnxef_trigger_fp_attach,
							dsp,
							BNXEF_SEC2TICK(1));
						mutex_enter(&dsp->state_mutex);
					}
				}
			}
		} else  {
			if ((dsp->fip_disc_status &
				FIP_UNICAST_DISC_ADV_RECEIVED) == 0) {
				mutex_enter(&fcfp->fcf_mutex);
				fcfp->max_fcoe_size_verified = 0;
				mutex_exit(&fcfp->fcf_mutex);
				BNXEF_DEBUG(dsp, FIP, -1,
					"%s%d: FCoE Verified set to zero",
					BNXEF_DRIVER_NAME, dsp->instance);
				dsp->fip_disc_status |=
					FIP_MULTICAST_DISC_ADV_RECEIVED;
			} else {
				if ((dsp->fip_disc_state ==
					FIP_LOGIN_READY_STATE) &&
					(dsp->num_fc_ports == 0)) {
					BNXEF_DEBUG(dsp, FIP, -1,
						"%s%d: Ignoring Advertizement",
						BNXEF_DRIVER_NAME,
						dsp->instance);
					mutex_exit(&dsp->state_mutex);
					BNXEF_STATS(dsp, l2_fip_rx_free);
					BNXEF_STATS(dsp, l2_rx_free);
					kmem_free(fip_frame, fip_frame_length);
					freemsg(mp);
					return (BNXEF_SUCCESS);
				}
				/* we should be in Link Maintenance state */
				timeout_id_t tid;

				if (((dsp->fip_disc_status &
					FIP_KEEP_ALIVE_TIMER_ARMED) ==
						FIP_KEEP_ALIVE_TIMER_ARMED) &&
					(fcfp->fcf_state &
						FCF_SELECTED_FOR_LOGIN)) {
					tid = dsp->fip_keep_alive_tmr_hdl;
					dsp->fip_disc_status &=
						~FIP_KEEP_ALIVE_TIMER_ARMED;
					mutex_exit(&dsp->state_mutex);
					untimeout(tid);
					/* Now Re-Arm the FIP Keep Alive */
					tid = timeout(
						bnxef_fip_disc_adv_enforce,
						(void *) dsp,
						BNXEF_SEC2TICK((3 *
						(fcfp->fka_adv_period/1000))));
					mutex_enter(&dsp->state_mutex);
					dsp->fip_keep_alive_tmr_hdl = tid;
					dsp->fip_disc_status |=
						FIP_KEEP_ALIVE_TIMER_ARMED;
				} else {
					mutex_exit(&dsp->state_mutex);
					/* Now Re-Arm the FIP Keep Alive */
					tid = timeout(
						bnxef_fip_disc_adv_enforce,
						(void *) dsp,
						BNXEF_SEC2TICK((3 *
						(fcfp->fka_adv_period/1000))));
					mutex_enter(&dsp->state_mutex);
					dsp->fip_keep_alive_tmr_hdl = tid;
					dsp->fip_disc_status |=
						FIP_KEEP_ALIVE_TIMER_ARMED;

				}

				if (dsp->port_bring_up == 0) {
					mutex_exit(&dsp->state_mutex);

					BNXEF_STATS(dsp, l2_fip_rx_free);
					BNXEF_STATS(dsp, l2_rx_free);
					kmem_free(fip_frame, fip_frame_length);
					freemsg(mp);
					return (BNXEF_SUCCESS);
				}
			}
		}
		fip_status = dsp->fip_disc_status;
		if (fip_status & FIP_UNICAST_DISC_ADV_RECEIVED) {
			dsp->fip_disc_state = FIP_LOGIN_READY_STATE;
			cv_signal(&dsp->fcf_cv);
			if ((dsp->port_bring_up) && (dsp->fcf_ident->flags_a)) {
				mutex_exit(&dsp->state_mutex);
				ret = ddi_taskq_dispatch(dsp->mtq,
					bnxef_bringup_ports, (void *)dsp,
						DDI_NOSLEEP);
				mutex_enter(&dsp->state_mutex);
				if (ret != DDI_SUCCESS) {
					dsp->port_bring_up = 1;
				} else
					dsp->port_bring_up = 0;
			}
			t_id	 = dsp->fip_timeout;
			tid_valid = 1;
			dsp->fip_disc_status &= ~FIP_TIMEOUT_ARMED;
		}
		mutex_exit(&dsp->state_mutex);
		if (tid_valid) {
			untimeout(t_id);
			tid_valid = 0;
		}
		BNXEF_STATS(dsp, l2_fip_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fip_frame, fip_frame_length);
		freemsg(mp);
		break;
	}

	case FIP_PROT_SUB_DISC_SOLICIT:
		/*
		 *  This should not come to us as it should be sent to
		 *  all FCF MAC and it should not come to ENODE MAC.
		 *  Therefore ignore this frame and move on.
		 */
		/* FALL THRU */
		ASSERT(0);
	default:
		BNXEF_STATS(dsp, l2_fip_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fip_frame, fip_frame_length);
		freemsg(mp);
	}

	return (BNXEF_SUCCESS);
}

/*
 * This handles the FLOGI ACCEPT or FDISC ACCEPT and populates the port
 * structure already allocated at the time of bind called by leadville stack.
 */
int
bnxef_fip_vlink_prot_handler(bnxef_driver_state_t *dsp, mblk_t *mp, int flags)
{
	bnxef_fip_frame_t	*fp;
	uint8_t *fip_framep;
	uint16_t fip_frame_length;
	bnxef_fip_frame_novlan_t *fpnovlan;
	uint8_t	 *curdescp;
	uint32_t	length;
	uint8_t fip_subcode;
	int ret;
	fip_mac_addr_desc_fmt_t *macp1 = NULL;

	ASSERT(dsp != NULL);
	ASSERT(mp != NULL);


	fip_frame_length = mp->b_wptr- mp->b_rptr;
	fip_framep = kmem_zalloc(fip_frame_length, KM_NOSLEEP);
	if (fip_framep == NULL) {
		BNXEF_STATS(dsp, l2_fip_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		freemsg(mp);
		return (BNXEF_SUCCESS);
	}
	if (flags) {
		memcpy((uint8_t *)fip_framep, mp->b_rptr,
			(fip_frame_length));
		fp  = (bnxef_fip_frame_t *)fip_framep;
		ASSERT(ntohs(fp->vlan.ether_type) == FIP_ETHERTYPE);
		if (bcmp((void *) dsp->mac_add,
			(void *)&fp->ether.ether_dhost, 6)) {
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Mac address %x:%x:%x:%x:%x:%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				fp->ether.ether_dhost.ether_addr_octet[0],
				fp->ether.ether_dhost.ether_addr_octet[1],
				fp->ether.ether_dhost.ether_addr_octet[2],
				fp->ether.ether_dhost.ether_addr_octet[3],
				fp->ether.ether_dhost.ether_addr_octet[4],
				fp->ether.ether_dhost.ether_addr_octet[5]);

			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_framep, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}
		ASSERT(ntohs(fp->ether.ether_type) == ETHERTYPE_VLAN);
		ASSERT(fp->pdu.version == FIP_FRAME_VER);
		fip_subcode = fp->ophdr.fip_subcode;
		length = htons(fp->ophdr.desc_len);
		curdescp = fp->desc;
	} else {
		memcpy((uint8_t *)fip_framep, mp->b_rptr,
			fip_frame_length);
		fpnovlan = (bnxef_fip_frame_novlan_t *)fip_framep;

		ret = bcmp((void *)dsp->mac_add,
			(void *)&fpnovlan->ether.ether_dhost, 6);
		if (ret) {
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_framep, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}
		ASSERT(fpnovlan->pdu.version == FIP_FRAME_VER);
		fip_subcode = fpnovlan->ophdr.fip_subcode;
		length = htons(fpnovlan->ophdr.desc_len);
		curdescp = fpnovlan->desc;

	}


	switch (fip_subcode) {
	case  FIP_PROT_SUB_VLINK_RESP: {
		fip_fc_desc_fmt_t *fcp = NULL;
		fip_mac_addr_desc_fmt_t *macp = NULL;
		uint32_t	cur_length;
		uint32_t	error = 0;
		uint8_t		hp_ffa = 0;

		BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Length of all descs 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, length);
		if (length == 0) {
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_framep, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}



		while (length > 0) {
			cur_length = curdescp[1];
			BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Desc Length 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance, cur_length);
			BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Cur Desc Type 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance, curdescp[0]);
			switch (curdescp[0]) {
			case  FIP_DESC_FLOGI:
				if (fcp == NULL) {
					/* LINTED: alignment */
					fcp = (fip_fc_desc_fmt_t *)curdescp;
					BNXEF_DEBUG(dsp, FIP, -1,
					"%s%d: FLOGI Length 0x%x",
					BNXEF_DRIVER_NAME, dsp->instance,
					fcp->length);
					if (fcp->length !=
						FIP_FLOGI_DESC_LEN)
						error++;
				} else {
					/*
					 * Already is some other descriptor
					 * is received, one more critical desc
					 * rxed, free the frame and move on
					 */
					error ++;
				}
				break;

			case  FIP_DESC_NPIV_FDISC:
				if (fcp == NULL) {
					/* LINTED: alignment */
					fcp = (fip_fc_desc_fmt_t *)curdescp;
					if (!((fcp->length ==
					    FIP_NPIV_FDISC_DESC_LEN) ||
						(fcp->length ==
					    FIP_NPIV_FDISC_LS_RJT_DESC_LEN)))
						error++;
				} else {
					/*
					 * Already some other Descriptor is
					 * is received, one more critical
					 * desc received, free frame and move
					 * on
					 */
					error++;
				}
				break;
			case  FIP_DESC_LOGO:
				if (fcp == NULL) {
					/* LINTED: alignment */
					fcp  = (fip_fc_desc_fmt_t *)curdescp;
					if ((fcp->length  !=
						FIP_LOGO_DESC_LEN) &&
						(fcp->length !=
						FIP_LOGO_LS_ACC_DESC_LEN))
						error++;
				} else {
					/*
					 * Already some other Descriptor is
					 * is received, one more critical
					 * desc received, free frame and move
					 * on
					 */
					error++;
				}
				break;
			case FIP_DESC_TYPE_MAC_ADDR:
				if (macp == NULL) {
					macp =
					/* LINTED: alignment */
					(fip_mac_addr_desc_fmt_t *)curdescp;
					if (macp->length !=
						FIP_MAC_ADDR_DESC_LEN)
						error++;
				} else {
					if (FCOE_INFO_IS_MF_MODE_SD
						(dsp->bnxe_params.flags)) {
						macp1 =
						/* LINTED: alignment */
						(fip_mac_addr_desc_fmt_t *)
						curdescp;
						if (macp1->length !=
							FIP_MAC_ADDR_DESC_LEN)
							error++;
						hp_ffa++;
					} else error++;
				}
				break;

			default:
				if (curdescp[0] <= FIP_CRITICAL_DESC_TYPE_MAX)
					error++;
				break;
			}
			if (error) break;
			curdescp += (cur_length * sizeof (uint32_t));
			length -= cur_length;
		}
		if (macp == NULL) {
			/* LINTED: alignment */
			fc_frame_hdr_t *fhp = (fc_frame_hdr_t *)fcp->fc_info;
			la_els_logi_t *flogip = (la_els_logi_t *)(fhp +1);
			uint8_t ls_code;

			/* Change the endianess for LS_CODE alone and Check */
			bnxef_big_endian(flogip, 4);
			ls_code = flogip->ls_code.ls_code;
			if (ls_code != LA_ELS_RJT)  {
				error++; /* Mandatory */
			}
			/* Revert it back to original endianness */
			bnxef_big_endian(flogip, 4);
		}
		if (error) {
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_framep, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}

		/* Validate whether the FLOGI has been sent */
		if (fcp->type == FIP_DESC_FLOGI) {
			uint32_t	fip_disc_state;
			/* This should be the response for the FLOGI */
			/* LINTED: alignment */
			fc_frame_hdr_t *fhp = (fc_frame_hdr_t *)fcp->fc_info;
			la_els_logi_t *flogip = (la_els_logi_t *)(fhp +1);
			uint8_t ls_code;

			/* Change the endianess for LS_CODE alone and Check */
			bnxef_big_endian(flogip, 4);
			ls_code = flogip->ls_code.ls_code;

			MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
			fip_disc_state = dsp->fip_disc_state;
			mutex_exit(&dsp->state_mutex);
			ASSERT((fip_disc_state == FIP_LOGIN_READY_STATE) ||
				(fip_disc_state == FIP_VLINK_MAINT_STATE));
			bnxef_big_endian(fhp, sizeof (fc_frame_hdr_t));
			ASSERT(fhp->r_ctl == R_CTL_ELS_RSP);
			ASSERT(fhp->type == FC_TYPE_EXTENDED_LS);
			switch (ls_code) {
			case LA_ELS_ACC: {
				uint8_t mac_addr[ETHERADDRL];

				/* Now the we have receieved an accept */
				bnxef_lport_t *lportp;
				fip_mac_addr_desc_fmt_t  *macp =
					(fip_mac_addr_desc_fmt_t *)(flogip +1);

				/* Find the Lport allocated at Bind time */
				lportp =
				bnxef_port_list_find_flags(dsp,
					BNXEF_FC_PORT_ID_NOT_ACQUIRED);

				if (lportp == NULL) {
					BNXEF_STATS(dsp, l2_fip_rx_free);
					BNXEF_STATS(dsp, l2_rx_free);
					kmem_free(fip_framep, fip_frame_length);
					freemsg(mp);
					return (BNXEF_SUCCESS);
				}

				/*
				 * Fill in the port information received
				 */
				mutex_enter(&lportp->port_mutex);
				lportp->id = fhp->d_id;
				bcopy(&macp->mac_addr_lsb, &mac_addr[2], 4);
				mac_addr[0] = macp->mac_addr_msb1;
				mac_addr[1] = macp->mac_addr_msb0;

				BNXEF_DEBUG(dsp, ERROR, -1,
					"%s%d: LS_ACC received for FLOGI",
					BNXEF_DRIVER_NAME, dsp->instance);
				bcopy(mac_addr, lportp->mac_addr, 6);
				if (FCOE_INFO_IS_MF_MODE_SD
					(dsp->bnxe_params.flags)) {
					bnxef_fcf_info_t *myfcfp;

					myfcfp = dsp->fcf_ident;
					bcopy(&macp1->mac_addr_lsb,
						&mac_addr[2], 4);
					mac_addr[0] = macp1->mac_addr_msb1;
					mac_addr[1] = macp1->mac_addr_msb0;
					bcopy(mac_addr,
						myfcfp->fcoe_mac_addr, 6);
					myfcfp->hp_ffa_flag = 1;
				} else {
					bnxef_fcf_info_t *myfcfp;

					myfcfp = dsp->fcf_ident;
					bcopy(myfcfp->mac_addr,
						myfcfp->fcoe_mac_addr, 6);
				}

				bcopy((uint8_t *)flogip,
					(uint8_t *)&lportp->fcf_logi_info,
					sizeof (la_els_logi_t));
				lportp->flags |= (BNXEF_FC_PORT_N_PORT |
						BNXEF_FC_PORT_ID_ACQUIRED);
				lportp->flags &=
					~BNXEF_FC_PORT_ID_NOT_ACQUIRED;
				lportp->fip_state |=
						FIP_FLOGI_LS_ACC_RECEIVED;
				bcopy(&fp->ether.ether_shost, mac_addr, 6);
				lportp->fcf = bnxef_fcf_list_find_mac_addr(dsp,
						mac_addr);
				ASSERT(lportp->fcf != NULL);
				lportp->vlan_id = lportp->fcf->vlan_id;
				/* Secs */
				lportp->vn_period =
					lportp->fcf->fka_adv_period/1000;

				cv_signal(&lportp->id_cv);
				mutex_exit(&lportp->port_mutex);
				break;
			}
			case LA_ELS_RJT: {
				/* Now you have received  LS_RJT */
				bnxef_lport_t *lportp;
				la_els_rjt_t *lsrjtp =
					(la_els_rjt_t *)(fhp + 1);

				/* Find the Lport allocated at Bind time */
				lportp =
				bnxef_port_list_find_flags(dsp,
					BNXEF_FC_PORT_ID_NOT_ACQUIRED);
				BNXEF_DEBUG(dsp, ERROR, -1,
					"%s%d: LS_RJT received for FLOGI",
					BNXEF_DRIVER_NAME, dsp->instance);
				mutex_enter(&lportp->port_mutex);
				ASSERT(lportp-> flags ==
					BNXEF_FC_PORT_ID_NOT_ACQUIRED);
				dsp->fip_disc_state = FIP_LOGIN_READY_STATE;
				lportp->fip_state |= FIP_FLOGI_LS_RJT_RECEIVED;
				lportp->fip_action = lsrjtp->action;
				lportp->fip_reason = lsrjtp->reason;
				cv_signal(&lportp->id_cv);
				mutex_exit(&lportp->port_mutex);
				break;
			}

			default:
				cmn_err(CE_PANIC, "%s%d: Unknown Response\n",
					BNXEF_DRIVER_NAME, dsp->instance);
			}
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_framep, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		} else 	if (fcp->type == FIP_DESC_NPIV_FDISC) {
			uint32_t fip_disc_state;

			/* This should be the response for the FLOGI */
			/* LINTED: alignment */
			fc_frame_hdr_t *fhp = (fc_frame_hdr_t *)fcp->fc_info;
			la_els_logi_t *fdiscp =
					(la_els_logi_t *)(fhp + 1);
			bnxef_big_endian(fhp, sizeof (fc_frame_hdr_t));
			MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
			fip_disc_state = dsp->fip_disc_state;
			mutex_exit(&dsp->state_mutex);
			ASSERT((fip_disc_state == FIP_LOGIN_READY_STATE) ||
				(fip_disc_state == FIP_VLINK_MAINT_STATE));
			ASSERT(fhp->r_ctl == R_CTL_ELS_RSP);
			ASSERT(fhp->type == FC_TYPE_EXTENDED_LS);
			bnxef_big_endian(fdiscp, 4);
			switch (fdiscp->ls_code.ls_code) {
			case LA_ELS_ACC: {
				/* Now the we have receieved an accept */
				bnxef_lport_t *lportp;
				uint8_t mac_addr[ETHERADDRL];

				fip_mac_addr_desc_fmt_t  *macp =
					(fip_mac_addr_desc_fmt_t *)(fdiscp +1);

				/* Find the Lport allocated at Bind time */
				lportp =
				bnxef_port_list_find_flags(dsp,
					BNXEF_FC_PORT_ID_NOT_ACQUIRED);
				if (lportp == NULL) {
					BNXEF_STATS(dsp, l2_fip_rx_free);
					BNXEF_STATS(dsp, l2_rx_free);
					kmem_free(fip_framep, fip_frame_length);
					freemsg(mp);
					return (BNXEF_SUCCESS);
				}
				/*
				 * Fill in the port information received
				 */
				mutex_enter(&lportp->port_mutex);
				lportp->id = fhp->d_id;
				bcopy(&macp->mac_addr_lsb, &mac_addr[2], 4);
				mac_addr[0] = macp->mac_addr_msb1;
				mac_addr[1] = macp->mac_addr_msb0;

				bcopy(mac_addr, lportp->mac_addr, 6);
				if (FCOE_INFO_IS_MF_MODE_SD
					(dsp->bnxe_params.flags)) {
					bnxef_fcf_info_t *myfcfp;

					myfcfp = dsp->fcf_ident;
					bcopy(&macp1->mac_addr_lsb,
						&mac_addr[2], 4);
					mac_addr[0] = macp1->mac_addr_msb1;
					mac_addr[1] = macp1->mac_addr_msb0;
					bcopy(mac_addr,
					myfcfp->fcoe_mac_addr, 6);
					myfcfp->hp_ffa_flag = 1;
				} else {
					bnxef_fcf_info_t *myfcfp;

					myfcfp = dsp->fcf_ident;
					bcopy(myfcfp->mac_addr,
						myfcfp->fcoe_mac_addr, 6);
				}

				bcopy((uint8_t *)fdiscp,
					(uint8_t *)&lportp->fcf_logi_info,
					sizeof (la_els_logi_t));
				lportp->flags |= (BNXEF_FC_PORT_VN_PORT |
						BNXEF_FC_PORT_ID_ACQUIRED);
				lportp->flags &=
					~BNXEF_FC_PORT_ID_NOT_ACQUIRED;
				lportp->fcf = dsp->fcf_ident;
				lportp->vlan_id = lportp->fcf->vlan_id;
				/* Millisec */
				lportp->vn_period = FKA_VN_PERIOD;
				lportp->fip_state |=
						FIP_FDISC_LS_ACC_RECEIVED;
				/*
				 * Consider this as a session
				 * established between this port
				 * and the FFFFFE and create a session
				 * pointer and save that
				 * into one of the hash bucket.
				 */
				bnxef_create_rport_session(lportp, fhp,
					fdiscp, &fp->ether);

				cv_signal(&lportp->id_cv);
				mutex_exit(&lportp->port_mutex);
				break;
			}
			case LA_ELS_RJT: {
				/* Now you have received  LS_RJT */
				bnxef_lport_t *lportp;
				la_els_rjt_t *lsrjtp =
					(la_els_rjt_t *)(fhp + 1);

				/* Find the Lport allocated at Bind time */
				lportp =
				bnxef_port_list_find_flags(dsp,
					BNXEF_FC_PORT_ID_NOT_ACQUIRED);
				if (lportp == NULL) {
					BNXEF_STATS(dsp, l2_fip_rx_free);
					BNXEF_STATS(dsp, l2_rx_free);
					kmem_free(fip_framep, fip_frame_length);
					freemsg(mp);
					return (BNXEF_SUCCESS);
				}
				mutex_enter(&lportp->port_mutex);
				ASSERT(lportp-> flags ==
					BNXEF_FC_PORT_ID_NOT_ACQUIRED);
				lportp->fip_state |= FIP_FDISC_LS_RJT_RECEIVED;
				lportp->fip_action = lsrjtp->action;
				lportp->fip_reason = lsrjtp->reason;
				cv_signal(&lportp->id_cv);
				mutex_exit(&lportp->port_mutex);
				break;
			}
			default:
				cmn_err(CE_PANIC, "%s%d: Unknown Response\n",
					BNXEF_DRIVER_NAME, dsp->instance);
			}
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_framep, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		} else if (fcp->type == FIP_DESC_LOGO) {
			/* LINTED: alignment */
			fc_frame_hdr_t *fhp = (fc_frame_hdr_t *)fcp->fc_info;
			la_els_logo_t *logop =
					(la_els_logo_t *)(fhp + 1);
			uint32_t fip_disc_state;

			bnxef_big_endian(fhp, sizeof (fc_frame_hdr_t));
			MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
			fip_disc_state = dsp->fip_disc_state;
			mutex_exit(&dsp->state_mutex);
			ASSERT((fip_disc_state & FIP_VLINK_MAINT_STATE) ==
				FIP_VLINK_MAINT_STATE);
			ASSERT(fhp->r_ctl ==
				    (R_CTL_SOLICITED_CONTROL |
					R_CTL_EXTENDED_SVC));
			bnxef_big_endian(logop, 4);
			switch (logop->ls_code.ls_code) {
			case LA_ELS_ACC: {
				bnxef_lport_t *lportp;
				fip_mac_addr_desc_fmt_t  *macp =
					/* LINTED: alignment */
					(fip_mac_addr_desc_fmt_t *)
					((uint8_t *)logop + 4);

				uint8_t mac_addr[ETHERADDRL];

				bcopy(&macp->mac_addr_lsb, &mac_addr[2], 4);
				mac_addr[0] = macp->mac_addr_msb1;
				mac_addr[1] = macp->mac_addr_msb0;

				lportp =
				bnxef_port_list_find_id(dsp,
					mac_addr,
					VLAN_ID(htons(fp->vlan.ether_tci)),
					fhp->d_id);
				if (lportp == NULL) {
					BNXEF_STATS(dsp, l2_fip_rx_free);
					BNXEF_STATS(dsp, l2_rx_free);
					kmem_free(fip_framep, fip_frame_length);
					freemsg(mp);
					return (BNXEF_SUCCESS);
				}
				ASSERT(lportp != NULL);
				mutex_enter(&lportp->port_mutex);
				ASSERT((lportp->fip_state & FIP_LOGO_SENT) ==
					FIP_LOGO_SENT);
				lportp->fip_state |= FIP_LOGO_LS_ACC_RECEIVED;
				cv_signal(&lportp->id_cv);
				mutex_exit(&lportp->port_mutex);
				break;
			}
			case LA_ELS_RJT: {
				bnxef_lport_t *lportp;
				fip_mac_addr_desc_fmt_t  *macp =
					/* LINTED: alignment */
					(fip_mac_addr_desc_fmt_t *)
					((uint8_t *)logop + 4);
				la_els_rjt_t *lsrjtp =
					(la_els_rjt_t *)(fhp + 1);

				uint8_t mac_addr[ETHERADDRL];

				bcopy(&macp->mac_addr_lsb, &mac_addr[2], 4);
				mac_addr[0] = macp->mac_addr_msb1;
				mac_addr[1] = macp->mac_addr_msb0;

				lportp =
				bnxef_port_list_find_id(dsp,
						mac_addr,
						VLAN_ID(fp->vlan.ether_tci),
						fhp->d_id);
				if (lportp == NULL) {
					BNXEF_STATS(dsp, l2_fip_rx_free);
					BNXEF_STATS(dsp, l2_rx_free);
					kmem_free(fip_framep, fip_frame_length);
					freemsg(mp);
					return (BNXEF_SUCCESS);
				}
				ASSERT(lportp != NULL);
				mutex_enter(&lportp->port_mutex);
				ASSERT((lportp->fip_state & FIP_LOGO_SENT) ==
					FIP_LOGO_SENT);
				lportp->fip_state |= FIP_LOGO_LS_RJT_RECEIVED;
				lportp->fip_action = lsrjtp->action;
				lportp->fip_reason = lsrjtp->reason;
				cv_signal(&lportp->id_cv);
				mutex_exit(&lportp->port_mutex);
				break;
			}

			default:
				cmn_err(CE_PANIC, "%s%d: Unknown Response\n",
					BNXEF_DRIVER_NAME, dsp->instance);
			}
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_framep, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		} else {
			cmn_err(CE_PANIC, "%s%d: Unknown descriptor\n",
				BNXEF_DRIVER_NAME, dsp->instance);
		}
		break;
	}
	case  FIP_PROT_SUB_VLINK_INIT_REQ:  {
		fip_fc_desc_fmt_t *fcp = NULL;
		fip_mac_addr_desc_fmt_t *macp = NULL;
		uint32_t	cur_length;
		uint32_t	error = 0;
		int ret;

		BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Length of all descs 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, length);
		if (length == 0) {
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_framep, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}
		while (length > 0) {
			cur_length = curdescp[1];
			BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Desc Length 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance, cur_length);
			BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Cur Desc Type 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance, curdescp[0]);
			switch (curdescp[0]) {
			case  FIP_DESC_FLOGI:
				if (fcp == NULL) {
					/* LINTED: alignment */
					fcp = (fip_fc_desc_fmt_t *)curdescp;
					BNXEF_DEBUG(dsp, FIP, -1,
					"%s%d: FLOGI Length 0x%x",
					BNXEF_DRIVER_NAME, dsp->instance,
					fcp->length);
					if (fcp->length !=
						FIP_FLOGI_DESC_LEN)
						error++;
				} else {
					/*
					 * Already is some other descriptor
					 * is received, one more critical desc
					 * rxed, free the frame and move on
					 */
					error ++;
				}
				break;

			case  FIP_DESC_NPIV_FDISC:
				if (fcp == NULL) {
					/* LINTED: alignment */
					fcp = (fip_fc_desc_fmt_t *)curdescp;
					if (fcp->length !=
						FIP_NPIV_FDISC_DESC_LEN)
						error++;
				} else {
					/*
					 * Already some other Descriptor is
					 * is received, one more critical
					 * desc received, free frame and move
					 * on
					 */
					error++;
				}
				break;
			case  FIP_DESC_LOGO:
				if (fcp == NULL) {
					/* LINTED: alignment */
					fcp  = (fip_fc_desc_fmt_t *)curdescp;
					if ((fcp->length  !=
						FIP_LOGO_DESC_LEN) &&
						(fcp->length !=
						FIP_LOGO_LS_ACC_DESC_LEN))
						error++;
				} else {
					/*
					 * Already some other Descriptor is
					 * is received, one more critical
					 * desc received, free frame and move
					 * on
					 */
					error++;
				}
				break;
			case FIP_DESC_TYPE_MAC_ADDR:
				if (macp == NULL) {
					macp =
					/* LINTED: alignment */
					(fip_mac_addr_desc_fmt_t *)curdescp;
					if (macp->length !=
						FIP_MAC_ADDR_DESC_LEN)
						error++;
				} else {
					/* Duplicate Mac descriptor */
					error ++;
				}
				break;

			default:
				if (curdescp[0] <= FIP_CRITICAL_DESC_TYPE_MAX)
					error++;
				break;
			}
			if (error) break;
			curdescp += (cur_length * sizeof (uint32_t));
			length -= cur_length;
		}
		if (macp == NULL) {
			cmn_err(CE_NOTE, "%s%d:MAC address descriptor Missing",
				BNXEF_DRIVER_NAME, dsp->instance);
			error++; /* Mandatory */
		}
		if (error) {
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_framep, fip_frame_length);
			freemsg(mp);
			return (BNXEF_SUCCESS);
		}


		/* Only LOGO Is handled - All others are ignored */
		/*
		 * This implementation is for an ENODE MAC, therefore
		 * we may not get such request, if we get ignore and move on.
		 */
		if (fcp->type ==  FIP_DESC_LOGO) {
			/* LINTED: alignment */
			fc_frame_hdr_t *fhp = (fc_frame_hdr_t *)fcp->fc_info;
			la_els_logo_t *logop =
					(la_els_logo_t *)(fhp + 1);
			uint32_t fip_disc_state;

			bnxef_big_endian(fhp, sizeof (fc_frame_hdr_t));
			MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
			fip_disc_state = dsp->fip_disc_state;
			mutex_exit(&dsp->state_mutex);
			ASSERT((fip_disc_state & FIP_VLINK_MAINT_STATE) ==
				FIP_VLINK_MAINT_STATE);
			ASSERT(fhp->r_ctl ==
				    (R_CTL_UNSOL_CONTROL | R_CTL_EXTENDED_SVC));
			bnxef_big_endian(logop, 4);
			switch (logop->ls_code.ls_code)  {
			case LA_ELS_LOGO: {
				bnxef_lport_t *lportp;
				fip_mac_addr_desc_fmt_t  *macp =
					/* LINTED: alignment */
					(fip_mac_addr_desc_fmt_t *)
						((uint8_t *)logop + 16);
				uint8_t mac_addr[ETHERADDRL];

				bcopy(&macp->mac_addr_lsb, &mac_addr[2], 4);
				mac_addr[0] = macp->mac_addr_msb1;
				mac_addr[1] = macp->mac_addr_msb0;

				lportp =
				bnxef_port_list_find_id(dsp,
					mac_addr,
					VLAN_ID(htons(fp->vlan.ether_tci)),
					fhp->d_id);
				if (lportp == NULL) {
					BNXEF_STATS(dsp, l2_fip_rx_free);
					BNXEF_STATS(dsp, l2_rx_free);
					kmem_free(fip_framep, fip_frame_length);
					freemsg(mp);
					return (BNXEF_SUCCESS);
				}

				if (fhp->s_id  != FS_FABRIC_F_PORT) {
					ret = bnxef_fip_sm_send_ls_rjt(dsp,
						lportp, fhp->ox_id, fhp->s_id);

					BNXEF_STATS(dsp, l2_fip_rx_free);
					BNXEF_STATS(dsp, l2_rx_free);
					kmem_free(fip_framep, fip_frame_length);
					freemsg(mp);
					return (BNXEF_SUCCESS);
				}
				ret = bnxef_fip_sm_send_ls_acc(dsp, lportp,
					fhp->ox_id);
				ASSERT(ret == BNXEF_SUCCESS);
				if (lportp->flags & BNXEF_FC_PORT_N_PORT) {
					ret = ddi_taskq_dispatch(dsp->tq,
						bnxef_implicit_fabric_logout,
						dsp, DDI_NOSLEEP);
					if (ret != DDI_SUCCESS) {
						BNXEF_DEBUG(dsp, ERROR, -1,
						"%s%d: Unable to dispatch\
						 impl logout routine",
						BNXEF_DRIVER_NAME,
						dsp->instance);
					}
				} else {
					uint32_t fip_state;

					mutex_enter(&lportp->port_mutex);
					lportp->fip_state  |=
					FIP_VIRTUAL_LINK_CLEAR_IN_PROGRESS;
					mutex_exit(&lportp->port_mutex);
					bnxef_fc_port_offline((void *)lportp);
					delay(BNXEF_SEC2TICK(2));
					mutex_enter(&lportp->port_mutex);
					fip_state = lportp->fip_state;
					mutex_exit(&lportp->port_mutex);
					/*
					 * This will cleanup all
					 * sessions and I/Os
					 */
					if ((fip_state & FIP_LOGO_SENT) == 0)
						bnxef_shutdown_port(lportp);

					ret = bnxef_port_get_id(lportp,
						LA_ELS_FDISC);
					if (ret != BNXEF_SUCCESS) {
						BNXEF_STATS(dsp,
							l2_fip_rx_free);
						BNXEF_STATS(dsp, l2_rx_free);
						kmem_free(fip_framep,
							fip_frame_length);
						freemsg(mp);
						return (BNXEF_SUCCESS);
					}

					mutex_enter(&lportp->port_mutex);
					lportp->fip_state  &=
					~FIP_VIRTUAL_LINK_CLEAR_IN_PROGRESS;
					mutex_exit(&lportp->port_mutex);
					bnxef_fc_port_online((void *) lportp);
				}
			}

			}
		}
	}
		/* FALL THRU */
	default:
		BNXEF_STATS(dsp, l2_fip_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fip_framep, fip_frame_length);
		freemsg(mp);
		return (BNXEF_SUCCESS);
	}
	kmem_free(fip_framep, fip_frame_length);
	return (BNXEF_FAILURE);
}


/*
 * For an ENODE MAC we should not receive FIP KEEP ALIVE FRAMES, but could
 * receive the Virtual link clear from FCF MAC. Indicating which such links
 * need to be cleared.
 */
void
bnxef_fip_vlink_maintenance_prot_handler(void *params)
{
	bnxef_driver_state_t *dsp;
	mblk_t *mp;
	bnxef_fip_frame_t	*fp;
	bnxef_fip_frame_novlan_t *fpnovlan;
	bnxef_tq_params_t	 *tqp;
	int	flags = 1;
	int	n_port_clear = 0;
	uint32_t	 state;
	timeout_id_t tid;
	int	tid_valid = 0;
	uint32_t fip_state;
	uint8_t *fip_framep;
	uint16_t fip_frame_length;
	uint32_t length;
	uint8_t  *curdescp;
	uint8_t fip_subcode;
	uint16_t vlan_id;


	ASSERT(params != NULL);
	tqp = (bnxef_tq_params_t *)params;
	dsp = tqp->dsp;
	mp = tqp->mp;
	flags = tqp->flags;

	ASSERT(dsp != NULL);
	ASSERT(mp != NULL);
	kmem_cache_free(dsp->tq_params_cache, tqp);
	mutex_enter(&dsp->state_mutex);
	if (dsp->fcf_ident == NULL) {
		mutex_exit(&dsp->state_mutex);
		BNXEF_STATS(dsp, l2_fip_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		freemsg(mp);
		return;
	}
	mutex_exit(&dsp->state_mutex);
	fip_frame_length = mp->b_wptr- mp->b_rptr;
	fip_framep = kmem_zalloc(fip_frame_length, KM_NOSLEEP);
	if (fip_framep == NULL) {
		BNXEF_STATS(dsp, l2_fip_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		freemsg(mp);
	}

	if (flags) {
		// fp = (bnxef_fip_frame_t *)mp->b_rptr;
		memcpy((uint8_t *)fip_framep, mp->b_rptr,
			(fip_frame_length));
		fp  = (bnxef_fip_frame_t *)fip_framep;
		ASSERT(ntohs(fp->vlan.ether_type) == FIP_ETHERTYPE);
		if (bcmp((void *)dsp->fcf_ident->mac_addr,
			&fp->ether.ether_shost, 6)) {
			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: LM frame from unknown FCF- Dropped",
				BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_framep, fip_frame_length);
			freemsg(mp);
			return;
		}
		ASSERT(ntohs(fp->ether.ether_type) == ETHERTYPE_VLAN);
		ASSERT(fp->pdu.version == FIP_FRAME_VER);

		length = htons(fp->ophdr.desc_len);
		curdescp = fp->desc;
		fip_subcode = fp->ophdr.fip_subcode;

	} else {
		memcpy((uint8_t *)fip_framep, mp->b_rptr,
			(fip_frame_length));
		fpnovlan = (bnxef_fip_frame_novlan_t *)fip_framep;
		if (bcmp((void *)dsp->fcf_ident->mac_addr,
			&fpnovlan->ether.ether_shost, 6)) {
			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: LM frame from unknown FCF- Dropped",
				BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_framep, fip_frame_length);
			freemsg(mp);
			return;
		}
		length = htons(fpnovlan->ophdr.desc_len);
		curdescp = fpnovlan->desc;
		fip_subcode = fpnovlan->ophdr.fip_subcode;

	}
	switch (fip_subcode) {
	case  FIP_PROT_SUB_CLEAR_VLINK: {
		fip_mac_addr_desc_fmt_t *macp = NULL;
		fip_name_id_desc_fmt_t	*namep = NULL;
		fip_vx_port_desc_fmt_t  *vxportp[BNXEF_MAX_FC_PORTS] = {NULL};
		uint32_t	cur_length;
		uint32_t	error = 0;
		uint16_t	vx_port_desc_cnt = 0;
		int i, ret;
		bnxef_port_t	*portp;

		BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Length of all descs 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, length);
		while (length > 0) {
			cur_length = curdescp[1];
			BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Desc Length 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance, cur_length);
			BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Cur Desc Type 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance, curdescp[0]);
			switch (curdescp[0]) {
			case  FIP_DESC_TYPE_MAC_ADDR:
				if (macp == NULL) {
					macp =
					/* LINTED: alignment */
					(fip_mac_addr_desc_fmt_t *)curdescp;
					if (macp->length !=
						FIP_MAC_ADDR_DESC_LEN)
						error++;
				} else {
					/*
					 * Already is some other descriptor
					 * is received, one more critical desc
					 * rxed, free the frame and move on
					 */
					error ++;
				}
				break;

			case  FIP_DESC_NAME_IDENTIFIER:
				if (namep == NULL) {
					namep =
					/* LINTED: alignment */
					(fip_name_id_desc_fmt_t *)curdescp;
					if (namep->length !=
						FIP_NAME_ID_DESC_LEN)
						error++;
				} else {
					/*
					 * Already some other Descriptor is
					 * is received, one more critical
					 * desc received, free frame and move
					 * on
					 */
					error++;
				}
				break;
			case  FIP_DESC_VX_PORT_ID:
				if (vxportp[vx_port_desc_cnt] == NULL) {
					vxportp[vx_port_desc_cnt]  =
					/* LINTED: alignment */
					(fip_vx_port_desc_fmt_t *)curdescp;
					if (vxportp[vx_port_desc_cnt]->length
						!=
						FIP_VX_PORT_DESC_LEN)
						error++;
					vx_port_desc_cnt++;
				} else {
					vxportp[vx_port_desc_cnt]  =
					/* LINTED: alignment */
					(fip_vx_port_desc_fmt_t *)curdescp;
					if (vxportp[vx_port_desc_cnt]->length
						!=
						FIP_VX_PORT_DESC_LEN)
						error++;
					vx_port_desc_cnt++;
				}
				break;

			default:
				if (curdescp[0] <= FIP_CRITICAL_DESC_TYPE_MAX)
					error++;
				break;
			}
			if (error) break;
			curdescp += (cur_length * sizeof (uint32_t));
			length -= cur_length;
		}
#if 1
		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Virtual clear received for Physical port, 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, dsp->num_fc_ports);
#endif
		if ((macp == NULL) || (namep == NULL))  error++;

		if (error) {
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_framep, fip_frame_length);
			freemsg(mp);
			return;
		}

		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		if (dsp->state & BNXEF_PORT_CVL_PROCESSING_INPROGRESS) {
			mutex_exit(&dsp->state_mutex);
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_framep, fip_frame_length);
			freemsg(mp);
			return;
		}
		if (dsp->fcf_ident) {
			vlan_id = dsp->fcf_ident->vlan_id;
		} else {
			mutex_exit(&dsp->state_mutex);
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_framep, fip_frame_length);
			freemsg(mp);
			return;
		}
		mutex_exit(&dsp->state_mutex);
		/*
		 * Check the MAC Address descriptor to which it is
		 * addressed to identify whether it is CLEAR VIRTUAL LINK
		 * for the ENODE MAC or to the Virtual port address received
		 * from FCF FPMA method.
		 */
		ret = bcmp((void *)dsp->mac_add,
				(void *)&fp->ether.ether_dhost, 6);
		if (ret != 0) {
			BNXEF_STATS(dsp, l2_fip_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fip_framep, fip_frame_length);
			freemsg(mp);
			return;
		}

		if (vx_port_desc_cnt == 0) {
			n_port_clear = 1;
			MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
			dsp->state |= BNXEF_PORT_CVL_PROCESSING_INPROGRESS;
			mutex_exit(&dsp->state_mutex);
		} else {
			n_port_clear = 0;
			for (i = 0; i < vx_port_desc_cnt; i++) {
				portp = bnxef_port_list_find_id(dsp,
					vxportp[i]->macaddr,
					vlan_id,
					htonl(vxportp[i]->address_id));
				if (portp == NULL) continue;
				if (portp->flags & BNXEF_FC_PORT_N_PORT) {
					n_port_clear = 1;
					MUTEX_ENTER(dsp, &dsp->state_mutex,
						__func__, __LINE__);
					dsp->state |=
					BNXEF_PORT_CVL_PROCESSING_INPROGRESS;
					mutex_exit(&dsp->state_mutex);
					break;
				}
			}
		}

		/*
		 * May be link might go down, wait for few secs before
		 * starting to shut down the port.
		 */
		if (n_port_clear) {
			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Virtual clear received for Physical port, 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, dsp->num_fc_ports);
			for (i = 0; i < dsp->num_fc_ports; i++) {
				/* First MAke all VN_Ports Provided Offline */
				portp = bnxef_port_list_find_flags(dsp,
					(BNXEF_FC_PORT_ID_ACQUIRED |
						BNXEF_FC_PORT_VN_PORT));
				if (portp == NULL) continue;
				BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Port Offline for Id 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance, portp->id);
				bnxef_fc_port_offline((void *) portp);
				/* Just cleanup port for reacquiring ID */
				mutex_enter(&portp->port_mutex);
				fip_state = portp->fip_state;
				mutex_exit(&portp->port_mutex);
				if ((fip_state & FIP_LOGO_SENT) == 0)
					bnxef_shutdown_port(portp);
			}
			/*
			 * For the Orininal N_PORt Cleanup and then
			 * Get the ID.
			 */
			portp = bnxef_port_list_find_flags(dsp,
				(BNXEF_FC_PORT_ID_ACQUIRED |
					BNXEF_FC_PORT_N_PORT));
			if (portp == NULL) {
				/*
				 * Means already shutdown has happend
				 * because of offline
				 * or unload request, ignore this CVL
				 * and move on.
				 */
				mutex_enter(&dsp->state_mutex);
				dsp->state &=
					~BNXEF_PORT_CVL_PROCESSING_INPROGRESS;
				mutex_exit(&dsp->state_mutex);
				BNXEF_STATS(dsp, l2_fip_rx_free);
				BNXEF_STATS(dsp, l2_rx_free);
				kmem_free(fip_framep, fip_frame_length);
				freemsg(mp);
				return;
			}
			ASSERT(portp != NULL);
			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Port Offline for Id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, portp->id);
			bnxef_fc_port_offline(portp);

			/* delay(BNXEF_SEC2TICK(2)); */
			mutex_enter(&portp->port_mutex);
			fip_state = portp->fip_state;
			mutex_exit(&portp->port_mutex);
			if ((fip_state & FIP_LOGO_SENT) == 0)
				bnxef_shutdown_port(portp);

			/*
			 * Here do the VLAN discovery and discovery
			 * advertizements to get fip_disc_state to LOGIN
			 * ready state.
			 */
			MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
			state = dsp->physical_port_state;
			if (dsp->fip_disc_status &
				FIP_KEEP_ALIVE_TIMER_ARMED) {
				tid = dsp->fip_keep_alive_tmr_hdl;
				tid_valid = 1;
				dsp->fip_disc_status &=
					~FIP_KEEP_ALIVE_TIMER_ARMED;
			}
			dsp->fip_disc_state = 0;
			dsp->fip_disc_status = 0;
			mutex_exit(&dsp->state_mutex);
			if (tid_valid) untimeout(tid);

			MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
			dsp->state &= ~BNXEF_PORT_CVL_PROCESSING_INPROGRESS;
			dsp->port_bring_up = 1;
			mutex_exit(&dsp->state_mutex);

			/*
			 * If the state is Online, then start FIP State
			 * machine
			 */
			if (state) {
				mutex_enter(&dsp->state_mutex);
				dsp->fcf_ident = NULL;
				mutex_exit(&dsp->state_mutex);
				bnxef_fcf_list_purge(dsp);
				ret = ddi_taskq_dispatch(dsp->tq,
					bnxef_fip_sm_start, dsp,
					DDI_SLEEP);
				if (ret != DDI_SUCCESS) {
					BNXEF_DEBUG(dsp, GENERAL, -1,
					"%s%d:Unable to schedule tq\n",
					BNXEF_DRIVER_NAME, dsp->instance);
					ASSERT(ret == DDI_SUCCESS);
					return;
				}
				BNXEF_DEBUG(dsp, ERROR, -1,
					"%s%d: Fip State machine Triggered\n",
					BNXEF_DRIVER_NAME, dsp->instance);


			} else {
				BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d; CVL didnot bringup ports",
				BNXEF_DRIVER_NAME, dsp->instance);
			}
		} else {
			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Identified CVL for a Virtual port",
				BNXEF_DRIVER_NAME, dsp->instance);
			/*
			 * For each Vx Port Descriptor, Handle the cleanup
			 */
			for (i = 0; i < vx_port_desc_cnt; i++) {
				ASSERT(dsp->fcf_ident != NULL);
				portp = bnxef_port_list_find_id(dsp,
					vxportp[i]->macaddr,
					vlan_id,
					htonl(vxportp[i]->address_id));
				if (portp == NULL) {
					BNXEF_DEBUG(dsp, ERROR, -1,
					"%s%d: Port is NULL for id 0x%x",
						BNXEF_DRIVER_NAME,
						dsp->instance,
						htonl(vxportp[i]->address_id));
					continue;
				}
				mutex_enter(&portp->port_mutex);
				portp->fip_state  |=
					FIP_VIRTUAL_LINK_CLEAR_IN_PROGRESS;
				mutex_exit(&portp->port_mutex);
				bnxef_fc_port_offline((void *)portp);
				//delay(BNXEF_SEC2TICK(2));
				mutex_enter(&portp->port_mutex);
				fip_state = portp->fip_state;
				mutex_exit(&portp->port_mutex);
				/* This will cleanup all sessions and I/Os */
				if ((fip_state & FIP_LOGO_SENT) == 0)
					bnxef_shutdown_port(portp);

				ret = bnxef_port_get_id(portp, LA_ELS_FDISC);
				if (ret != BNXEF_SUCCESS) continue;
				mutex_enter(&portp->port_mutex);
				portp->fip_state  &=
					~FIP_VIRTUAL_LINK_CLEAR_IN_PROGRESS;
				mutex_exit(&portp->port_mutex);
				bnxef_fc_port_online((void *) portp);
			}
		}
		break;
	}
	default:
		BNXEF_DEBUG(dsp, FIP, -1,
			"%s%d Wrong Frame received 0x%x",
			fp->ophdr.fip_subcode);
			break;
	}
	BNXEF_STATS(dsp, l2_fip_rx_free);
	BNXEF_STATS(dsp, l2_rx_free);
	kmem_free(fip_framep, fip_frame_length);
	freemsg(mp);
}

/*
 * This will send appropriate FIP Flogi or FdISC to get the address for the
 * online, offline or clear virtual link scenarios.
 */
int
bnxef_port_get_id(bnxef_port_t *portp, int cmd)
{
	bnxef_driver_state_t *dsp;
	uint16_t	retry_count = 0;
	uint8_t		portname[8];
	uint8_t		nodename[8];
	uint32_t	fip_state;
	int ret;


	ASSERT(portp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);

#ifdef TEST_LS_ACC_DROP
			vlan_id = dsp->fcf_ident->vlan_id;
#endif
	retry_count = 0;
	for (; ; ) {
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		if (dsp->state & BNXEF_L2_UNLOAD_CALLED) {
			mutex_exit(&dsp->state_mutex);
			return (BNXEF_FAILURE);
		}
		if (dsp->state & BNXEF_IMPLICIT_FABRIC_LOGO_IN_PROGRESS) {
			mutex_exit(&dsp->state_mutex);
			return (BNXEF_FAILURE);
		}
		if ((dsp->physical_port_state & BNXEF_PHYPORT_ONLINE) == 0) {
			mutex_exit(&dsp->state_mutex);
			return (BNXEF_FAILURE);
		}
		mutex_exit(&dsp->state_mutex);

		mutex_enter(&portp->port_mutex);
		/* Get the portname and nodename */
		bcopy((uint8_t *)&portp->plogi_info.nport_ww_name.raw_wwn[0],
			portname, 8);
		bcopy((uint8_t *)&portp->plogi_info.node_ww_name.raw_wwn[0],
			nodename, 8);
		mutex_exit(&portp->port_mutex);

		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Sending the FLOGI with retry count 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, retry_count);
#ifdef TEST_LS_ACC_DROP
			dsp->fcf_ident->vlan_id = 100;
			if (retry_count > 100)
				dsp->fcf_ident->vlan_id = vlan_id;
#endif
#ifdef TEST_LS_RJT
			cmd = LA_ELS_FDISC;
			if (retry_count > 50)
				cmd = LA_ELS_FLOGI;
			if (retry_count == 25)
				ddi_taskq_dispatch(dsp->tq,
					bnxef_fip_disc_adv_enforce,
					(void *)dsp, DDI_SLEEP);
#endif
		/*
		 * Now try to acquire another ID, by sending FIP FDISC
		 */
		ret = bnxef_fip_sm_send_flogi_fdisc(dsp, cmd,
			portp->fip_task->x_id, portname, nodename);
		if (ret != BNXEF_SUCCESS) {
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Unable to send FIP FDISC",
				BNXEF_DRIVER_NAME, dsp->instance);
			retry_count++;
			continue;
		}
		mutex_enter(&portp->port_mutex);
		if (cmd == LA_ELS_FDISC)
			portp->fip_state |= FIP_FDISC_SENT;
		else
			portp->fip_state |= FIP_FLOGI_SENT;
		ret = cv_timedwait(&portp->id_cv, &portp->port_mutex,
				ddi_get_lbolt() + BNXEF_SEC2TICK(2));
		if (ret < 0) {
			mutex_exit(&portp->port_mutex);
			retry_count++;
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Response to FLOGI/FDISC not received",
				BNXEF_DRIVER_NAME, dsp->instance);
			continue;
		}
		fip_state = portp->fip_state;
		mutex_exit(&portp->port_mutex);

		if ((fip_state & FIP_FDISC_LS_RJT_RECEIVED) &&
			(cmd == LA_ELS_FDISC)) {
			retry_count++;
		} else  if ((fip_state &  FIP_FLOGI_LS_RJT_RECEIVED) &&
				(cmd == LA_ELS_FLOGI)) {
			retry_count++;
		} else if ((fip_state & FIP_FLOGI_LS_ACC_RECEIVED) &&
				(cmd == LA_ELS_FLOGI)) {
				break;
		} else if ((fip_state & FIP_FDISC_LS_ACC_RECEIVED) &&
				(cmd == LA_ELS_FDISC)) {
				break;
		}
	}
	return (BNXEF_SUCCESS);
}
/*
 * THis will send the frame out on the wire.
 */
boolean_t
bnxef_send_frame(bnxef_driver_state_t *dsp, mblk_t *mp, uint16_t vlan_id)
{
	dev_info_t *pdip = NULL;
	uint16_t	vlan_tag;

	ASSERT(dsp != NULL);
	ASSERT(mp != NULL);

	pdip = ddi_get_parent(dsp->dip);
	ASSERT(pdip != NULL);
	BNXEF_DEBUG(dsp, FIP, -1, "%s%d: Sending the Frame, on vlan 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, vlan_id);
	vlan_tag = vlan_id;
	if (FCOE_INFO_IS_MF_MODE_SD(dsp->bnxe_params.flags))
		return ((dsp->callbacks.prvTx(pdip, mp, 0,
			vlan_tag) == NULL) ? B_TRUE : B_FALSE);
	else
		return ((dsp->callbacks.prvTx(pdip, mp, PRV_TX_VLAN_TAG,
			vlan_tag) == NULL) ? B_TRUE : B_FALSE);
}


void
bnxef_create_rport_session(bnxef_lport_t *portp, fc_frame_hdr_t *fhp,
	la_els_logi_t *plogi_infop, struct ether_header *etherp)
{

	bnxef_driver_state_t  *dsp;
	bnxef_session_t	*sessionp;
	bnxef_port_t *rportp;
	la_els_logi_t *loginp, *srcloginp;
	svc_param_t *class3_param, *src_class3_param;
	uint8_t	hash;


	dsp = portp->statep;
	ASSERT(dsp != NULL);


	/* Allocate a remote port structure from cache and populate info */
	rportp = kmem_cache_alloc(dsp->port_cache, KM_SLEEP);
	ASSERT(rportp != NULL);

	rportp->id = fhp->s_id;
	bcopy(etherp->ether_shost.ether_addr_octet, rportp->mac_addr,
			ETHERADDRL);
	rportp->vlan_id = portp->vlan_id;
	loginp = &rportp->plogi_info;
	srcloginp = (la_els_logi_t *)plogi_infop;
	loginp->ls_code.ls_code = srcloginp->ls_code.ls_code;
	//  bnxef_big_endian(loginp, 4);
	bcopy(&srcloginp->nport_ww_name.raw_wwn[0],
		&loginp->nport_ww_name.raw_wwn[0],  8);
	bcopy(&srcloginp->node_ww_name.raw_wwn[0],
		&loginp->node_ww_name.raw_wwn[0], 8);
	loginp->common_service.fcph_version =
		htons(srcloginp->common_service.fcph_version);
	loginp->common_service.btob_credit =
		htons(srcloginp->common_service.btob_credit);
	loginp->common_service.cmn_features =
		htons(srcloginp->common_service.cmn_features);
	loginp->common_service.conc_sequences =
		htons(srcloginp->common_service.conc_sequences);
	loginp->common_service.relative_offset =
		htons(srcloginp->common_service.relative_offset);
	loginp->common_service.e_d_tov =
		htonl(srcloginp->common_service.e_d_tov);
	class3_param = (svc_param_t *)&loginp->class_3;
	src_class3_param = (svc_param_t *)&srcloginp->class_3;
	class3_param->class_opt = htons(src_class3_param->class_opt);

	class3_param->rcv_size = loginp->common_service.rx_bufsize =
		htons(srcloginp->common_service.rx_bufsize);
	class3_param->conc_sequences = htons(src_class3_param->conc_sequences);
	class3_param->open_seq_per_xchng =
		htons(src_class3_param->open_seq_per_xchng);

	rportp->flags = BNXEF_FC_PORT_REMOTE | BNXEF_FC_PORT_N_PORT;
	if ((rportp->id >= 0xFFFFF7) && (rportp->id < 0xFFFFFF))
		rportp->flags |= BNXEF_FC_PORT_WELL_KNOWN;

	/*
	 * Allocate a session from the session cache and set up all
	 * information pertaining to this session.
	 */

	sessionp = kmem_cache_alloc(dsp->session_cache, KM_SLEEP);
	ASSERT(sessionp != NULL);

	sessionp->lport  = portp;
	sessionp->rport = rportp;

	/* This will initialize the session task list */
	bnxef_task_session_list_init(dsp, sessionp);

	/* Initialize information which will be used when downloaded. */
	sessionp->max_sqes = BNXEF_SQ_WQES_MAX;
	sessionp->max_cqes = BNXEF_CQ_WQES_MAX;
	sessionp->max_rqes = BNXEF_RQ_WQES_MAX;
	sessionp->doorbell_acc = dsp->doorbell_acc;

	/* Initialize the toggle bit */
	sessionp->sq_toggle = 1;
	sessionp->cq_toggle = 1;
	sessionp->sq_prod_idx = 0;
	sessionp->cq_cons_idx = 0;
	sessionp->rq_prod_idx = 0x8000;
	sessionp->rq_cons_idx = 0;

	/*
	 * Until now this session is not visible to any one, but once
	 * added to the port hash list it is visible. Once visible, it should
	 * be protected by appropriate mutex.
	 */

	hash = bnxef_session_gen_hash(rportp->vlan_id, rportp->id,
			rportp->mac_addr);

	/*
	 * Now make it visible, from now on anything updated you should hold
	 * locks appropriately.
	 */
	bnxef_session_list_add(portp, sessionp, hash);
}
