/*
 * The information contained in this file is confidential and proprietary to
 * Broadcom Corporation.  No part of this file may be reproduced or
 * distributed, in any form or by any means for any purpose, without the
 * express written permission of Broadcom Corporation.
 *
 * (c) COPYRIGHT 2010-2012 Broadcom Corporation, ALL RIGHTS RESERVED.
 */

#pragma ident "(C) 2010-2012 Broadcom Corporation"
#pragma ident " $File$$Revision$$Change$$DateTime$"

#include <sys/conf.h>
#include <sys/ddi.h>
#include <sys/stat.h>
#include <sys/pci.h>
#include <sys/sunddi.h>
#include <sys/modctl.h>
#include <sys/cmn_err.h>
#include <sys/file.h>
#include <sys/cred.h>
#include <sys/byteorder.h>
#include <sys/atomic.h>
#include <sys/scsi/scsi.h>
#include <sys/modhash.h>
#include <sys/sunldi.h>
#include <sys/kstat.h>
#include <sys/kmem.h>
#include <sys/ethernet.h>
#include <sys/stream.h>
#include <sys/sunldi.h>

/*
 * leadville header files
 */
#include <sys/fibre-channel/fc_types.h>
#include <sys/fibre-channel/impl/fc_fcaif.h>
#include <bnxe_binding.h>
#include <bnxef_tq_param.h>
#include <bnxef_fcf_info.h>
#include <bnxef_hsi.h>
#include <bnxef_fcoe_task.h>
#include <bnxef_fcoe_session.h>
#include <bnxef_state.h>
#include <bnxef_fip.h>
#include <bnxef_fcoe.h>
#include <bnxef_debug.h>
#include <57xx_fcoe_constants.h>

#if !(defined(__S11) || defined(__S12))
#include <sys/fibre-channel/ulp/fcp.h>
typedef struct bnxef_scsi_lun {
	uchar_t		sl_lun1_msb;
	uchar_t		sl_lun1_lsb;
	uchar_t		sl_lun2_msb;
	uchar_t		sl_lun2_lsb;
	uchar_t		sl_lun3_msb;
	uchar_t		sl_lun3_lsb;
	uchar_t		sl_lun4_msb;
	uchar_t		sl_lun4_lsb;
} bnxef_scsi_lun_t;
#endif
extern int bnxef_task_bd_table_alloc(bnxef_session_t *sessionp,
	fc_packet_t *pktp);
extern int
bnxef_task_cmd_bd_table_alloc(bnxef_session_t *sessionp, fc_packet_t *pktp);
extern bnxef_fcoe_task_t *
bnxef_task_alloc(bnxef_driver_state_t *dsp, int sleepflag);

extern void bnxef_big_endian(void *bufp, int size);
extern int bnxef_get_active_ios(bnxef_session_t *sessionp);

void bnxef_log_buf(bnxef_driver_state_t *dsp, uint8_t *buf, int size);
extern void
bnxef_log_session_life_cycle(bnxef_port_t *portp, bnxef_session_t *sessionp,
	int type);


#if defined(__S11) || defined(__S12)
#define	bnxef_scsi_lun_t scsi_lun_t
#endif

typedef uint64_t	bnxef_scsi_lun64_t;
#define	BNXEF_SCSI_LUN_AM_MASK	0xC0
#define	BNXEF_SCSI_LUN_AM_PDEV	0x00

bnxef_scsi_lun_t
bnxef_scsi_lun64_to_lun(bnxef_scsi_lun64_t lun64)
{
		bnxef_scsi_lun_t	lun;

		if (lun64 <= (((0xFF & ~BNXEF_SCSI_LUN_AM_MASK) << 8) | 0xFF)) {
			/*
			 * lun64 is in Solaris 'unit-address compatibility
			 * form.
			 */
			lun.sl_lun1_msb = BNXEF_SCSI_LUN_AM_PDEV | (lun64 >> 8);
			lun.sl_lun1_lsb = (uchar_t)lun64;
			lun.sl_lun2_msb = 0;
			lun.sl_lun2_lsb = 0;
			lun.sl_lun3_msb = 0;
			lun.sl_lun3_lsb = 0;
			lun.sl_lun4_msb = 0;
			lun.sl_lun4_lsb = 0;
		} else {
			/* lun64 is in full 64 bit LUN format. */
			lun.sl_lun1_msb = (uchar_t)(lun64 >> 56);
			lun.sl_lun1_lsb = (uchar_t)(lun64 >> 48);
			lun.sl_lun2_msb = (uchar_t)(lun64 >> 40);
			lun.sl_lun2_lsb = (uchar_t)(lun64 >> 32);
			lun.sl_lun3_msb = (uchar_t)(lun64 >> 24);
			lun.sl_lun3_lsb = (uchar_t)(lun64 >> 16);
			lun.sl_lun4_msb = (uchar_t)(lun64 >>  8);
			lun.sl_lun4_lsb = (uchar_t)(lun64);
		}
		return (lun);
}


/*
 * we know it is a power of 2 for the argument passed.
 */
int
bnxef_log2(uint32_t x)
{

	int i = 0;

	while (x > 0) {
		i++;
		x = (x >> 1);
	}

	return (i-1);
}

struct fcoe_kwqe_init1  fcoe_init1_copy;
struct fcoe_kwqe_init2  fcoe_init2_copy;
struct fcoe_kwqe_init3  fcoe_init3_copy;
/*
 * THis initiates the initial handshake with the fcoe firmware.
 */
int
bnxef_send_fw_fcoe_init_msg(bnxef_driver_state_t *dsp)
{
	struct fcoe_kwqe_init1 *fcoe_init1;
	struct fcoe_kwqe_init2 *fcoe_init2;
	struct fcoe_kwqe_init3 *fcoe_init3;
	struct kwqe *kwqe_arr[3];
	int num_kwqes = 3;
	dev_info_t *pdip = NULL;

	ASSERT(dsp != NULL);
	pdip = ddi_get_parent(dsp->dip);
	fcoe_init1 = &dsp->fcoe_init1;
	fcoe_init2 = &dsp->fcoe_init2;
	fcoe_init3 = &dsp->fcoe_init3;

	/* fill init1 KWQE */
	memset(fcoe_init1, 0x00, sizeof (struct fcoe_kwqe_init1));
	fcoe_init1->hdr.op_code = FCOE_KWQE_OPCODE_INIT1;
	fcoe_init1->hdr.flags = (FCOE_KWQE_LAYER_CODE <<
					FCOE_KWQE_HEADER_LAYER_CODE_SHIFT);

	fcoe_init1->num_tasks = CPU_TO_LE16(dsp->max_exchanges);
	fcoe_init1->sq_num_wqes = CPU_TO_LE16(BNXEF_SQ_WQES_MAX);
	fcoe_init1->rq_num_wqes = CPU_TO_LE16(BNXEF_RQ_WQES_MAX);
	fcoe_init1->rq_buffer_log_size = CPU_TO_LE16(BNXEF_RQ_BUF_LOG_SZ);
	fcoe_init1->cq_num_wqes = CPU_TO_LE16(BNXEF_CQ_WQES_MAX);
	ASSERT(dsp->dummy_cookie_cnt == 1);

	fcoe_init1->dummy_buffer_addr_lo = CPU_TO_LE32(((uint32_t)
			(dsp->dummy_dma_cookie.dmac_laddress & 0xffffffff)));
	fcoe_init1->dummy_buffer_addr_hi = CPU_TO_LE32(((uint32_t)
			((uint64_t)dsp->dummy_dma_cookie.dmac_laddress >> 32)));

	ASSERT(dsp->task_ctx_bd_cookie_cnt == 1);

	fcoe_init1->task_list_pbl_addr_lo = CPU_TO_LE32(((uint32_t)
			(dsp->task_ctx_bd_cookie.dmac_laddress & 0xffffffff)));
	fcoe_init1->task_list_pbl_addr_hi = CPU_TO_LE32(((uint32_t)
		(dsp->task_ctx_bd_cookie.dmac_laddress >> 32)));
	fcoe_init1->mtu = CPU_TO_LE16(dsp->mtu_size);

	fcoe_init1->flags = (BNXEF_PAGE_SHIFT <<
				FCOE_KWQE_INIT1_LOG_PAGE_SIZE_SHIFT);
#if 0
	fcoe_init1.flags |= (0 <<
				FCOE_KWQE_INIT1_LOG_CACHED_PBES_PER_FUNC_SHIFT);
#endif

	fcoe_init1->num_sessions_log = bnxef_log2(dsp->max_sessions);

	memset(&fcoe_init1_copy, 0, sizeof (struct fcoe_kwqe_init1));
	bcopy((uint8_t *)fcoe_init1, &fcoe_init1_copy,
			sizeof (struct fcoe_kwqe_init1));
	/* fill init2 KWQE */
	memset(fcoe_init2, 0x00, sizeof (struct fcoe_kwqe_init2));
	fcoe_init2->hdr.op_code = FCOE_KWQE_OPCODE_INIT2;
	fcoe_init2->hdr.flags = (FCOE_KWQE_LAYER_CODE <<
					FCOE_KWQE_HEADER_LAYER_CODE_SHIFT);
		    fcoe_init2->hsi_major_version = FCOE_HSI_MAJOR_VERSION;
		    fcoe_init2->hsi_minor_version = FCOE_HSI_MINOR_VERSION;

	//  fcoe_init2.rec_tov_timer_val = 150;
	ASSERT(dsp->hash_table_pbl_cookie_cnt == 1);
	fcoe_init2->hash_tbl_pbl_addr_lo = CPU_TO_LE32(((uint32_t)
		(dsp->hash_table_pbl_cookie.dmac_laddress & 0xffffffff)));
	fcoe_init2->hash_tbl_pbl_addr_hi = CPU_TO_LE32(((uint32_t)
		((uint64_t)dsp->hash_table_pbl_cookie.dmac_laddress >> 32)));

	ASSERT(dsp->t2_hash_table_cookie_cnt == 1);
	fcoe_init2->t2_hash_tbl_addr_lo = CPU_TO_LE32(((uint32_t)
		(dsp->t2_hash_table_dma_cookie.dmac_laddress & 0xffffffff)));
	fcoe_init2->t2_hash_tbl_addr_hi = CPU_TO_LE32(((uint32_t)
	((uint64_t)dsp->t2_hash_table_dma_cookie.dmac_laddress >> 32)));

	ASSERT(dsp->t2_hash_table_ptr_cookie_cnt == 1);
	fcoe_init2->t2_ptr_hash_tbl_addr_lo = CPU_TO_LE32(((uint32_t)
		(dsp->t2_hash_table_dma_ptr_cookie.dmac_laddress &
			0xffffffff)));
	fcoe_init2->t2_ptr_hash_tbl_addr_hi = CPU_TO_LE32(((uint32_t)
		(dsp->t2_hash_table_dma_ptr_cookie.dmac_laddress >> 32)));

	fcoe_init2->free_list_count = CPU_TO_LE32(dsp->max_sessions);

	memset((uint8_t *)&fcoe_init2_copy, 0, sizeof (struct fcoe_kwqe_init2));
	bcopy((uint8_t *)fcoe_init2, (uint8_t *)&fcoe_init2_copy,
			sizeof (struct fcoe_kwqe_init2));
	/* fill init3 KWQE */
	memset((uint8_t *)fcoe_init3, 0x00, sizeof (struct fcoe_kwqe_init3));
	fcoe_init3->hdr.op_code = FCOE_KWQE_OPCODE_INIT3;
	fcoe_init3->hdr.flags = (FCOE_KWQE_LAYER_CODE <<
					FCOE_KWQE_HEADER_LAYER_CODE_SHIFT);
	fcoe_init3->error_bit_map_lo = CPU_TO_LE32(0xffffffff);
	fcoe_init3->error_bit_map_hi = CPU_TO_LE32(0xffffffff);

	fcoe_init3->perf_config = 1;

	memset((uint8_t *)&fcoe_init3_copy, 0, sizeof (struct fcoe_kwqe_init3));
	bcopy((uint8_t *)fcoe_init3, &fcoe_init3_copy,
			sizeof (struct fcoe_kwqe_init3));

	kwqe_arr[0] = (struct kwqe *)fcoe_init1;
	kwqe_arr[1] = (struct kwqe *)fcoe_init2;
	kwqe_arr[2] = (struct kwqe *)fcoe_init3;


	if (!dsp->callbacks.prvSendWqes(pdip, (void *)kwqe_arr, num_kwqes)) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to Send WQEs to init fw\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}
	BNXEF_STATS(dsp, init_cqe_tx);

	return (BNXEF_SUCCESS);
}

int
bnxef_send_fw_fcoe_uninit_msg(bnxef_driver_state_t *dsp)
{
	struct fcoe_kwqe_destroy fcoe_destroy;
	struct kwqe *kwqe_arr[2];
	int num_kwqes = 1;
	dev_info_t *pdip;

	ASSERT(dsp != NULL);

	pdip = ddi_get_parent(dsp->dip);
	ASSERT(pdip != NULL);

	/* fill destroy KWQE */
	memset(&fcoe_destroy, 0x00, sizeof (struct fcoe_kwqe_destroy));
	fcoe_destroy.hdr.op_code = FCOE_KWQE_OPCODE_DESTROY;
	fcoe_destroy.hdr.flags = (FCOE_KWQE_LAYER_CODE <<
					FCOE_KWQE_HEADER_LAYER_CODE_SHIFT);
	kwqe_arr[0] = (struct kwqe *)&fcoe_destroy;

	if (!dsp->callbacks.prvSendWqes(pdip, (void *)kwqe_arr, num_kwqes)) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to Send WQEs to uninit fw\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}

	return (BNXEF_SUCCESS);
}

/*
 * This will send an offload request to firmware to offload the given session
 * established using the given local port.
 */
/* ARGSUSED2 */
int
bnxef_offload_session(bnxef_session_t *sessionp, uint8_t sparamw3byte2,
	uint8_t sparamw3byte3)
{
	bnxef_driver_state_t *dsp;
	struct fcoe_kwqe_conn_offload1 *ofld_req1;
	struct fcoe_kwqe_conn_offload2 *ofld_req2;
	struct fcoe_kwqe_conn_offload3 *ofld_req3;
	struct fcoe_kwqe_conn_offload4 *ofld_req4;
	int num_kwqes = 4;
	int rc = 0;
	uint16_t conn_id;
	bnxef_port_t *portp;
	bnxef_rport_t *rportp;
	dev_info_t *pdip;
	struct kwqe *kwqe_arr[4];


	ASSERT(sessionp != NULL);
	portp = (bnxef_port_t *)sessionp->lport;
	ASSERT(portp != NULL);
	if (portp == NULL) {
		return (BNXEF_FAILURE);
	}
	dsp = portp->statep;
	ASSERT(dsp != NULL);
	ASSERT(sessionp->lport == portp);
	ASSERT(mutex_owned(&sessionp->session_mutex));
	rportp = (bnxef_port_t *)sessionp->rport;

	pdip = ddi_get_parent(dsp->dip);

	ofld_req1 = (struct fcoe_kwqe_conn_offload1 *)&sessionp->ofld_req1;
	ofld_req2 = (struct fcoe_kwqe_conn_offload2 *)&sessionp->ofld_req2;
	ofld_req3 = (struct fcoe_kwqe_conn_offload3 *)&sessionp->ofld_req3;
	ofld_req4 = (struct fcoe_kwqe_conn_offload4 *)&sessionp->ofld_req4;

		/* Initialize offload request 1 structure */
	memset(ofld_req1, 0x00, sizeof (struct fcoe_kwqe_conn_offload1));

	ofld_req1->hdr.op_code = FCOE_KWQE_OPCODE_OFFLOAD_CONN1;
	ofld_req1->hdr.flags =
		(FCOE_KWQE_LAYER_CODE << FCOE_KWQE_HEADER_LAYER_CODE_SHIFT);


	conn_id = (uint16_t)sessionp->con_id;
	ofld_req1->fcoe_conn_id = CPU_TO_LE16(conn_id);


	ofld_req1->sq_addr_lo =
		CPU_TO_LE32((uint32_t)(sessionp->sq_cookie.dmac_laddress &
						0xFFFFFFFF));
	ofld_req1->sq_addr_hi = CPU_TO_LE32((uint32_t)
			((uint64_t)sessionp->sq_cookie.dmac_laddress >>32));

	ofld_req1->rq_pbl_addr_lo = CPU_TO_LE32((uint32_t)
		(sessionp->rq_pbl_dma_cookie.dmac_laddress & 0xffffffff));
	ofld_req1->rq_pbl_addr_hi = CPU_TO_LE32((uint32_t)
		((uint64_t)sessionp->rq_pbl_dma_cookie.dmac_laddress >> 32));

	ofld_req1->rq_first_pbe_addr_lo = CPU_TO_LE32((uint32_t)
		(sessionp->rq_cookie.dmac_laddress & 0xffffffff));
	ofld_req1->rq_first_pbe_addr_hi =
		CPU_TO_LE32((uint32_t)(
			(uint64_t)sessionp->rq_cookie.dmac_laddress >> 32));

	ofld_req1->rq_prod = CPU_TO_LE16(0x8000);

		/* Initialize offload request 2 structure */
	memset(ofld_req2, 0x00, sizeof (struct fcoe_kwqe_conn_offload2));

	ofld_req2->hdr.op_code = FCOE_KWQE_OPCODE_OFFLOAD_CONN2;
	ofld_req2->hdr.flags =
		(FCOE_KWQE_LAYER_CODE << FCOE_KWQE_HEADER_LAYER_CODE_SHIFT);

	ofld_req2->tx_max_fc_pay_len =
			CPU_TO_LE16(rportp->plogi_info.class_3.rcv_size);

	ofld_req2->cq_addr_lo =
		CPU_TO_LE32((uint32_t)sessionp->cq_cookie.dmac_laddress);
	ofld_req2->cq_addr_hi = CPU_TO_LE32((uint32_t)
			((uint64_t)sessionp->cq_cookie.dmac_laddress >> 32));

	ofld_req2->xferq_addr_lo =
		CPU_TO_LE32((uint32_t)sessionp->xferq_cookie.dmac_laddress);
	ofld_req2->xferq_addr_hi = CPU_TO_LE32((uint32_t)
		((uint64_t)sessionp->xferq_cookie.dmac_laddress >> 32));

	ofld_req2->conn_db_addr_lo = CPU_TO_LE32((uint32_t)
		(sessionp->conn_db_cookie.dmac_laddress & 0xffffffff));
	ofld_req2->conn_db_addr_hi = CPU_TO_LE32((uint32_t)
		((uint64_t)sessionp->conn_db_cookie.dmac_laddress >> 32));

		/* Initialize offload request 3 structure */
	memset(ofld_req3, 0x00, sizeof (struct fcoe_kwqe_conn_offload3));

	ofld_req3->hdr.op_code = FCOE_KWQE_OPCODE_OFFLOAD_CONN3;
	ofld_req3->hdr.flags =
		(FCOE_KWQE_LAYER_CODE << FCOE_KWQE_HEADER_LAYER_CODE_SHIFT);

	ofld_req3->vlan_tag =
		CPU_TO_LE16(VLAN_TCI(portp->fcf->vlan_tag_pcp,
		portp->fcf->vlan_tag_cfi, portp->vlan_id));

	ofld_req3->s_id[0] = (portp->id & 0x000000FF);
	ofld_req3->s_id[1] = (portp->id & 0x0000FF00) >> 8;
	ofld_req3->s_id[2] = (portp->id & 0x00FF0000) >> 16;

	ofld_req3->d_id[0] = (rportp->id & 0x000000FF);
	ofld_req3->d_id[1] = (rportp->id & 0x0000FF00) >> 8;
	ofld_req3->d_id[2] = (rportp->id & 0x00FF0000) >>16;

	ofld_req3->tx_total_conc_seqs =
		CPU_TO_LE16(rportp->plogi_info.common_service.conc_sequences);

	ofld_req3->tx_max_conc_seqs_c3 =
		rportp->plogi_info.class_3.conc_sequences;
	ofld_req3->rx_max_fc_pay_len  =
		CPU_TO_LE16(portp->plogi_info.class_3.rcv_size);

	ofld_req3->rx_total_conc_seqs =
		CPU_TO_LE16(portp->plogi_info.common_service.conc_sequences);

	ofld_req3->rx_max_conc_seqs_c3 =
		portp->plogi_info.class_3.conc_sequences;
	ofld_req3->rx_open_seqs_exch_c3 =
		portp->plogi_info.class_3.open_seq_per_xchng;

	ofld_req3->confq_first_pbe_addr_lo = CPU_TO_LE32(((uint64_t)
		sessionp->confq_cookie.dmac_laddress) & 0xFFFFFFFF);
	ofld_req3->confq_first_pbe_addr_hi = CPU_TO_LE32((uint32_t)
		((uint64_t)sessionp->confq_cookie.dmac_laddress >> 32));

	/* set mul_n_port_ids supported flag to 0, until it is supported */
	ofld_req3->flags = 0;
	/* Info from PLOGI response */
	ofld_req3->flags |= (((portp->plogi_info.common_service.cmn_features &
		(1 << 10))? 1 : 0) <<
		FCOE_KWQE_CONN_OFFLOAD3_B_E_D_TOV_RES_SHIFT);

	ofld_req3->flags |= (((portp->plogi_info.common_service.cmn_features &
		(1<<2)) ? 1 : 0) <<
		FCOE_KWQE_CONN_OFFLOAD3_B_CONT_INCR_SEQ_CNT_SHIFT);
	/*
	 * Info from PRLI response, here we should enable Seq Level Error
	 * recovery when we want to support
	 */
	ofld_req3->flags |= 1 << FCOE_KWQE_CONN_OFFLOAD3_B_CONF_REQ_SHIFT;
	if (sparamw3byte2 & PRLI_RETRY_ALLOWED)  {
		ofld_req3->flags |=
			1 << FCOE_KWQE_CONN_OFFLOAD3_B_REC_VALID_SHIFT;
		sessionp->state |= BNXEF_SESSION_SEQ_RETRY_ENABLED;
	}

	if (!FCOE_INFO_IS_MF_MODE_SD(dsp->bnxe_params.flags)) {
		/* vlan flag */
		ofld_req3->flags |=
			(1 << FCOE_KWQE_CONN_OFFLOAD3_B_VLAN_FLAG_SHIFT);
	}

	/* Initialize offload request 4 structure */
	memset(ofld_req4, 0x00, sizeof (struct fcoe_kwqe_conn_offload4));
	ofld_req4->hdr.op_code = FCOE_KWQE_OPCODE_OFFLOAD_CONN4;
	ofld_req4->hdr.flags =
		(FCOE_KWQE_LAYER_CODE << FCOE_KWQE_HEADER_LAYER_CODE_SHIFT);

	ofld_req4->e_d_tov_timer_val =
		portp->plogi_info.common_service.e_d_tov / 20;

	ofld_req4->src_mac_addr_lo[0] =  portp->mac_addr[5];
	ofld_req4->src_mac_addr_lo[1] =  portp->mac_addr[4];
	ofld_req4->src_mac_addr_mid[0] =  portp->mac_addr[3];
	ofld_req4->src_mac_addr_mid[1] =  portp->mac_addr[2];
	ofld_req4->src_mac_addr_hi[0] =  portp->mac_addr[1];
	ofld_req4->src_mac_addr_hi[1] =  portp->mac_addr[0];
	ofld_req4->dst_mac_addr_lo[0] =  portp->fcf->fcoe_mac_addr[5];
	ofld_req4->dst_mac_addr_lo[1] =  portp->fcf->fcoe_mac_addr[4];
	ofld_req4->dst_mac_addr_mid[0] =  portp->fcf->fcoe_mac_addr[3];
	ofld_req4->dst_mac_addr_mid[1] =  portp->fcf->fcoe_mac_addr[2];
	ofld_req4->dst_mac_addr_hi[0] =  portp->fcf->fcoe_mac_addr[1];
	ofld_req4->dst_mac_addr_hi[1] =  portp->fcf->fcoe_mac_addr[0];

	ofld_req4->lcq_addr_lo =
		CPU_TO_LE32((uint32_t)sessionp->lcq_cookie.dmac_laddress);
	ofld_req4->lcq_addr_hi = CPU_TO_LE32((uint32_t)
			((uint64_t)sessionp->lcq_cookie.dmac_laddress >>32));

	ofld_req4->confq_pbl_base_addr_lo = CPU_TO_LE32((uint32_t)
		(sessionp->confq_pbl_cookie.dmac_laddress & 0xffffffff));
	ofld_req4->confq_pbl_base_addr_hi = CPU_TO_LE32((uint32_t)
		((uint64_t)sessionp->confq_pbl_cookie.dmac_laddress >> 32));

	kwqe_arr[0] = (struct kwqe *)ofld_req1;
	kwqe_arr[1] = (struct kwqe *)ofld_req2;
	kwqe_arr[2] = (struct kwqe *)ofld_req3;
	kwqe_arr[3] = (struct kwqe *)ofld_req4;
	mutex_exit(&sessionp->session_mutex);
#if 0
	offldp = (uint32_t *)ofld_req1;
	cmn_err(CE_NOTE,
		"%s%d: Offload1: 0x%x, 0x%x, 0x%x, \
		0x%x, 0x%x, 0x%x, 0x%x, 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		offldp[0], offldp[1], offldp[2], offldp[3],
		offldp[4], offldp[5], offldp[6], offldp[7]);
	offldp = (uint32_t *)ofld_req2;
	cmn_err(CE_NOTE,
		"%s%d: Offload2: 0x%x, 0x%x, 0x%x, \
		0x%x, 0x%x, 0x%x, 0x%x, 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		offldp[0], offldp[1], offldp[2], offldp[3],
		offldp[4], offldp[5], offldp[6], offldp[7]);
	offldp = (uint32_t *)ofld_req3;
	cmn_err(CE_NOTE,
		"%s%d: Offload3: 0x%x, 0x%x, 0x%x, \
		0x%x, 0x%x, 0x%x, 0x%x, 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		offldp[0], offldp[1], offldp[2],
		offldp[3], offldp[4], offldp[5], offldp[6], offldp[7]);
	offldp = (uint32_t *)ofld_req4;
	cmn_err(CE_NOTE,
		"%s%d: Offload4: 0x%x, 0x%x, 0x%x, \
		0x%x, 0x%x, 0x%x, 0x%x, 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		offldp[0], offldp[1], offldp[2], offldp[3],
		offldp[4], offldp[5], offldp[6], offldp[7]);
#endif
	bnxef_log_session_life_cycle(portp, sessionp,
		BNXEF_SESSION_OFFLOAD_TYPE);


	BNXEF_TRACE_EVENT(dsp, BNXEF_SESSION_OFFLOAD_REQ,
		-1, -1, 0, sessionp, 0, 0, 0);
	if (!dsp->callbacks.prvSendWqes(pdip, (void *)kwqe_arr, num_kwqes)) {
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to Send WQEs to uninit fw\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		mutex_enter(&sessionp->session_mutex);
		return (BNXEF_FAILURE);
	}
	mutex_enter(&sessionp->session_mutex);
	BNXEF_STATS(dsp, ofld_cqe_tx);

	return (rc);
}

/*
 * Enable the session offloaded.
 */
int
bnxef_session_enable(bnxef_session_t *sessionp)
{
	bnxef_driver_state_t *dsp;
	struct fcoe_kwqe_conn_enable_disable *enbl_req;
	int num_kwqes = 1;
	bnxef_port_t *portp, *rportp;
	dev_info_t  *pdip;
	// uint32_t *dreqp;
	struct  kwqe *kwqe_arr[4];

	ASSERT(sessionp != NULL);
	portp = sessionp->lport;
	if (portp == NULL)
		return (BNXEF_FAILURE);
	ASSERT(portp != NULL);
	ASSERT(sessionp->rport != NULL);
	rportp = (bnxef_port_t *)sessionp->rport;
	if (rportp == NULL)
		return (BNXEF_FAILURE);
	dsp = portp->statep;
	ASSERT(mutex_owned(&sessionp->session_mutex));
	ASSERT(sessionp->lport == portp);
	pdip = ddi_get_parent(dsp->dip);

	enbl_req = (struct fcoe_kwqe_conn_enable_disable *)&sessionp->enbl_req;
	memset(enbl_req, 0x00, sizeof (struct fcoe_kwqe_conn_enable_disable));
	enbl_req->hdr.op_code = FCOE_KWQE_OPCODE_ENABLE_CONN;
	enbl_req->hdr.flags =
		(FCOE_KWQE_LAYER_CODE << FCOE_KWQE_HEADER_LAYER_CODE_SHIFT);

	enbl_req->src_mac_addr_lo[0] =  portp->mac_addr[5];
	enbl_req->src_mac_addr_lo[1] =  portp->mac_addr[4];
	enbl_req->src_mac_addr_mid[0] =  portp->mac_addr[3];
	enbl_req->src_mac_addr_mid[1] =  portp->mac_addr[2];
	enbl_req->src_mac_addr_hi[0] =  portp->mac_addr[1];
	enbl_req->src_mac_addr_hi[1] =  portp->mac_addr[0];

	/* FCF Mac */
	enbl_req->dst_mac_addr_lo[0] =  portp->fcf->fcoe_mac_addr[5];
	enbl_req->dst_mac_addr_lo[1] =  portp->fcf->fcoe_mac_addr[4];
	enbl_req->dst_mac_addr_mid[0] =  portp->fcf->fcoe_mac_addr[3];
	enbl_req->dst_mac_addr_mid[1] =  portp->fcf->fcoe_mac_addr[2];
	enbl_req->dst_mac_addr_hi[0] =  portp->fcf->fcoe_mac_addr[1];
	enbl_req->dst_mac_addr_hi[1] =  portp->fcf->fcoe_mac_addr[0];

	enbl_req->s_id[0] = (portp->id & 0x000000FF);
	enbl_req->s_id[1] = (portp->id & 0x0000FF00) >> 8;
	enbl_req->s_id[2] = (portp->id & 0x00FF0000) >> 16;

	enbl_req->d_id[0] = (rportp->id & 0x000000FF);
	enbl_req->d_id[1] = (rportp->id & 0x0000FF00) >> 8;
	enbl_req->d_id[2] = (rportp->id & 0x00FF0000) >>16;
	enbl_req->vlan_tag = CPU_TO_LE16(VLAN_TCI(portp->fcf->vlan_tag_pcp,
				portp->fcf->vlan_tag_cfi,
				portp->vlan_id));
	if (!FCOE_INFO_IS_MF_MODE_SD(dsp->bnxe_params.flags))
		enbl_req->vlan_flag = 1;
	enbl_req->context_id = CPU_TO_LE32(sessionp->context_id);
	enbl_req->conn_id = CPU_TO_LE32(sessionp->con_id);

	kwqe_arr[0] = (struct kwqe *)enbl_req;

	mutex_exit(&sessionp->session_mutex);
	BNXEF_DEBUG(dsp, GENERAL, -1, "%s%d:Sending Enable Req for 0x%p",
		BNXEF_DRIVER_NAME, dsp->instance, sessionp);
#if 0
	dreqp = (uint32_t *)enbl_req;
	cmn_err(CE_NOTE, "%s%d: Enable: Con Id 0x%x, Context_id 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		enbl_req->conn_id, enbl_req->context_id);
	cmn_err(CE_NOTE,
		"%s%d: Enable: 0x%x, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x, \
		0x%x, 0x%x, 0x%x, 0x%x, 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		dreqp[0], dreqp[1], dreqp[2], dreqp[3], dreqp[4],
		dreqp[5], dreqp[6], dreqp[7], dreqp[8], dreqp[9], dreqp[10]);
	cmn_err(CE_NOTE, "%s%d: Enable:Number of Active I/Os 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		bnxef_get_active_ios(sessionp));
#endif

	bnxef_log_session_life_cycle(portp, sessionp,
		BNXEF_SESSION_ENABLE_TYPE);
	BNXEF_TRACE_EVENT(dsp, BNXEF_SESSION_ENABLE_REQ,
		-1, -1, 0, sessionp, 0, 0, 0);
	if (!dsp->callbacks.prvSendWqes(pdip, (void *)kwqe_arr,
			num_kwqes)) {
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d:Unable to Send WQE to Enable session\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		mutex_enter(&sessionp->session_mutex);
		return (BNXEF_FAILURE);
	}
	mutex_enter(&sessionp->session_mutex);
	BNXEF_STATS(dsp, enable_cqe_tx);

	return (BNXEF_SUCCESS);
}

/*
 * This will disable the session.
 */
int
bnxef_session_disable(bnxef_session_t *sessionp)
{
	bnxef_driver_state_t *dsp;
	struct fcoe_kwqe_conn_enable_disable *disable_req;
	int num_kwqes = 1;
	int rc = 0;
	bnxef_port_t *portp, *rportp;
	dev_info_t *pdip;
	// uint32_t *dreqp;
	struct kwqe *kwqe_arr[4];

	ASSERT(sessionp != NULL);
	portp = (bnxef_port_t *)sessionp->lport;
	rportp = (bnxef_port_t *)sessionp->rport;
	ASSERT(portp != NULL);
	ASSERT(rportp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);
	pdip = ddi_get_parent(dsp->dip);

	disable_req = (struct fcoe_kwqe_conn_enable_disable *)
			&sessionp->disable_req;
	memset(disable_req, 0x00,
		sizeof (struct fcoe_kwqe_conn_enable_disable));
	disable_req->hdr.op_code = FCOE_KWQE_OPCODE_DISABLE_CONN;
	disable_req->hdr.flags =
		(FCOE_KWQE_LAYER_CODE << FCOE_KWQE_HEADER_LAYER_CODE_SHIFT);

	disable_req->src_mac_addr_lo[0] =  portp->mac_addr[5];
		disable_req->src_mac_addr_lo[1] =  portp->mac_addr[4];
	disable_req->src_mac_addr_mid[0] =  portp->mac_addr[3];
	disable_req->src_mac_addr_mid[1] =  portp->mac_addr[2];
	disable_req->src_mac_addr_hi[0] =  portp->mac_addr[1];
	disable_req->src_mac_addr_hi[1] =  portp->mac_addr[0];


	/* fcf mac address */
	disable_req->dst_mac_addr_lo[0] =  portp->fcf->fcoe_mac_addr[5];
	disable_req->dst_mac_addr_lo[1] =  portp->fcf->fcoe_mac_addr[4];
	disable_req->dst_mac_addr_mid[0] =  portp->fcf->fcoe_mac_addr[3];
	disable_req->dst_mac_addr_mid[1] =  portp->fcf->fcoe_mac_addr[2];
	disable_req->dst_mac_addr_hi[0] =  portp->fcf->fcoe_mac_addr[1];
	disable_req->dst_mac_addr_hi[1] =  portp->fcf->fcoe_mac_addr[0];

	disable_req->s_id[0] = (portp->id & 0x000000FF);
	disable_req->s_id[1] = (portp->id & 0x0000FF00) >> 8;
	disable_req->s_id[2] = (portp->id& 0x00FF0000) >> 16;

	disable_req->d_id[0] = (rportp->id & 0x000000FF);
	disable_req->d_id[1] = (rportp->id & 0x0000FF00) >> 8;
	disable_req->d_id[2] = (rportp->id & 0x00FF0000) >>16;

	disable_req->context_id = CPU_TO_LE32(sessionp->context_id);
	disable_req->conn_id = CPU_TO_LE32(sessionp->con_id);
#if 0
	dreqp = (uint32_t *)disable_req;
	cmn_err(CE_NOTE, "%s%d: Disable: Con Id 0x%x, Context_id 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, disable_req->conn_id,
			disable_req->context_id);
	cmn_err(CE_NOTE, "%s%d: Disable: 0x%x, 0x%x, 0x%x, 0x%x,\
		0x%x, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		dreqp[0], dreqp[1], dreqp[2], dreqp[3], dreqp[4], dreqp[5],
		dreqp[6], dreqp[7], dreqp[8], dreqp[9], dreqp[10]);
	cmn_err(CE_NOTE, "%s%d: Disable:Number of Active I/Os 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		bnxef_get_active_ios(sessionp));
#endif
	disable_req->vlan_tag = CPU_TO_LE16(VLAN_TCI(portp->fcf->vlan_tag_pcp,
				portp->fcf->vlan_tag_cfi,
				portp->vlan_id));
	if (!FCOE_INFO_IS_MF_MODE_SD(dsp->bnxe_params.flags))
		disable_req->vlan_flag = 1;

	kwqe_arr[0] = (struct kwqe *)disable_req;
	bnxef_log_session_life_cycle(portp, sessionp,
		BNXEF_SESSION_DISABLE_TYPE);
	BNXEF_TRACE_EVENT(dsp, BNXEF_SESSION_DISABLE_REQ,
		-1, -1, 0, sessionp, 0, 0, 0);
	if (!dsp->callbacks.prvSendWqes(pdip, (void *)kwqe_arr,
		num_kwqes)) {
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d:Unable to Send WQE to disable session\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}

	return (rc);
}

/*
 * This will completely destroy the session.
 */
int
bnxef_session_destroy(bnxef_session_t *sessionp)
{
	struct fcoe_kwqe_conn_destroy *destroy_req;
	int num_kwqes = 1;
	int rc = 0;
	bnxef_driver_state_t *dsp;
	bnxef_port_t *portp;
	dev_info_t *pdip;
	// uint32_t *dreqp;
	struct kwqe *kwqe_arr[4];

	ASSERT(sessionp != NULL);
	portp = sessionp->lport;
	ASSERT(portp !=  NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);

	pdip = ddi_get_parent(dsp->dip);
	ASSERT(pdip != NULL);


	destroy_req = (struct fcoe_kwqe_conn_destroy *)&sessionp->destroy_req;
	memset(destroy_req, 0x00, sizeof (struct fcoe_kwqe_conn_destroy));
	destroy_req->hdr.op_code = FCOE_KWQE_OPCODE_DESTROY_CONN;
	destroy_req->hdr.flags =
		(FCOE_KWQE_LAYER_CODE << FCOE_KWQE_HEADER_LAYER_CODE_SHIFT);

	destroy_req->context_id = CPU_TO_LE32(sessionp->context_id);
	destroy_req->conn_id = CPU_TO_LE32(sessionp->con_id);
#if 0
	dreqp = (uint32_t *)destroy_req;
	cmn_err(CE_NOTE,  "%s%d: Destroy: Con Id 0x%x, Context_id 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		destroy_req->conn_id, destroy_req->context_id);
	cmn_err(CE_NOTE,
		"%s%d: Destroy WQE: 0x%x, 0x%x, 0x%x,\
		0x%x, 0x%x, 0x%x, 0x%x, 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		dreqp[0], dreqp[1], dreqp[2], dreqp[3],
		dreqp[4], dreqp[5], dreqp[6], dreqp[7]);
	cmn_err(CE_NOTE, "%s%d: Destroy: Number of Active I/Os 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		bnxef_get_active_ios(sessionp));
#endif

	kwqe_arr[0] = (struct kwqe *)destroy_req;
	bnxef_log_session_life_cycle(portp, sessionp,
		BNXEF_SESSION_DESTROY_TYPE);
	BNXEF_TRACE_EVENT(dsp, BNXEF_SESSION_DESTROY_REQ,
		-1, -1, 0, sessionp, 0, 0, 0);
	if (dsp->callbacks.prvSendWqes == NULL) debug_enter("Session Destroy");
	if (!dsp->callbacks.prvSendWqes(pdip, (void *)kwqe_arr, num_kwqes)) {
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d:Unable to Send WQE to disable session\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}
	return (rc);
}


/*
 * This will queue the given X_ID into the Send Queue for firmware to work on
 * that request.
 */
void
bnxef_add_2_sq(bnxef_session_t *sessionp, uint16_t xid)
{
	struct fcoe_sqe *sqe;
	int ret;

	ASSERT(sessionp != NULL);
	ASSERT(xid < BNXEF_MAX_EXCHGS_SUPPORTED);

	mutex_enter(&sessionp->session_mutex);
	/* LINTED: alignment */
	sqe = (struct fcoe_sqe *)(sessionp->sq_addr + (sessionp->sq_prod_idx *
			sizeof (struct fcoe_sqe)));

	/* Fill SQ WQE */
	sqe->wqe = CPU_TO_LE16(xid << FCOE_SQE_TASK_ID_SHIFT);
	sqe->wqe |=
		CPU_TO_LE16(sessionp->sq_toggle << FCOE_SQE_TOGGLE_BIT_SHIFT);

	/* Advance SQ Prod Idx */
	if (++sessionp->sq_prod_idx == BNXEF_SQ_WQES_MAX) {
		sessionp->sq_prod_idx = 0;
		sessionp->sq_toggle = 1 - sessionp->sq_toggle;
	}
	mutex_exit(&sessionp->session_mutex);
	ret = ddi_dma_sync(sessionp->sq_dma_handle, 0, sessionp->sq_length,
		DDI_DMA_SYNC_FORDEV);
	ASSERT(ret == DDI_SUCCESS);
}

/*
 * This will ring the door bell to prompt the firmware to start executing the
 * tasks posted in SQ.
 */
void
bnxef_ring_doorbell(bnxef_session_t *sessionp)
{
	struct b577xx_doorbell_set_prod ev_doorbell;
	uint32_t msg;
	bnxef_driver_state_t *dsp;


	ASSERT(sessionp != NULL);

	dsp = ((bnxef_port_t *)sessionp->lport)->statep;
	ASSERT(dsp != NULL);
	mutex_enter(&sessionp->session_mutex);
	memset(&ev_doorbell, 0, sizeof (struct b577xx_doorbell_set_prod));
	ev_doorbell.header.header = B577XX_DOORBELL_HDR_DB_TYPE;

	ev_doorbell.prod = sessionp->sq_prod_idx |
				(sessionp->sq_toggle << 15);
	ev_doorbell.header.header |= B577XX_FCOE_CONNECTION_TYPE <<
					B577XX_DOORBELL_HDR_CONN_TYPE_SHIFT;
	/* LINTED: alignment */
	msg = *((uint32_t *)&ev_doorbell);
	BNXEF_DEBUG(dsp, GENERAL, -1,
		"%s%d: Wrting 0x%x in doorbell reg offset 0x%p",
		BNXEF_DRIVER_NAME, dsp->instance, msg, sessionp->doorbell_reg);
	ddi_put32(sessionp->doorbell_acc, sessionp->doorbell_reg, msg);
	mutex_exit(&sessionp->session_mutex);

}

void
bnxef_arm_cq(bnxef_session_t *sessionp, uint16_t cq_index)
{
	struct b577xx_fcoe_rx_doorbell db;
	uint32_t msg;
	bnxef_driver_state_t *dsp;


	ASSERT(sessionp != NULL);

	dsp = ((bnxef_port_t *)sessionp->lport)->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&sessionp->session_mutex);
	memset(&db, 0, sizeof (struct b577xx_fcoe_rx_doorbell));
	db.hdr.header = ((0x1 << B577XX_DOORBELL_HDR_RX_SHIFT) |
		(0x1 << B577XX_DOORBELL_HDR_DB_TYPE_SHIFT) |
		(B577XX_FCOE_CONNECTION_TYPE <<
			B577XX_DOORBELL_HDR_CONN_TYPE_SHIFT));
	db.params = ((0x2 << B577XX_FCOE_RX_DOORBELL_NEGATIVE_ARM_SHIFT) |
		    (0x3 << B577XX_FCOE_RX_DOORBELL_OPCODE_SHIFT));
	db.doorbell_cq_cons = (cq_index |
			(sessionp->cq_toggle << FCOE_CQE_TOGGLE_BIT_SHIFT));
	sessionp->prev_cq_cons_idx = cq_index;
	sessionp->prev_cq_toggle = sessionp->cq_toggle;
	/* LINTED: alignment */
	msg = *((uint32_t *)&db);
	BNXEF_DEBUG(dsp, GENERAL, -1,
		"%s%d: Writing 0x%x in doorbell reg offset 0x%p",
		BNXEF_DRIVER_NAME, dsp->instance, msg, sessionp->doorbell_reg);
	ddi_put32(sessionp->doorbell_acc, sessionp->doorbell_reg, (msg));
		    sessionp->state &= ~BNXEF_SESSION_CQ_ARMING_REQUIRED;
	mutex_exit(&sessionp->session_mutex);
}


/*
 * This will get the next RQ entry to get the data associated with it.
 */

uint8_t *
bnxef_get_next_rqe(bnxef_session_t *sessionp, uint8_t num_items)
{
	uint8_t *buf;
	bnxef_driver_state_t *dsp;
	bnxef_port_t *portp;


	portp = sessionp->lport;
	ASSERT(portp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);


	mutex_enter(&sessionp->session_mutex);
	buf = (uint8_t *)sessionp->rq_addr +
		(sessionp->rq_cons_idx * BNXEF_RQ_BUF_SIZE);

	if (sessionp->rq_cons_idx + num_items > BNXEF_RQ_WQES_MAX) {
		mutex_exit(&sessionp->session_mutex);
		return (NULL);
	}
	sessionp->rq_cons_idx += num_items;
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Consumer idex updated to 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
			sessionp->rq_cons_idx);

	if (sessionp->rq_cons_idx >= BNXEF_RQ_WQES_MAX) {
		sessionp->rq_cons_idx -= BNXEF_RQ_WQES_MAX;
	}
	mutex_exit(&sessionp->session_mutex);
	return (buf);
}

void
bnxef_return_rqe(bnxef_session_t *sessionp, uint8_t num_items)
{
	/* return the rq buffer */
	uint16_t next_prod_idx;
		    int ret;
	bnxef_driver_state_t *dsp;
	bnxef_port_t *portp;

	portp = sessionp->lport;
	ASSERT(portp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&sessionp->session_mutex);
	next_prod_idx = sessionp->rq_prod_idx + num_items;
	if ((next_prod_idx & 0x7fff) == BNXEF_RQ_WQES_MAX) {
		/* Wrap around RQ */
		next_prod_idx += 0x8000 - BNXEF_RQ_WQES_MAX;
	}
	sessionp->rq_prod_idx = next_prod_idx;
	/* LINTED: alignment */
	((struct fcoe_conn_db *)sessionp->conn_db_addr)->rq_prod =
		CPU_TO_LE16(sessionp->rq_prod_idx);
	mutex_exit(&sessionp->session_mutex);
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d:rq prod idx programmed 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		CPU_TO_LE16(sessionp->rq_prod_idx));
		    ret = ddi_dma_sync(sessionp->conn_db_dma_handle, 0,
			sessionp->conn_db_length, DDI_DMA_SYNC_FORDEV);
		    ASSERT(ret == DDI_SUCCESS);
}

/*
 * This will cleanup the task pending with the firmware.
 */
int
bnxef_cleanup_task(bnxef_session_t *sessionp, bnxef_fcoe_task_t *taskp)
{
	uint8_t task_type = FCOE_TASK_TYPE_EXCHANGE_CLEANUP;
	uint32_t context_id = sessionp->context_id;
	struct fcoe_task_ctx_entry  *fwtskp;
	bnxef_driver_state_t	*dsp;
	bnxef_port_t	*portp;
	bnxef_fcoe_task_t *cleanuptaskp;

	ASSERT(sessionp != NULL);
	portp  = (bnxef_port_t *)sessionp->lport;
	ASSERT(portp != NULL);
	dsp = (bnxef_driver_state_t *)portp->statep;
	ASSERT(dsp != NULL);

	cleanuptaskp = bnxef_task_alloc(dsp, KM_SLEEP);
	ASSERT(cleanuptaskp != NULL);
	fwtskp = cleanuptaskp->fwtaskp;


	mutex_enter(&cleanuptaskp->task_mutex);
	/* Tx Write Rx Read */
	fwtskp->txwr_rxrd.const_ctx.tx_flags =
		FCOE_TASK_TX_STATE_EXCHANGE_CLEANUP <<
		FCOE_TCE_TX_WR_RX_RD_CONST_TX_STATE_SHIFT;
	fwtskp->txwr_rxrd.const_ctx.init_flags = task_type <<
		FCOE_TCE_TX_WR_RX_RD_CONST_TASK_TYPE_SHIFT;
	fwtskp->rxwr_txrd.const_ctx.init_flags = CPU_TO_LE32(context_id <<
		FCOE_TCE_RX_WR_TX_RD_CONST_CID_SHIFT);
	fwtskp->rxwr_txrd.var_ctx.rx_flags |= CPU_TO_LE16(1 <<
		FCOE_TCE_RX_WR_TX_RD_VAR_EXP_FIRST_FRAME_SHIFT);
	fwtskp->txwr_rxrd.union_ctx.cleanup.ctx.cleaned_task_id =
		CPU_TO_LE16(taskp->x_id);

	cleanuptaskp->task_flags |= BNXEF_FCOE_TASK_CLEANUP;
	mutex_exit(&cleanuptaskp->task_mutex);

	BNXEF_TRACE_EVENT(dsp, BNXEF_SCSI_TASK_CLEANUP_INIT,
		taskp->x_id, cleanuptaskp->x_id, 0, sessionp, 0, 0, 0);

	/* Add to the SQ entry for firmware to work on */
	bnxef_add_2_sq(sessionp, cleanuptaskp->x_id);

	/* Now ring the door bell to work on this entry */
	bnxef_ring_doorbell(sessionp);

	BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: Task Cleaned up for id 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
#if 0
	/* Wait on the Original task, Cleanup Completion */
	mutex_enter(&taskp->task_mutex);
	ret = cv_timedwait(&taskp->task_cv, &taskp->task_mutex,
		(ddi_get_lbolt() + BNXEF_SEC2TICK(1)));
	if (ret < 0) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Task Cleanup Timedout for id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
		ret = BNXEF_FAILURE;
	} else {
		ret = BNXEF_SUCCESS;
	}
	mutex_exit(&taskp->task_mutex);
#endif

		    return (BNXEF_SUCCESS);
}

/*
 * THis will initialize the middle path task for transport via firmware.
 */

int
bnxef_init_mp_task(bnxef_session_t *sessionp, fc_packet_t *pktp)
{
	bnxef_port_t *portp;
	bnxef_driver_state_t *dsp;
	bnxef_fcoe_task_t *taskp;
	struct fcoe_task_ctx_entry *fwtaskp;
	uint8_t task_type = 0;
	uint32_t context_id;
	fc_frame_hdr_t tfchdr;
	uint64_t	*ofchdrp;
	uint64_t	 *tmpfchdrp;
	int ret, i;
	struct fcoe_bd_ctx  *bdp;
	ddi_dma_cookie_t	*cp;
	uint64_t		rsp_phy_addr = 0;

	ASSERT(sessionp != NULL);
	portp = sessionp->lport;
	ASSERT(portp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	ASSERT(pktp != NULL);
	mutex_enter(&sessionp->session_mutex);
	context_id = sessionp->context_id;
	mutex_exit(&sessionp->session_mutex);

	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;

	mutex_enter(&taskp->task_mutex);

	/* Obtain task_type */
	if (((taskp->task_flags & BNXEF_FCOE_TASK_MGMT_CMD) ==
		BNXEF_FCOE_TASK_MGMT_CMD) ||
			    ((taskp->task_flags & BNXEF_FCOE_TASK_ELS) ==
		BNXEF_FCOE_TASK_ELS)) {
		if ((taskp->task_flags & BNXEF_FCOE_TASK_UNSOLICITED_ELS) ==
				BNXEF_FCOE_TASK_UNSOLICITED_ELS)
			task_type = FCOE_TASK_TYPE_UNSOLICITED;
		else
			task_type = FCOE_TASK_TYPE_MIDPATH;
	} else if ((taskp->task_flags & BNXEF_FCOE_TASK_ABTS)
			== BNXEF_FCOE_TASK_ABTS) {
		task_type = FCOE_TASK_TYPE_ABTS;
	}
	fwtaskp = taskp->fwtaskp;
	ASSERT(fwtaskp != NULL);

	memset(fwtaskp, 0, sizeof (struct fcoe_task_ctx_entry));

	/* Tx only */
	if ((task_type == FCOE_TASK_TYPE_MIDPATH) ||
			    (task_type == FCOE_TASK_TYPE_UNSOLICITED)) {
		if (pktp->pkt_cmdlen != 0) {
			ASSERT(pktp->pkt_cmd_cookie_cnt == 1);
			if (dsp->task_bd_table_pre_alloc == 0) {
				ret =
				bnxef_task_cmd_bd_table_alloc(sessionp, pktp);
				if (ret != BNXEF_SUCCESS) {
					BNXEF_DEBUG(dsp, ERROR, -1,
					"%s%d: Error Allocating CMD BD table",
					BNXEF_DRIVER_NAME, dsp->instance);
					mutex_exit(&taskp->task_mutex);
					return (BNXEF_FAILURE);
				}
			}

			/* LINTED: alignment */
			bdp = (struct fcoe_bd_ctx *)taskp->bd_addr;

			cp = pktp->pkt_cmd_cookie;
			for (i = 0; i < pktp->pkt_cmd_cookie_cnt; i++) {
				bdp->buf_addr_hi =  (uint32_t)
					CPU_TO_LE32((
					(uint64_t)cp->dmac_laddress >> 32));
				bdp->buf_addr_lo =
					CPU_TO_LE32(
					(uint32_t)cp->dmac_laddress);
				ASSERT(cp->dmac_size < BNXEF_MAX_BD_SIZE);
				bdp->buf_len = CPU_TO_LE16(cp->dmac_size);

				BNXEF_DEBUG(dsp, SCSI, -1,
					"%s%d: x_id 0x%x, Cookie %d,\
					Address 0x%p,size 0x%x",
					BNXEF_DRIVER_NAME, dsp->instance,
					taskp->x_id, i, cp->dmac_laddress,
					cp->dmac_size);
				bdp += 1;
				cp += 1;
			}

			fwtaskp->txwr_only.sgl_ctx.sgl.mul_sgl.cur_sge_addr.lo =
			CPU_TO_LE32((uint32_t)taskp->bd_cookie.dmac_laddress);
			fwtaskp->txwr_only.sgl_ctx.sgl.mul_sgl.cur_sge_addr.hi =
			(uint32_t)CPU_TO_LE32((
			(uint64_t)taskp->bd_cookie.dmac_laddress >> 32));
			fwtaskp->txwr_only.sgl_ctx.sgl.mul_sgl.sgl_size = 1;
			mutex_exit(&taskp->task_mutex);
			ddi_dma_sync(pktp->pkt_cmd_dma, 0, 0,
					DDI_DMA_SYNC_FORDEV);
			ret = ddi_dma_sync(taskp->bd_dma_handle, 0,
				taskp->bd_length, DDI_DMA_SYNC_FORDEV);
			if (ret != DDI_SUCCESS) {
				return (BNXEF_FAILURE);
			}
			mutex_enter(&taskp->task_mutex);
		}
	}

	/* Tx Write Rx Read */
	fwtaskp->txwr_rxrd.const_ctx.tx_flags = FCOE_TASK_TX_STATE_INIT <<
				FCOE_TCE_TX_WR_RX_RD_CONST_TX_STATE_SHIFT;
	fwtaskp->txwr_rxrd.const_ctx.init_flags = task_type <<
				FCOE_TCE_TX_WR_RX_RD_CONST_TASK_TYPE_SHIFT;
	fwtaskp->rxwr_txrd.const_ctx.init_flags = CPU_TO_LE32(context_id <<
				FCOE_TCE_RX_WR_TX_RD_CONST_CID_SHIFT);
	fwtaskp->txwr_rxrd.const_ctx.verify_tx_seq = 0;
	fwtaskp->rxwr_txrd.const_ctx.data_2_trns =
		CPU_TO_LE32(pktp->pkt_cmdlen);
	fwtaskp->rxwr_txrd.var_ctx.rx_flags |= CPU_TO_LE16(1 <<
			FCOE_TCE_RX_WR_TX_RD_VAR_EXP_FIRST_FRAME_SHIFT);
	fwtaskp->rxwr_txrd.var_ctx.rx_id = CPU_TO_LE16(0xffff);

	/* Fill FC Header into middle path buffer */
	bcopy(&pktp->pkt_cmd_fhdr, &tfchdr, sizeof (fc_frame_hdr_t));
	bnxef_big_endian(&tfchdr, sizeof (fc_frame_hdr_t));
	ofchdrp = (uint64_t *)&fwtaskp->txwr_rxrd.union_ctx.tx_frame.fc_hdr;
	tmpfchdrp = (uint64_t *)&tfchdr;
	ofchdrp[0] = BSWAP_64(tmpfchdrp[0]);
	ofchdrp[1] = BSWAP_64(tmpfchdrp[1]);
	ofchdrp[2] = BSWAP_64(tmpfchdrp[2]);
	BNXEF_DEBUG(dsp, ELS, portp->id,
		"%s%d: init_flags 0x%x, common_flags 0x%x, data_2_trns 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		fwtaskp->txwr_rxrd.const_ctx.init_flags,
		fwtaskp->rxwr_txrd.var_ctx.rx_flags,
		fwtaskp->rxwr_txrd.const_ctx.data_2_trns);
	/* Rx Only */
	if (task_type == FCOE_TASK_TYPE_MIDPATH) {
		if (pktp->pkt_rsplen != 0) {
			ASSERT(pktp->pkt_cmd_cookie_cnt == 1);
			ASSERT(pktp->pkt_resp_cookie_cnt == 1);
			/* LINTED: alignment */
			bdp = (struct fcoe_bd_ctx *)taskp->bd_addr;
			bdp += 1; /* Move to the next one */
			cp = pktp->pkt_resp_cookie;
			for (i = 0; i < pktp->pkt_resp_cookie_cnt; i++) {
				bdp->buf_addr_hi =  (uint32_t)
				CPU_TO_LE32((
				(uint64_t)cp->dmac_laddress >> 32));
				bdp->buf_addr_lo = CPU_TO_LE32((uint32_t)
					cp->dmac_laddress);
				ASSERT(cp->dmac_size < BNXEF_MAX_BD_SIZE);
				bdp->buf_len = CPU_TO_LE16(cp->dmac_size);

				BNXEF_DEBUG(dsp, SCSI, -1,
			"%s%d: x_id 0x%x, Cookie %d, Address 0x%p, size 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				taskp->x_id, i,
				cp->dmac_laddress,
				cp->dmac_size);
				bdp += 1;
				cp += 1;
			}
			rsp_phy_addr = taskp->bd_cookie.dmac_laddress +
				sizeof (struct fcoe_bd_ctx);
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.sgl.
				mul_sgl.cur_sge_addr.lo =
				CPU_TO_LE32((uint32_t)rsp_phy_addr);
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.sgl.
				mul_sgl.cur_sge_addr.hi =
				CPU_TO_LE32((uint32_t)(
				(uint64_t)rsp_phy_addr >> 32));
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.sgl.
				mul_sgl.sgl_size =
				pktp->pkt_resp_cookie_cnt;
			mutex_exit(&taskp->task_mutex);
			ret = ddi_dma_sync(taskp->bd_dma_handle, 0,
				taskp->bd_length, DDI_DMA_SYNC_FORDEV);
			if (ret != DDI_SUCCESS) {
				return (BNXEF_FAILURE);
			}
			mutex_enter(&taskp->task_mutex);
		}
	}
	mutex_exit(&taskp->task_mutex);
	ret = ddi_dma_sync(dsp->task_dma_handle[taskp->dma_handle_idx],
		(taskp->x_id %32) * sizeof (struct fcoe_task_ctx_entry),
		sizeof (struct fcoe_task_ctx_entry),
		DDI_DMA_SYNC_FORDEV);
	ASSERT(ret == DDI_SUCCESS);
	if (ret != DDI_SUCCESS) {
		return (BNXEF_FAILURE);
	}
	return (BNXEF_SUCCESS);
}

uint64_t *global_fcp_cmd;
/*
 * This will initialize the firmware task entry with the required fields for
 * transport. This will be used for initializing the SCSI commands.
 */
int
bnxef_init_task(bnxef_session_t *sessionp,  fc_packet_t *pktp)
{
	uint8_t task_type;
	uint32_t context_id;
	int i;
	bnxef_port_t *portp;
	bnxef_driver_state_t *dsp;
	bnxef_fcoe_task_t *taskp;
	struct fcoe_task_ctx_entry *fwtaskp;
	uint8_t *fcp_cmdp;
	struct fcoe_bd_ctx  *bdp;
	int ret, cnt;
	uint32_t	length;
	fcp_cmd_t	tmp_fcp_cmd;
	uint64_t	*tfcp_cmd;
	uint64_t	*ofcp_cmd;
	ddi_dma_cookie_t	*cp;
	size_t		dmac_size;
	uint64_t	address;
	int cookie_cnt = 0;
	bnxef_scsi_lun_t	lun;
	fcp_cmd_t	*cmdp;


	ASSERT(sessionp != NULL);
	portp = sessionp->lport;
	ASSERT(portp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	ASSERT(pktp != NULL);
	mutex_enter(&sessionp->session_mutex);
	context_id = sessionp->context_id;
	mutex_exit(&sessionp->session_mutex);

	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	BNXEF_DEBUG(dsp, SCSI, -1, "%s%d: TAsk Id 0x%x\n", BNXEF_DRIVER_NAME,
		dsp->instance, taskp->x_id);
	fwtaskp = taskp->fwtaskp;
	ASSERT(fwtaskp != NULL);

	memset(fwtaskp, 0, sizeof (struct fcoe_task_ctx_entry));

	if ((pktp->pkt_tran_type & FC_PKT_FCP_WRITE) == FC_PKT_FCP_WRITE) {
		task_type = FCOE_TASK_TYPE_WRITE;
	} else {
		task_type = FCOE_TASK_TYPE_READ;
	}

	if (pktp->pkt_datalen != 0) {
		if (dsp->task_bd_table_pre_alloc == 0) {
			/* Allocate the bd Table for this data */
			ret = bnxef_task_bd_table_alloc(sessionp, pktp);
			if (ret != BNXEF_SUCCESS) {
				BNXEF_DEBUG(dsp,  ERROR, portp->id,
					"%s%d: Unable to allocate BD table\n",
				BNXEF_DRIVER_NAME, dsp->instance);
				ASSERT(ret == BNXEF_SUCCESS);
				return (BNXEF_FAILURE);
			}
		}

		/* LINTED: alignment */
		bdp = (struct fcoe_bd_ctx *)taskp->bd_addr;
		cp = pktp->pkt_data_cookie;
		taskp->data_cookie = cp;
		length = pktp->pkt_datalen;
		cookie_cnt = 0;
		for (i = 0; i < pktp->pkt_data_cookie_cnt; i++) {
			mutex_enter(&taskp->task_mutex);
			if (cp->dmac_size > BNXEF_MAX_BD_SIZE) {
				dmac_size = cp->dmac_size;
				address = cp->dmac_laddress;
				do  {
					bdp->buf_addr_hi =  (uint32_t)
					CPU_TO_LE32((uint64_t)address >> 32);
					bdp->buf_addr_lo =
						CPU_TO_LE32((uint32_t)address);
					if (dmac_size > BNXEF_SPLIT_BD_SIZE) {
						dmac_size -=
							BNXEF_SPLIT_BD_SIZE;
						bdp->buf_len =
						CPU_TO_LE16(
						(uint16_t)BNXEF_SPLIT_BD_SIZE);
						address += BNXEF_SPLIT_BD_SIZE;
						length -= BNXEF_SPLIT_BD_SIZE;
						cookie_cnt++;
						bdp += 1;
					} else {
						bdp->buf_len =
					CPU_TO_LE16((uint16_t)dmac_size);
						length -= dmac_size;
						dmac_size -= dmac_size;
					}
				} while (dmac_size != 0);
			} else {
				bdp->buf_addr_hi = (uint32_t)
				CPU_TO_LE32((uint64_t)cp->dmac_laddress >> 32);
				bdp->buf_addr_lo =
				CPU_TO_LE32((uint32_t)cp->dmac_laddress);
				ASSERT(cp->dmac_size <= BNXEF_MAX_BD_SIZE);
				bdp->buf_len =
					CPU_TO_LE16((uint16_t)(cp->dmac_size));
				length -= cp->dmac_size;
			}

#if 0
			cmn_err(CE_NOTE, "%s%d: Bdp->buf_addr_lo 0x%x, \
				bdp->buf_addr_hi 0x%x, bdp->buf_len 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				bdp->buf_addr_lo, bdp->buf_addr_hi,
				bdp->buf_len);

			cmn_err(CE_NOTE,
			"%s%d: x_id 0x%x, Cookie %d, Address 0x%p, size 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				taskp->x_id, i,
				cp->dmac_laddress,
				cp->dmac_size);
#endif

			BNXEF_DEBUG(dsp, SCSI, -1,
			"%s%d: x_id 0x%x, Cookie %d, Address 0x%p, size 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				taskp->x_id, i,
				cp->dmac_laddress,
				cp->dmac_size);
			cookie_cnt++;
			bdp += 1;
			mutex_exit(&taskp->task_mutex);
			cp += 1;
		}
		if (length != 0) {
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Something Wrong, x_id 0x%x, count 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id,
				cookie_cnt);
			cp = pktp->pkt_data_cookie;
		}
		ASSERT(length == 0);
		ret = ddi_dma_sync(pktp->pkt_data_dma, 0, pktp->pkt_datalen,
				DDI_DMA_SYNC_FORDEV);
		if (ret != DDI_SUCCESS)
			return (BNXEF_FAILURE);

		ASSERT(ret == DDI_SUCCESS);
		ret = ddi_dma_sync(taskp->bd_dma_handle, 0, taskp->bd_length,
			DDI_DMA_SYNC_FORDEV);
		if (ret != DDI_SUCCESS)
			return (BNXEF_FAILURE);
		ASSERT(ret == DDI_SUCCESS);

	}
	taskp->actual_bd_entries = cookie_cnt;
	mutex_enter(&taskp->task_mutex);
	/* Tx only */
	if ((task_type == FCOE_TASK_TYPE_WRITE) && (pktp->pkt_datalen != 0)) {
		if (cookie_cnt == 1) {
			struct fcoe_bd_ctx *fcoe_bd_tbl =
				/* LINTED: alignment */
				(struct fcoe_bd_ctx *)taskp->bd_addr;
			fwtaskp->txwr_only.sgl_ctx.cached_sge.cur_buf_addr.lo =
				fcoe_bd_tbl->buf_addr_lo;
			fwtaskp->txwr_only.sgl_ctx.cached_sge.cur_buf_addr.hi =
				fcoe_bd_tbl->buf_addr_hi;
			fwtaskp->txwr_only.sgl_ctx.cached_sge.cur_buf_rem =
				fcoe_bd_tbl->buf_len;
			fwtaskp->txwr_rxrd.const_ctx.init_flags |= 1 <<
				FCOE_TCE_TX_WR_RX_RD_CONST_CACHED_SGE_SHIFT;
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.
				cached_sge.cur_buf_addr.lo =
				fcoe_bd_tbl->buf_addr_lo;
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.
				cached_sge.cur_buf_addr.hi =
				fcoe_bd_tbl->buf_addr_hi;
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.
				cached_sge.cur_buf_rem =
				fcoe_bd_tbl->buf_len;
		} else {
			fwtaskp->txwr_only.sgl_ctx.sgl.mul_sgl.cur_sge_addr.lo =
			CPU_TO_LE32((uint32_t)taskp->bd_cookie.dmac_laddress);
			fwtaskp->txwr_only.sgl_ctx.sgl.mul_sgl.cur_sge_addr.hi =
				CPU_TO_LE32((uint32_t)
			((uint64_t)taskp->bd_cookie.dmac_laddress >> 32));
			fwtaskp->txwr_only.sgl_ctx.sgl.mul_sgl.sgl_size =
				cookie_cnt;
		}
	}

	/* Tx Write Rx Read */
	fwtaskp->txwr_rxrd.const_ctx.tx_flags = FCOE_TASK_TX_STATE_NORMAL <<
				FCOE_TCE_TX_WR_RX_RD_CONST_TX_STATE_SHIFT;
	fwtaskp->txwr_rxrd.const_ctx.init_flags |= task_type <<
				FCOE_TCE_TX_WR_RX_RD_CONST_TASK_TYPE_SHIFT;
	fwtaskp->txwr_rxrd.const_ctx.verify_tx_seq = 0;
	/* Common */
	fwtaskp->rxwr_txrd.const_ctx.data_2_trns =
			CPU_TO_LE32(pktp->pkt_datalen);
	fwtaskp->rxwr_txrd.const_ctx.init_flags = CPU_TO_LE32(context_id <<
				FCOE_TCE_RX_WR_TX_RD_CONST_CID_SHIFT);
	fwtaskp->rxwr_txrd.var_ctx.rx_flags |= CPU_TO_LE16(1 <<
			FCOE_TCE_RX_WR_TX_RD_VAR_EXP_FIRST_FRAME_SHIFT);

	fwtaskp->rxwr_txrd.var_ctx.rx_id = CPU_TO_LE16(0xffff);

	/* Set the initiative for ownership */
	fwtaskp->txwr_rxrd.union_ctx.tx_seq.ctx.seq_cnt = CPU_TO_LE16(1);

	/* Fill FCP_CMND IU */
	fcp_cmdp =
		(uint8_t *)fwtaskp->txwr_rxrd.union_ctx.fcp_cmd.opaque;

	/* Copy from pkt to this address */
	ddi_rep_get8(pktp->pkt_cmd_acc, (uint8_t *)fcp_cmdp,
		(uint8_t *)pktp->pkt_cmd, 32, DDI_DEV_AUTOINCR);

	/* LINTED: alignment */
	cmdp = (fcp_cmd_t *)fcp_cmdp;
	if (cmdp->fcp_cntl.cntl_qtype == FCP_QTYPE_UNTAGGED) {
		BNXEF_DEBUG(dsp, SCSI, -1, "%s%d: Queue Type 0x%x\n",
			BNXEF_DRIVER_NAME, dsp->instance,
			cmdp->fcp_cntl.cntl_qtype);
		cmdp->fcp_cntl.cntl_qtype = FCP_QTYPE_SIMPLE;
	}

	cmdp->fcp_data_len = htonl(cmdp->fcp_data_len);

#if 0
	/* This will set the give FCP DL in Big endian format */
	bnxef_big_endian((uint8_t *)fcp_cmdp + 28, 4);
#endif

	/* The following will set the LUN number is appropriate big endian */
	lun = bnxef_scsi_lun64_to_lun(*(
		/* LINTED: alignment */
		(uint64_t *)fcp_cmdp));
	memcpy(fcp_cmdp, &lun, sizeof (bnxef_scsi_lun_t));

	/* LINTED: alignment */
	BSWAP_64(*((uint64_t *)fcp_cmdp));

	cnt = sizeof (fcp_cmd_t)/sizeof (uint64_t);
	tfcp_cmd = (uint64_t *)&tmp_fcp_cmd;
	/* LINTED: alignment */
	ofcp_cmd = (uint64_t *)fcp_cmdp;
	for (i = 0; i < cnt; i++) {
		tfcp_cmd[i] = BSWAP_64(ofcp_cmd[i]);
	}

	bcopy((uint8_t *)tfcp_cmd, (uint8_t *)ofcp_cmd, sizeof (fcp_cmd_t));
	global_fcp_cmd = (uint64_t *)taskp;

	/* Rx Only */
	if ((task_type == FCOE_TASK_TYPE_READ) && (pktp->pkt_datalen != 0)) {
		if (cookie_cnt == 1) {
			struct fcoe_bd_ctx *fcoe_bd_tbl =
				/* LINTED: alignment */
				(struct fcoe_bd_ctx *)taskp->bd_addr;
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.
				cached_sge.cur_buf_addr.lo =
				fcoe_bd_tbl->buf_addr_lo;
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.
				cached_sge.cur_buf_addr.hi =
				fcoe_bd_tbl->buf_addr_hi;
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.
				cached_sge.cur_buf_rem =
				fcoe_bd_tbl->buf_len;
			fwtaskp->txwr_rxrd.const_ctx.init_flags |= (1 <<
				FCOE_TCE_TX_WR_RX_RD_CONST_CACHED_SGE_SHIFT);
		} else if (cookie_cnt == 2) {
			struct fcoe_bd_ctx *fcoe_bd_tbl =
				/* LINTED: alignment */
				(struct fcoe_bd_ctx *)taskp->bd_addr;
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.
				cached_sge.cur_buf_addr.lo =
				fcoe_bd_tbl->buf_addr_lo;
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.
				cached_sge.cur_buf_addr.hi =
				fcoe_bd_tbl->buf_addr_hi;
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.
				cached_sge.cur_buf_rem =
				fcoe_bd_tbl->buf_len;

			fcoe_bd_tbl  += 1;
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.
				cached_sge.second_buf_addr.lo =
				fcoe_bd_tbl->buf_addr_lo;
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.
				cached_sge.second_buf_addr.hi =
				fcoe_bd_tbl->buf_addr_hi;
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.
					cached_sge.second_buf_rem =
					fcoe_bd_tbl->buf_len;
			fwtaskp->txwr_rxrd.const_ctx.init_flags |= (1 <<
				FCOE_TCE_TX_WR_RX_RD_CONST_CACHED_SGE_SHIFT);
		} else {
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.
				sgl.mul_sgl.cur_sge_addr.lo =
			CPU_TO_LE32((uint32_t)taskp->bd_cookie.dmac_laddress);
			fwtaskp->rxwr_only.union_ctx.read_info.sgl_ctx.
				sgl.mul_sgl.cur_sge_addr.hi =
				CPU_TO_LE32((uint32_t)
			((uint64_t)taskp->bd_cookie.dmac_laddress >> 32));
			fwtaskp->rxwr_only.union_ctx.read_info.
				sgl_ctx.sgl.mul_sgl.sgl_size =
					cookie_cnt;
		}
	}

#if 0
	if (task_type == FCOE_TASK_TYPE_WRITE)
		debug_enter("write");
	bnxef_log_buf(dsp, (uint8_t *)fwtaskp,
			sizeof (struct fcoe_task_ctx_entry));
#endif
	BNXEF_DEBUG(dsp, GENERAL, -1,
		"%s%d: tx_flags 0x%x, init_flags 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		fwtaskp->txwr_rxrd.const_ctx.tx_flags,
		fwtaskp->txwr_rxrd.const_ctx.init_flags);
	BNXEF_DEBUG(dsp, GENERAL, -1,
		"%s%d: data_2_trns 0x%x, rxwr_txrd_init_flags 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		fwtaskp->rxwr_txrd.const_ctx.data_2_trns,
		fwtaskp->rxwr_txrd.const_ctx.init_flags);
	BNXEF_DEBUG(dsp, GENERAL, -1, "%s%d: Rx State 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
			fwtaskp->rxwr_txrd.var_ctx.rx_flags);
	mutex_exit(&taskp->task_mutex);

	ret = ddi_dma_sync(dsp->task_dma_handle[taskp->dma_handle_idx],
		(taskp->x_id %32) * sizeof (struct fcoe_task_ctx_entry),
		sizeof (struct fcoe_task_ctx_entry),
		DDI_DMA_SYNC_FORDEV);
	if (ret != DDI_SUCCESS) {
		return (BNXEF_FAILURE);
	}
	ASSERT(ret == DDI_SUCCESS);

#if 0
	ret = ddi_dma_sync(dsp->task_dma_handle[taskp->dma_handle_idx],
		0, 0, DDI_DMA_SYNC_FORDEV);
	if (ret != DDI_SUCCESS) {
		return (BNXEF_FAILURE);
	}
#endif
	return (BNXEF_SUCCESS);

}


void
bnxef_log_buf(bnxef_driver_state_t *dsp, uint8_t *buf, int size)
{
	int i;
	/* LINTED: alignment */
	uint32_t	*buf32p = (uint32_t *)buf;

	ASSERT(dsp != NULL);

	cmn_err(CE_NOTE, "Buffer of Size 0x%x", size);
	for (i = 0; i < size/sizeof (uint32_t); i = i+ 4) {
		cmn_err(CE_NOTE, "0x%x  0x%x, 0x%x 0x%x",
			buf32p[i], buf32p[i+1], buf32p[i+2], buf32p[i+3]);
	}
}

int
bnxef_send_stats_req(bnxef_driver_state_t *dsp)
{

	struct fcoe_kwqe_stat stat_req;
	struct kwqe *kwqe_arr[2];
	int num_kwqes = 1;
	dev_info_t *pdip = NULL;

	ASSERT(dsp != NULL);
	pdip = ddi_get_parent(dsp->dip);
	ASSERT(mutex_owned(&dsp->state_mutex));

	memset(&stat_req, 0x0, sizeof (struct fcoe_kwqe_stat));
	stat_req.hdr.op_code = FCOE_KWQE_OPCODE_STAT;
	stat_req.hdr.flags = (FCOE_KWQE_LAYER_CODE <<
			FCOE_KWQE_HEADER_LAYER_CODE_SHIFT);
	stat_req.stat_params_addr_lo = CPU_TO_LE32((uint32_t)
			(dsp->stats_dma_cookie.dmac_laddress & 0xffffffff));
		stat_req.stat_params_addr_hi = CPU_TO_LE32((uint32_t)
			((uint64_t)dsp->stats_dma_cookie.dmac_laddress >> 32));

		kwqe_arr[0] = (struct kwqe *)&stat_req;
	(void) ddi_dma_sync(dsp->stats_dma_handle, 0, dsp->stats_size,
		DDI_DMA_SYNC_FORDEV);

	if (!dsp->callbacks.prvSendWqes(pdip, (void *)kwqe_arr, num_kwqes)) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to Send WQEs to get stats\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}

		return (BNXEF_SUCCESS);
}
