/*
 * The information contained in this file is confidential and proprietary to
 * Broadcom Corporation.  No part of this file may be reproduced or
 * distributed, in any form or by any means for any purpose, without the
 * express written permission of Broadcom Corporation.
 *
 * (c) COPYRIGHT 2010-2012 Broadcom Corporation, ALL RIGHTS RESERVED.
 */

#pragma ident "(C) 2010-2012 Broadcom Corporation $File$$Revision$$Change$$DateTime$"

#include <sys/conf.h>
#include <sys/ddi.h>
#include <sys/stat.h>
#include <sys/pci.h>
#include <sys/sunddi.h>
#include <sys/modctl.h>
#include <sys/cmn_err.h>
#include <sys/file.h>
#include <sys/cred.h>
#include <sys/byteorder.h>
#include <sys/atomic.h>
#include <sys/scsi/scsi.h>
#include <sys/modhash.h>
#include <sys/sunldi.h>
#include <sys/kstat.h>
#include <sys/kmem.h>
#include <sys/ethernet.h>
#include <sys/stream.h>
#include <sys/sunldi.h>
/*
 * leadville header files
 */
#include <sys/fibre-channel/fc_types.h>
#include <sys/fibre-channel/impl/fc_fcaif.h>
#include <bnxe_binding.h>
#include <bnxef_tq_param.h>
#include <bnxef_fcf_info.h>
#include <bnxef_hsi.h>
#include <bnxef_fcoe_task.h>
#include <bnxef_fcoe_session.h>
#include <bnxef_state.h>
#include <bnxef_fip.h>
#include <bnxef_fcoe.h>
#include <bnxef_debug.h>


#ifdef TESTING
extern bnxef_fcoe_task_t *bnxef_task_alloc(bnxef_driver_state_t *dsp,
	int sleepflag);
extern void bnxef_task_free(void *arg, bnxef_fcoe_task_t *taskp);
extern int
bnxef_task_session_list_get_num_items(bnxef_session_t *sessionp);
extern int
bnxef_task_session_list_find(bnxef_session_t *sessionp, uint16_t task_id);
int bnxef_session_list_remove(bnxef_port_t *portp, bnxef_session_t *sessionp,
	uint8_t hashbucket);
int bnxef_session_list_add(bnxef_port_t *portp, bnxef_session_t *sessionp,
	uint8_t hashbucket);
bnxef_session_t *bnxef_get_first_session(bnxef_port_t *portp, int bucket);
uint8_t bnxef_session_gen_hash(int16_t vlan_id, uint32_t d_id,
	uint8_t *macaddr);
int bnxef_session_list_init(bnxef_driver_state_t *dsp, bnxef_port_t *portp,
	uint8_t hashbucket);
int bnxef_session_list_fini(bnxef_driver_state_t *dsp, bnxef_port_t *portp,
	uint8_t hashbucket);
bnxef_session_t *
bnxef_session_find_remote_port(bnxef_port_t *portp, int16_t vlan_id,
		uint32_t d_id, uint8_t *macaddr);








void
bnxef_test_alloc_task(void *arg)
{
	bnxef_tq_params_t    *tqp = (bnxef_tq_params_t *)arg;
	bnxef_driver_state_t *dsp;
	bnxef_fcoe_task_t *taskp;
	bnxef_session_t	  *sessionp;
	int count = 0, ret;
	kmutex_t	*mp;
	kcondvar_t	*cvp;


	dsp = tqp->dsp;
	sessionp = tqp->sessp;
	mp = (kmutex_t *)tqp->reserved1;
	cvp = (kcondvar_t *)tqp->reserved2;

	ASSERT(dsp != NULL);

	BNXEF_AUTO_DEBUG("%s%d: -----------------Alloc Task Started-------",
		BNXEF_DRIVER_NAME, dsp->instance,
		__func__);

	while (1) {
		taskp = bnxef_task_alloc(dsp, KM_SLEEP);
		ASSERT(taskp != NULL);
		BNXEF_AUTO_DEBUG("%s%d: Allocated task 0x%p Count %d",
			BNXEF_DRIVER_NAME, dsp->instance, taskp, count);
		bnxef_task_session_list_add(sessionp, taskp);
		count++;
		if (count > 10000) break;
	}

	BNXEF_AUTO_DEBUG("%s%d: -----------------Alloc Task Done-------",
		BNXEF_DRIVER_NAME, dsp->instance,
		__func__);
}


void
bnxef_test_free_task(void *arg)
{
	bnxef_tq_params_t	*tqp = (bnxef_tq_params_t *)arg;
	bnxef_driver_state_t *dsp;
	bnxef_fcoe_task_t *taskp;
	bnxef_session_t	  *sessionp;
	int count = 0, i;
	kmutex_t *mp;
	kcondvar_t *cvp;
	uint16_t	task_id;

	dsp = tqp->dsp;
	sessionp = tqp->sessp;
	mp = (kmutex_t *)tqp->reserved1;
	cvp = (kcondvar_t *)tqp->reserved2;
	uint16_t  task_free[10] = { 0x5, 0x9, 0x8, 0x7, 0x3, 0x4,
				    0x1, 0x2, 0x6, 0x0 };
	uint16_t	nitems;

	ASSERT(dsp != NULL);

	BNXEF_DEBUG(dsp, GENERAL, -1, "---------- Free Task Started----------")

	while (1) {
		taskp = bnxef_task_session_list_get_first(sessionp);
		if (taskp == NULL) continue;
		bnxef_task_session_list_remove(sessionp, taskp);
		bnxef_task_free((void *)dsp, taskp);
		count++;
		if ((count%500) == 0) delay(BNXEF_SEC2TICK(2));
		task_id = (count + 100) % dsp->max_exchanges;
		if (bnxef_task_session_list_find(sessionp, task_id)) {
			taskp = dsp->taskarray[task_id];
			bnxef_task_session_list_remove(sessionp, taskp);
			bnxef_task_free((void *)dsp, taskp);
			count++;
		}
		if ((count%500) == 0) delay(BNXEF_SEC2TICK(2));
		if (count > 10000) break;
	}

	BNXEF_DEBUG(dsp, GENERAL, -1, "---------- Free Task Done----------")

	mutex_enter(mp);
	cv_signal(cvp);
	mutex_exit(mp);
}

/*
 * This tests the task structure allocation, inclusion into the session list
 * and removal from the session list.
 */
void
bnxef_test_driver_task(bnxef_driver_state_t *dsp)
{
	bnxef_tq_params_t *task1_paramp;
	bnxef_tq_params_t *task2_paramp;
	bnxef_session_t	 *sessionp;
	int ret;
	char name[KSTAT_STRLEN];
	kmutex_t *test_mutex;
	kcondvar_t	*test_cv;


	ASSERT(dsp != NULL);
	test_mutex = kmem_zalloc(sizeof (kmutex_t), KM_SLEEP);
	test_cv = kmem_zalloc(sizeof (kcondvar_t), KM_SLEEP);
	snprintf(name, KSTAT_STRLEN, "test%d-mutex", dsp->instance);
	mutex_init(test_mutex, name, MUTEX_DRIVER, NULL);
	snprintf(name, KSTAT_STRLEN, "test%d-cv", dsp->instance);
	cv_init(test_cv, name, CV_DRIVER, NULL);

	BNXEF_AUTO_DEBUG("%s%d:Test: Mutex and Condition variable alloced",
		BNXEF_DRIVER_NAME, dsp->instance);

	task1_paramp = kmem_cache_alloc(dsp->tq_params_cache, KM_SLEEP);
	ASSERT(task1_paramp != NULL);
	task2_paramp = kmem_cache_alloc(dsp->tq_params_cache, KM_SLEEP);
	ASSERT(task2_paramp != NULL);
	BNXEF_AUTO_DEBUG("%s%d: Task Params structure alloced for 2 tasks",
		BNXEF_DRIVER_NAME, dsp->instance);
	sessionp =   kmem_cache_alloc(dsp->session_cache, KM_SLEEP);
	if (sessionp == NULL) {
	    BNXEF_DEBUG(dsp, GENERAL, -1, "%s%d: Unable to allocate Sessionp"
		BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}
	/* Now Initialize the Task Session List */
	ret = bnxef_task_session_list_init(dsp, sessionp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to Init task sess list",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}
	BNXEF_AUTO_DEBUG("%s%d: Session List has been Initialized",
		BNXEF_DRIVER_NAME, dsp->instance);
	task1_paramp->dsp = dsp;
	task1_paramp->sessp = sessionp;
	task1_paramp->reserved1 = (uint64_t)test_mutex;
	task1_paramp->reserved2 = (uint64_t)test_cv;
	ret = ddi_taskq_dispatch(dsp->tq, bnxef_test_alloc_task,
		(void *) task1_paramp, DDI_SLEEP);
	if (ret == DDI_FAILURE)  {
		cmn_err(CE_WARN, "%s%d Unable to Schedule in task Q\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}

	BNXEF_AUTO_DEBUG("%s%d: First Task dispatched",
		BNXEF_DRIVER_NAME, dsp->instance);
	task2_paramp->dsp = dsp;
	task2_paramp->sessp = sessionp;
	task2_paramp->reserved1 = (uint64_t)test_mutex;
	task2_paramp->reserved2 = (uint64_t)test_cv;

	ret = ddi_taskq_dispatch(dsp->tq, bnxef_test_free_task,
		(void *) task2_paramp, DDI_SLEEP);
	if (ret == DDI_FAILURE)  {
		cmn_err(CE_WARN, "%s%d Unable to Schedule in task Q\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}
	BNXEF_AUTO_DEBUG("%s%d: Second Task dispatched",
		BNXEF_DRIVER_NAME, dsp->instance);
	mutex_enter(test_mutex);
	cv_wait(test_cv, test_mutex);
	mutex_exit(test_mutex);
	BNXEF_AUTO_DEBUG("%s%d: Second Task wake me up to exit, exiting...",
			BNXEF_DRIVER_NAME, dsp->instance);

	kmem_cache_free(dsp->session_cache, sessionp);
	kmem_cache_free(dsp->tq_params_cache, task1_paramp);
	kmem_cache_free(dsp->tq_params_cache, task2_paramp);
	mutex_destroy(test_mutex);
	cv_destroy(test_cv);
	kmem_free(test_mutex, sizeof (kmutex_t));
	kmem_free(test_cv, sizeof (kcondvar_t));

}

uint64_t  port_ptrs[256];
uint8_t	  remove_order[256];

void
bnxef_test_alloc_port(void *arg)
{
	bnxef_tq_params_t  *tqp  = (bnxef_tq_params_t *)arg;
	bnxef_driver_state_t *dsp;
	bnxef_port_list_t *portlstp;
	bnxef_port_t	*portp;
	uint8_t	  index;
	uint16_t nitems;
	kmutex_t *mp;
	kcondvar_t *cvp;
	int i, ret;
	uint32_t port_id;
	uint16_t  vlan_id;
	uint8_t  macaddr[ETHERADDRL];


	mp = (kmutex_t *)tqp->reserved1;
	cvp = (kcondvar_t *)tqp->reserved2;
	dsp = tqp->dsp;

	portlstp = &dsp->port_list;

	for (i = 0; i < dsp->max_fc_ports; i++) {
		portp = kmem_cache_alloc(dsp->port_cache, KM_SLEEP);
		port_ptrs[i] = (uint64_t)portp;
		ASSERT(portp != NULL);
		BNXEF_AUTO_DEBUG("%s%d: Port Allocated 0x%p",
			BNXEF_DRIVER_NAME, dsp->instance, portp);
		portp->flags =   BNXEF_FC_PORT_ID_ACQUIRED; // (1 << (i %9));
		portp->id    =   i + 0x10000;
		portp->mac_addr[0] = i;
		portp->mac_addr[1] = 0xf0;
		portp->mac_addr[2] = 0xf0;
		portp->mac_addr[3] = 0xff;
		portp->mac_addr[4] = 0xd0;
		portp->mac_addr[5] = 0xcf;
		portp->vlan_id =  i + 0x300;
		ret = bnxef_port_list_add(dsp, portp);
		ASSERT(ret == BNXEF_SUCCESS);
		if (i < 128)
			remove_order[i] = 128 - i -1;
		else
			remove_order[i] = 255 - i + 128;
	}
	for (i = 0; i < 5; i++) {
		portp = kmem_cache_alloc(dsp->port_cache, KM_SLEEP);
		ASSERT(portp != NULL);
		BNXEF_AUTO_DEBUG("%s%d: Port Allocated 0x%p",
			BNXEF_DRIVER_NAME, dsp->instance, portp);
		portp->flags =   BNXEF_FC_PORT_ID_NOT_ACQUIRED;
		portp->id    =   i + 0x20000;
		portp->mac_addr[0] = i;
		portp->mac_addr[1] = 0xb0;
		portp->mac_addr[2] = 0xa0;
		portp->mac_addr[3] = 0xc0;
		portp->mac_addr[4] = 0xd0;
		portp->mac_addr[5] = 0xcf;
		portp->vlan_id =  i + 0x500;
		ret = bnxef_port_list_add(dsp, portp);
		ASSERT(ret == BNXEF_SUCCESS);
	}
	for (i = 0; i < 5; i++) {
		portp = kmem_cache_alloc(dsp->port_cache, KM_SLEEP);
		ASSERT(portp != NULL);
		BNXEF_AUTO_DEBUG("%s%d: Port Allocated 0x%p",
			BNXEF_DRIVER_NAME, dsp->instance, portp);
		portp->flags =   BNXEF_FC_PORT_REMOTE | BNXEF_FC_PORT_TARGET;
				// (1 << (i %9));
		portp->id    =   i + 0x30000;
		portp->mac_addr[0] = i;
		portp->mac_addr[1] = 0xbb;
		portp->mac_addr[2] = 0xaa;
		portp->mac_addr[3] = 0xcc;
		portp->mac_addr[4] = 0xd0;
		portp->mac_addr[5] = 0xcf;
		portp->vlan_id =  i + 0x500;
		ret = bnxef_port_list_add(dsp, portp);
		ASSERT(ret == BNXEF_SUCCESS);
	}

	portp = bnxef_port_list_find_flags(dsp, BNXEF_FC_PORT_REMOTE |
					BNXEF_FC_PORT_TARGET);
	if (portp != NULL) {
		BNXEF_AUTO_DEBUG("%s%d: Port id 0x%x, vlan id 0x%x\n",
			BNXEF_DRIVER_NAME, dsp->instance, portp->id,
			portp->vlan_id);
	} else
		ASSERT(0);
	portp = bnxef_port_list_find_flags(dsp, BNXEF_FC_PORT_ID_NOT_ACQUIRED);
	if (portp != NULL) {
		BNXEF_AUTO_DEBUG("%s%d: Port id 0x%x, vlan id 0x%x\n",
			BNXEF_DRIVER_NAME, dsp->instance, portp->id,
			portp->vlan_id);
	} else ASSERT(0);

	/* Find something in the middle of the list */
	port_id = 0x26;
	macaddr[0] = port_id;
	macaddr[1] = 0xf0;
	macaddr[2] = 0xf0;
	macaddr[3] = 0xff;
	macaddr[4] = 0xd0;
	macaddr[5] = 0xcf;
	vlan_id = port_id + 0x300;
	port_id += 0x10000;

	portp = bnxef_port_list_find_id(dsp, macaddr, vlan_id, port_id);
	if (portp != NULL) {
		ASSERT(port_id == portp->id);
		ASSERT(vlan_id == portp->vlan_id);
		BNXEF_AUTO_DEBUG("%s%d: Found the right Port 0x%x,\
				vlan id 0x%x", BNXEF_DRIVER_NAME,
				dsp->instance, port_id, vlan_id);
	} else {
		ASSERT(0);
	}

	/* Beginning of the list */
	port_id = 0x1;
	vlan_id = 0x300 + port_id;
	macaddr[0] = port_id;
	port_id += 0x10000;
	portp = bnxef_port_list_find_id(dsp, macaddr, vlan_id, port_id);
	if (portp != NULL) {
		ASSERT(port_id == portp->id);
		ASSERT(vlan_id == portp->vlan_id);
		BNXEF_AUTO_DEBUG("%s%d: Found the right Port 0x%x,\
				vlan id 0x%x", BNXEF_DRIVER_NAME,
				dsp->instance, port_id, vlan_id);
	} else {
		ASSERT(0);
	}

	/* End of the list */
	port_id = 0xFF;
	vlan_id = 0x300 + port_id;
	macaddr[0] = port_id;
	port_id += 0x10000;
		portp = bnxef_port_list_find_id(dsp, macaddr, vlan_id, port_id);
	if (portp != NULL) {
		ASSERT(port_id == portp->id);
		ASSERT(vlan_id == portp->vlan_id);
		BNXEF_AUTO_DEBUG("%s%d: Found the right Port 0x%x,\
				vlan id 0x%x", BNXEF_DRIVER_NAME,
				dsp->instance, port_id, vlan_id);
	} else {
		ASSERT(0);
	}

	for (i = 0; i < dsp->max_fc_ports; i++) {
		index = remove_order[i];
		portp = (bnxef_port_t *)port_ptrs[index];
		ASSERT(portp != NULL);
		ASSERT(index <= 255);
		BNXEF_AUTO_DEBUG("%s%d: Port Removed 0x%p",
			BNXEF_DRIVER_NAME, dsp->instance, portp);
		ret = bnxef_port_list_remove(dsp, portp);
		ASSERT(ret == BNXEF_SUCCESS);
		kmem_cache_free(dsp->port_cache, portp);
	}

	while ((portp = bnxef_get_first_port(dsp)) != NULL) {
		ret = bnxef_port_list_remove(dsp, portp);
		ASSERT(ret == BNXEF_SUCCESS);
		kmem_cache_free(dsp->port_cache, portp);
	}

	debug_enter("Verify test task");
	mutex_enter(mp);
	cv_signal(cvp);
	mutex_exit(mp);

}

void
bnxef_test_free_port(void *arg)
{


}

/*
 * The following will test the port allocation, inclusion in port list and
 * removal and finding the appropriate port.
 */
void
bnxef_test_driver_port(bnxef_driver_state_t *dsp)
{

	bnxef_tq_params_t *task1_paramp;
	bnxef_tq_params_t *task2_paramp;
	int ret;
	char name[KSTAT_STRLEN];
	kmutex_t *test_mutex;
	kcondvar_t	*test_cv;

	ASSERT(dsp != NULL);
	test_mutex = kmem_zalloc(sizeof (kmutex_t), KM_SLEEP);
	test_cv = kmem_zalloc(sizeof (kcondvar_t), KM_SLEEP);
	snprintf(name, KSTAT_STRLEN, "test%d-mutex", dsp->instance);
	mutex_init(test_mutex, name, MUTEX_DRIVER, NULL);
	snprintf(name, KSTAT_STRLEN, "test%d-cv", dsp->instance);
	cv_init(test_cv, name, CV_DRIVER, NULL);

	BNXEF_AUTO_DEBUG("%s%d:Test: Mutex and Condition variable alloced",
		BNXEF_DRIVER_NAME, dsp->instance);

	task1_paramp = kmem_cache_alloc(dsp->tq_params_cache, KM_SLEEP);
	ASSERT(task1_paramp != NULL);
	task2_paramp = kmem_cache_alloc(dsp->tq_params_cache, KM_SLEEP);
	ASSERT(task2_paramp != NULL);
	BNXEF_AUTO_DEBUG("%s%d: Task Params structure alloced for 2 tasks",
		BNXEF_DRIVER_NAME, dsp->instance);

	task1_paramp->dsp = dsp;
	task1_paramp->sessp = NULL;
	task1_paramp->reserved1 = (uint64_t)test_mutex;
	task1_paramp->reserved2 = (uint64_t)test_cv;
	ret = ddi_taskq_dispatch(dsp->tq, bnxef_test_alloc_port,
		(void *) task1_paramp, DDI_SLEEP);
	if (ret == DDI_FAILURE)  {
		cmn_err(CE_WARN, "%s%d Unable to Schedule in task Q\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}

	BNXEF_AUTO_DEBUG("%s%d: First Task dispatched",
		BNXEF_DRIVER_NAME, dsp->instance);
	task2_paramp->dsp = dsp;
	task2_paramp->sessp = NULL;
	task2_paramp->reserved1 = (uint64_t)test_mutex;
	task2_paramp->reserved2 = (uint64_t)test_cv;

	ret = ddi_taskq_dispatch(dsp->tq, bnxef_test_free_port,
		(void *) task2_paramp, DDI_SLEEP);
	if (ret == DDI_FAILURE)  {
		cmn_err(CE_WARN, "%s%d Unable to Schedule in task Q\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}
	BNXEF_AUTO_DEBUG("%s%d: Second Task dispatched",
		BNXEF_DRIVER_NAME, dsp->instance);
	mutex_enter(test_mutex);
	cv_wait(test_cv, test_mutex);
	mutex_exit(test_mutex);
	BNXEF_AUTO_DEBUG("%s%d: Second Task wake me up to exit, exiting...",
			BNXEF_DRIVER_NAME, dsp->instance);

	kmem_cache_free(dsp->tq_params_cache, task1_paramp);
	kmem_cache_free(dsp->tq_params_cache, task2_paramp);
	mutex_destroy(test_mutex);
	cv_destroy(test_cv);
	kmem_free(test_mutex, sizeof (kmutex_t));
	kmem_free(test_cv, sizeof (kcondvar_t));
}

bnxef_session_t		*sessptr[512];
uint16_t			remove_sess_order[512];
uint8_t			hashvalue[512];
uint16_t			cur_index;
bnxef_session_t		*rx_session_ptr[512];
void
bnxef_test_alloc_session(void *arg)
{
	bnxef_tq_params_t	*tqp = (bnxef_tq_params_t *)arg;
	bnxef_driver_state_t	*dsp;
	bnxef_port_t		*portp;
	kmutex_t		*mp;
	kcondvar_t		*cvp;
	bnxef_port_t		*rportp;
	bnxef_session_t		*sessionp, *fsessionp;
	int 			i, ret, nitems, index;
	uint8_t			hash;
	bnxef_session_list_t	*slstp;


	dsp = tqp->dsp;
	portp = tqp->portp;
	mp = (kmutex_t *)tqp->reserved1;
	cvp = (kcondvar_t *)tqp->reserved2;

	/* Initialize all the hash buckets */
	for (i = 0; i < BNXEF_MAX_HASH_BUCKETS; i++)
		bnxef_session_list_init(dsp, portp, i);

	for (i = 0; i < 512; i++) {
		rportp = kmem_cache_alloc(dsp->port_cache, KM_SLEEP);
		ASSERT(rportp != NULL);
		sessionp = kmem_cache_alloc(dsp->session_cache, KM_SLEEP);
		ASSERT(sessionp != NULL);

		/* Initialize the Rport filed appropriately */
		rportp->id = 0x50000 + i;
		rportp->flags = BNXEF_FC_PORT_REMOTE | BNXEF_FC_PORT_TARGET;
		rportp->vlan_id = 0x768 +i;
		rportp->mac_addr[0] = i;
		rportp->mac_addr[1] = 0xaa;
		rportp->mac_addr[2] = 0x55 + i;
		rportp->mac_addr[3] = 0xCC;
		rportp->mac_addr[4] = 0xDD;
		rportp->mac_addr[5] = 0xEE;

		sessionp->lport = (void *)portp;
		sessionp->rport = (void *)rportp;
		hash = bnxef_session_gen_hash(rportp->vlan_id, rportp->id,
			rportp->mac_addr);
		BNXEF_AUTO_DEBUG("%s%d: Hash for Portid 0x%x, vlan_id 0x%x,\
			Mac addr %x:%x:%x:%x:%x:%x, is 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, rportp->id,
			rportp->vlan_id, rportp->mac_addr[5],
			rportp->mac_addr[4], rportp->mac_addr[3],
			rportp->mac_addr[2], rportp->mac_addr[1],
			rportp->mac_addr[0], hash);
		ret = bnxef_session_list_add(portp, sessionp, hash);
		ASSERT(ret == BNXEF_SUCCESS);
		sessptr[i] = sessionp;
		hashvalue[i] = hash;
		if (i < 256)
			remove_sess_order[i] = 256 -i -1;
		else
			remove_sess_order[i] = 511 -i + 256;

	}

#if 0
	for (i = 0; i < 512; i++) {
		/* sessionp = bnxef_get_first_session(portp, 0); */
		index = remove_sess_order[i];
		cur_index = index;
		sessionp = sessptr[index];
		ASSERT(sessionp != NULL);
		rportp = sessionp->rport;
		ASSERT(rportp != NULL);
		fsessionp = bnxef_session_find_remote_port(portp,
			rportp->vlan_id, rportp->id, rportp->mac_addr);
		rx_session_ptr[index] = fsessionp;

		ASSERT(sessionp == fsessionp);
		hash = bnxef_session_gen_hash(rportp->vlan_id, rportp->id,
			rportp->mac_addr);
		ret = bnxef_session_list_remove(portp, sessionp, hash);
		ASSERT(ret == BNXEF_SUCCESS);
		kmem_cache_free(dsp->port_cache, sessionp->rport);
		kmem_cache_free(dsp->session_cache, sessionp);
	}

	/* When done uninitialize all the hash buckets */
	for (i = 0; i < BNXEF_MAX_HASH_BUCKETS; i++)
		bnxef_session_list_fini(dsp, portp, i);
#endif


	mutex_enter(mp);
	cv_signal(cvp);
	mutex_exit(mp);
}



void
bnxef_test_driver_session(bnxef_driver_state_t *dsp)
{
	bnxef_tq_params_t *task1_paramp;
	bnxef_tq_params_t *task2_paramp;
	bnxef_port_t	  *portp;
	int ret;
	char name[KSTAT_STRLEN];
	kmutex_t *test_mutex;
	kcondvar_t	*test_cv;

	ASSERT(dsp != NULL);
	test_mutex = kmem_zalloc(sizeof (kmutex_t), KM_SLEEP);
	test_cv = kmem_zalloc(sizeof (kcondvar_t), KM_SLEEP);
	snprintf(name, KSTAT_STRLEN, "test%d-mutex", dsp->instance);
	mutex_init(test_mutex, name, MUTEX_DRIVER, NULL);
	snprintf(name, KSTAT_STRLEN, "test%d-cv", dsp->instance);
	cv_init(test_cv, name, CV_DRIVER, NULL);

	BNXEF_AUTO_DEBUG("%s%d:Test: Mutex and Condition variable alloced",
		BNXEF_DRIVER_NAME, dsp->instance);

	task1_paramp = kmem_cache_alloc(dsp->tq_params_cache, KM_SLEEP);
	ASSERT(task1_paramp != NULL);
	task2_paramp = kmem_cache_alloc(dsp->tq_params_cache, KM_SLEEP);
	ASSERT(task2_paramp != NULL);
	BNXEF_AUTO_DEBUG("%s%d: Task Params structure alloced for 2 tasks",
		BNXEF_DRIVER_NAME, dsp->instance);

	portp = kmem_cache_alloc(dsp->port_cache, KM_SLEEP);
	ASSERT(portp != NULL);

	portp->id = 0x10001;
	portp->vlan_id = 0x768;
	portp->mac_addr[0] = 0x1;
	portp->mac_addr[1] = 0xe0;
	portp->mac_addr[1] = 0xd0;
	portp->mac_addr[3] = 0xCC;
	portp->mac_addr[4] = 0x11;
	portp->mac_addr[5] = 0x55;
	portp->flags = BNXEF_FC_PORT_ID_ACQUIRED | BNXEF_FC_PORT_INITIATOR |
			BNXEF_FC_PORT_SOL_BOUND;
	portp->statep = dsp;

	ret = bnxef_port_list_add(dsp, portp);
	ASSERT(ret == BNXEF_SUCCESS);


	task1_paramp->portp = portp;
	task1_paramp->dsp = dsp;
	task1_paramp->sessp = NULL;
	task1_paramp->reserved1 = (uint64_t)test_mutex;
	task1_paramp->reserved2 = (uint64_t)test_cv;
	ret = ddi_taskq_dispatch(dsp->tq, bnxef_test_alloc_session,
		(void *) task1_paramp, DDI_SLEEP);
	if (ret == DDI_FAILURE)  {
		cmn_err(CE_WARN, "%s%d Unable to Schedule in task Q\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}

	BNXEF_AUTO_DEBUG("%s%d: First Task dispatched",
		BNXEF_DRIVER_NAME, dsp->instance);
	mutex_enter(test_mutex);
	cv_wait(test_cv, test_mutex);
	mutex_exit(test_mutex);
	BNXEF_AUTO_DEBUG("%s%d: Second Task wake me up to exit, exiting...",
			BNXEF_DRIVER_NAME, dsp->instance);

	kmem_cache_free(dsp->tq_params_cache, task1_paramp);
	kmem_cache_free(dsp->tq_params_cache, task2_paramp);
	kmem_cache_free(dsp->port_cache, portp);
	mutex_destroy(test_mutex);
	cv_destroy(test_cv);
	kmem_free(test_mutex, sizeof (kmutex_t));
	kmem_free(test_cv, sizeof (kcondvar_t));
}

#endif
