/*
 * The information contained in this file is confidential and proprietary to
 * Broadcom Corporation.  No part of this file may be reproduced or
 * distributed, in any form or by any means for any purpose, without the
 * express written permission of Broadcom Corporation.
 *
 * (c) COPYRIGHT 2010-2012 Broadcom Corporation, ALL RIGHTS RESERVED.
 */

#pragma ident "(C) 2010-2012 Broadcom Corporation"
#pragma ident "$File$$Revision$$Change$$DateTime$"

#include <sys/conf.h>
#include <sys/ddi.h>
#include <sys/stat.h>
#include <sys/pci.h>
#include <sys/sunddi.h>
#include <sys/modctl.h>
#include <sys/cmn_err.h>
#include <sys/file.h>
#include <sys/cred.h>
#include <sys/byteorder.h>
#include <sys/atomic.h>
#include <sys/scsi/scsi.h>
#include <sys/modhash.h>
#include <sys/sunldi.h>
#include <sys/kstat.h>
#include <sys/kmem.h>
#include <sys/ethernet.h>
#include <sys/stream.h>
#include <sys/sunldi.h>
/*
 * leadville header files
 */
#include <sys/fibre-channel/fc_types.h>
#include <sys/fibre-channel/impl/fc_fcaif.h>
#include <bnxe_binding.h>
#include <bnxef_tq_param.h>
#include <bnxef_fcf_info.h>
#include <bnxef_hsi.h>
#include <bnxef_fcoe_task.h>
#include <bnxef_fcoe_session.h>
#include <bnxef_state.h>
#include <bnxef_fip.h>
#include <bnxef_fcoe.h>
#include <bnxef_debug.h>

/*ARGSUSED*/
int
bnxef_tq_param_cache_constructor(void *bufp, void *args, int kmflags)
{

	NOTE(ARGUNUSED(args))
	NOTE(ARGUNUSED(kmflags))

	bzero((uint8_t *)bufp, sizeof (bnxef_tq_params_t));

	return (0);
}

/*
 * Session Cache destructor
 */
/*ARGSUSED*/
void
bnxef_tq_param_cache_destructor(void *bufp, void *args)
{

	_NOTE(ARGUNUSED(bufp))
	_NOTE(ARGUNUSED(args))
}


/*
 * This creates the cache for use at attach time.
 */
int
bnxef_tq_param_cache_create(bnxef_driver_state_t *dsp)
{
	char  buf[KSTAT_STRLEN];

	ASSERT(dsp != NULL);

	(void) snprintf(buf, KSTAT_STRLEN, "tqparams%d_cache", dsp->instance);
	dsp->tq_params_cache = kmem_cache_create(buf,
		sizeof (bnxef_tq_params_t),
		8, bnxef_tq_param_cache_constructor,
		bnxef_tq_param_cache_destructor, NULL,
		dsp, NULL,  0);

	if (dsp->tq_params_cache == NULL) {
		cmn_err(CE_PANIC, "%s%d Unable to allocate tq params cache\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (DDI_FAILURE);
	}

	return (DDI_SUCCESS);
}


/*
 * This destroys the cache at detach time.
 */
int
bnxef_tq_param_cache_destroy(bnxef_driver_state_t *dsp)
{
	ASSERT(dsp != NULL);

	kmem_cache_destroy(dsp->tq_params_cache);

	return (DDI_SUCCESS);
}
