
/*
 * The information contained in this file is confidential and proprietary to
 * Broadcom Corporation.  No part of this file may be reproduced or
 * distributed, in any form or by any means for any purpose, without the
 * express written permission of Broadcom Corporation.
 *
 * (c) COPYRIGHT 2010-2012 Broadcom Corporation, ALL RIGHTS RESERVED.
 */

#pragma ident "(C) 2010-2012 Broadcom Corporation"
#pragma ident " $File$$Revision$$Change$$DateTime$"

#ifndef __BNXEF_TQ_PARAM_H__
#define	__BNXEF_TQ_PARAM_H__

#include <sys/types.h>
#include <sys/conf.h>
#include <sys/stream.h>
#include <sys/stropts.h>
#include <sys/errno.h>
#include <sys/cred.h>
#include <sys/poll.h>
#include <sys/modctl.h>
#include <sys/stat.h>
#include <sys/ddi.h>
#include <sys/sunddi.h>
#include <sys/ddifm.h>
#include <sys/fm/protocol.h>
#include <sys/fm/util.h>
#include <sys/fm/io/ddi.h>
#include <sys/pattr.h>
#include <sys/sysmacros.h>
#include <sys/strsun.h>
#include <sys/ksynch.h>
#include <sys/kstat.h>
#include <sys/strsubr.h>
#include <sys/ksynch.h>
#include <sys/ethernet.h>


typedef struct _bnxef_tq_param_ {
	uint32_t		type;
	void			*dsp;
	void			*portp;
	void			*framep;
	uint32_t		frame_length;
	mblk_t			*mp;
	void			*taskp;
	void			*sessp;
	void			*fcp;
	uint32_t		flags;

	uint64_t		reserved1;
	uint64_t		reserved2;
	uint64_t		reserved3;
	uint64_t		reserved4;
} bnxef_tq_params_t;

/*
 * The following are the various types of TQ calls made.
 *
 * Each type will have its own set of parameters defined. Not all of them
 * need to be set for certain type of handling. There are 4 reserved slots
 * provided which could hold type specific information which does not fit in
 * generic scheme of things.
 */

/* Type  FIP related will take values beween 0x100 - 0x200 */
#define	 BNXEF_FIP_TYPE_FCF_NO_RESOURCE		0x100
#define	 BNXEF_TQ_FIP_VLAN_REQ_NO_RESOURCE	0x101
#define	 BNXEF_TQ_FIP_VLAN_REQ_SEND_FAILURE	0x102
#define	 BNXEF_TQ_FIP_DISC_SOL_NO_RESOURCE	0x103
#define	 BNXEF_TQ_FIP_DISC_SOL_SEND_FAILURE	0x104


#define	 BNXEF_FIP_FCF_NO_RESOURCE

/* Type ELS handling related		0x200 - 0x300 */
#define	BNXEF_ELS_TIMEOUT_TYPE			0x200
#define	BNXEF_ELS_PLOGI_LS_ACC			0x201
#define	BNXEF_ELS_PRLI_LS_ACC			0x202
#define	BNXEF_ELS_LOGO_LS_ACC			0x203
#define	BNXEF_ELS_LS_ACC			0x204
#define	BNXEF_ELS_LS_RJT			0x205
#define	BNXEF_PLOGI_L2_RX_HANDLER		0x206
#define	BNXEF_LOGO_L2_RX_HANDLER		0x207
#define	BNXEF_ELS_SCR_LS_ACC			0x208
#define	BNXEF_PRLI_L2_RX_HANDLER		0x209
#define	BNXEF_UNSOL_ELS_L2_RX_HANDLER		0x20A
#define	BNXEF_RSCN_L2_RX_HANDLER		0x20B
#define	BNXEF_ELS_ADISC_LS_ACC			0x20C

/* Types for KCQE/CQE handlers		0x300 - 0x400 */
#define	BNXEF_SESSION_CQ_HANDLER		0x300

/* Type for Send RRQ and other Misc functions  0x400 - 0x500 */
#define	BNXEF_RRQ_SEND_REQ_TYPE			0x400
#define	BNXEF_ABTS_TIMEOUT_TYPE			0x401
#define	BNXEF_RRQ_TIMEOUT_TYPE			0x402

#define	BNXEF_REC_TIMEOUT_TYPE			0x403
#define	BNXEF_SRR_TIMEOUT_TYPE			0x404

/* THis will be for the SCSI and FCCT types */
#define	BNXEF_SCSI_TIMEOUT_TYPE			0x500
#define	BNXEF_CT_TIMEOUT_TYPE			0x501

#endif
